What's New in the Internet Explorer Administration Kit?

You can use the Internet Explorer Customization wizard and the IEAK Profile Manager, both included in the IEAK, to customize, deploy, and maintain Internet Explorer. For more information about the contents of the IEAK, see What's in the Microsoft Internet Explorer Administration Kit?.

The IEAK contains new features to help you streamline and manage Setup, sign custom files automatically with digital certificates, control whether users can customize their installation, and periodically provide updated information and files to users.

For more information about what's new in Internet Explorer 5, refer to the online Help installed with the product.

Here are some of the key new IEAK features:

  • Smaller setup footprint and modular features. Internet Explorer is smaller and more modular. You have more control over which features are installed and whether users can customize setup options.
  • Install only the features users need. You can install only the Internet Explorer 5 features that you know your users will need, but enable users to install new features as they need them with the Automatic Install feature. Through System Policies and Settings, you can control whether this feature is enabled.
  • View only the Internet Explorer Customization wizard screens that apply to you. In the Customization wizard, you can specify only the features that you want to customize. This is especially helpful if you want to specify only a few custom settings; you don't have to enter information for every page of the wizard.
  • Improved digital certificate support. If you have digital certificates, the IEAK wizard can sign custom files and programs automatically. Signing your files is necessary if you plan to distribute your files over the Internet or you don't want to specifically configure your intranet settings. Additionally, Internet service providers can specify a root certificate, so that all certificates in the hierarchy from that certification authority can be approved.
  • Batch text setup file. The IEAK enables you to customize setup, but you can further control setup by using a batch text file. You can include the batch file in your custom IEAK package.
  • The Connection Manager Administration Kit, which enables you to customize users' connection settings and appearance, is included and installed with the IEAK.
  • Internet Connection wizard integration. Internet service providers can integrate user sign-up with the Internet Connection wizard.
  • Enhanced Automatic Version Synchronization (AVS). When you download updated program versions, you don't need to download setup (.cab) files that haven't changed. This saves download time. The version number and disk space needed for each component are also displayed in the AVS interface.
  • Custom browser toolbar buttons. You can customize the browser toolbar by specifying custom buttons to run scripts or executable files.
  • Automatic Install. Internet Explorer enables users to install features that were not initially installed as they need them.
  • Update notification page. You can provide information about updated programs, files, or company news at intervals with a standard .htm page.
  • Installation into a custom directory. You are now prompted to choose an installation directory, so previous versions of the IEAK do not have to be overwritten. You can also determine whether or not users can change their installation location.


What's in the Microsoft Internet Explorer Administration Kit?

The Microsoft Internet Explorer Administration Kit (IEAK) contains programs and tools to help you customize and administer Internet Explorer.

You can:

  • Tailor the browser and other Internet components to fit your organization's or customers' needs. For example, you can customize the Links bar and Favorites list to promote your organization or provide helpful information.
  • Configure settings before you install, so you don't need to set options on each computer.
  • Customize Setup so that it requires less intervention and installs your custom programs.
  • If you're a corporate administrator, control which settings your employees can change, so you ensure that security, connection, and other important settings adhere to corporate standards.

Before using the IEAK, you should determine which settings you want to customize, prepare any graphics or custom files you'll need, and plan your distribution method. You'll also want to familiarize yourself with the programs and tools in the IEAK.

Internet Explorer Customization Wizard

The Customization wizard provides five stages of step-by-step screens that help you create customized Internet Explorer packages.

Internet Explorer Administration Kit Profile Manager

The Profile Manager enables you to change your users' settings and restrictions automatically, after Internet Explorer is already installed. For more information, see How to Use the IEAK Profile Manager.

Connection Manager Administration Kit

The Connection Manager Administration Kit (CMAK) is a wizard that guides you through customizing and configuring the Microsoft Connection Manager dialer. The CMAK creates a self-extracting executable (*.exe) file that installs itself on your users' computers. Then when a user clicks the custom icon to connect to the Internet, the custom dialer dialog box that you created appears. You can build a custom profile into your Internet Explorer packages.

IEAK Toolkit

The IEAK Toolkit contains helpful tools, programs, and sample files, such as the IExpress wizard, sample sign-up and addon files, artwork, and other tools. The Toolkit contents are located in the Toolkit folder of the IEAK program folder.

Internet Explorer Administration Kit Help

You can use the Index, Table of Contents, and full-text Search to find topics that address your needs. You can print a single topic or all topics at once; from the Table of Contents, you can print a "book" or a group of related topics.


Overview for Internet Content Providers

The Microsoft® Internet Explorer Administration Kit (IEAK) enables Internet content providers (ICPs) and Internet developers to create a custom browser for customers who already have Internet accounts.

As an ICP, you can also create a custom browser if you plan to use the Microsoft referral server as part of your custom package. This referral server, which provides information about Internet service providers in your area, is maintained by Microsoft. You can link to sign-up servers using this referral server.

You can use this kit to do the following:*

Customize the Setup program

  • Customize the appearance of the Setup program and configure types of installation (such as Standard and Minimal).
  • Point users to Internet or intranet servers to access the latest product versions with Windows Update Setup Wizard for Internet Explorer and Other Internet Tools.
  • Specify the language version of Internet Explorer to include in the installation package. You must run the Customization wizard once for each language version you want to create.

Customize the browser and channels

  • Set home, Search, and support pages.
  • Load links and folders into the Favorites list.
  • Change the title bar and logos of the browser.
  • Add a channel or channel category.

Use of the Internet Explorer logo

In accordance with the terms of the license agreement, you must display the Internet Explorer logo on your packaging and promotional goods, as well as on your Web site. Please visit the IEAK Web site for logo information, camera-ready art information, and examples.

*Note

  • Some features may not be available, depending on your license agreement. For more information, consult your contract.


ICP: Prepare to Run the Wizard

Internet
Content Provider

Prepare to Run the Wizard

  • Verify that the computer you will build your package from meets the hardware and software requirements.
  • Determine the encryption levels for your browser packages. For information about encryption of Internet Explorer, see the IEAK Web site.
  • Decide how you will be distributing your custom package (floppy disk, CD, or download). After the IEAK builds your package, you will need to move the files to the selected media. If you build a downloadable package, you must move the package to the appropriate place on your server.
  • If you decide to publish your browser package to an Internet server, you need to gather the path to the server and the URL from which the files will be downloaded. Then create a folder on the Web server, such as CIE, to publish all the files and folders associated with your custom browser. For example, you might create a server path of C:\Inetpub\Wwwroot\Cie. The corresponding URL would be http://computername/Cie.
  • Create a folder on your hard disk or network drive for the custom bitmaps you will use.

  • Make initial preparations for signing certain files, such as customization files created by the Internet Explorer Customization wizard and any custom components, if you distribute files over the Internet or an intranet that isn't especially configured. With browser security features, users are warned about or prevented from downloading files that aren't signed. Digital signatures identify the source of programs and guarantee that the code hasn't changed since it was signed.

    The Customization wizard can sign your files if you have a publishing certificate from a certification authority. To prepare certificates for use by the IEAK, you can import them onto your computer by using the Certificate Manager Import wizard. If you have received a file with an .spc extension, you can start the Certificate Manager Import wizard by double-clicking the .spc file in Windows Explorer or My Computer.

    You can also open the Certificate Manager from Internet Explorer. To do so, click the Tools menu, click Internet Options, click the Content tab, and then click Certificates. Click Import to start the Certificate Manager Import wizard, and then follow the steps in the wizard.

  • Create the following folder structure:
    Folder name | Description
    \CIE | Parent root for all files
    \CIE\Bitmaps | Custom bitmap files (graphic files needed for your custom browser)

    You can also create a custom browser package on a CD-ROM.

  • Copy the necessary files.

    You will have the option of customizing the following bitmaps in your browser. Place the bitmaps in the \CIE\Bitmaps folder before you run the Customization wizard.

    • One background bitmap for the CD-ROM Autorun screen (if you create a CD-ROM package)
    • Custom image for the CD-ROM buttons (if you create a CD-ROM package)
    • Two custom bitmaps for the Windows Update Setup wizard (if you want to customize its appearance): a 162-by-312 pixel bitmap for the left side of the first wizard screen and a 496-by-56 pixel bitmap for the top of the remaining wizard screens.
    • Custom toolbar bitmap (that displays as a background for the buttons and menus)
    • Two static 256-color bitmap images (one 38-by-38 pixels and the other 22-by-22 pixels), which will be used to brand the Internet Explorer browser with your logo
    • Two animated 256-color bitmap images (one 38-by-38 pixels and the other 22-by-22 pixels), which will be used to brand the Internet Explorer browser with your animated logo
  • Create animated bitmaps.

    Two tools are included with the IEAK to help you create customized animated bitmaps for your browser. One tool is used to stack bitmaps in the format described above, while the other tool previews the animation. For information about how to use these tools, see Animated Bitmap Tools.

  • Create a bitmap for the Autorun splash screen.

    If you plan to distribute your custom browser on a compact disc, you'll need to create bitmaps as part of the Autorun splash screen that is displayed after the user has inserted the compact disc. To create this bitmap, see Create a Bitmap for the Autorun Splash Screen.

  • Edit your graphic.

    The custom backgrounds and buttons are displayed only on computers with 256-color (8-bit) display capabilities. On computers with 16-color (4-bit) display capabilities, a standard low-resolution background bitmap and button set are displayed.

  • Gather the URLs for home, Search, and support pages.

    It's a good idea to create a support page that will appear if your users encounter problems when installing the browser. You will be prompted for the URLs for these pages when you run the Customization wizard.


ICP: Stage 1 Overview: Gathering Information

Internet
Content Provider

Stage 1 Overview: Gathering Information

In the first stage of the Internet Explorer Customization wizard, content providers/developers are prompted for the following information:

  • Your company name and 10-digit customization code. The customization code was included with other kit information you received from Microsoft.
  • Your role based on your license agreement. You must specify whether you are a content provider or developer, service provider, or corporate administrator.
  • The platform for which you will build your Internet Explorer package.
  • The file locations for creating your customized browser package.
  • The language of the browser package you are creating. You will need to run the Customization wizard for each international version you want to create.
  • The distribution media you plan to use, such as CD-ROM or multiple floppy disks.
  • The features you plan to customize. For example, if you are making only minor modifications to the browser, you won't need to view all of the IEAK wizard screens.

Note

  • The Customization wizard will not work correctly if Internet Explorer 5 is not installed. For more information, see Hardware and Software Requirements.


ICP: Stage 2 Overview: Specifying Setup Parameters

Internet
Content Provider

Stage 2 Overview: Specifying Setup Parameters

In this stage of the Internet Explorer Customization wizard, content providers are prompted for the following:

  • Download or update any Microsoft components with Automatic Version Synchronization. You must download Internet Explorer, but you can choose which other Internet Explorer components to download.

    Red, yellow, and green icons indicate whether you have downloaded the components and whether they are the latest versions.

  • Select any custom components you want to include.

    You can also specify up to 10 additional components, which can be self-extracting executable (.exe) files or compressed cabinet (.cab) files.


ICP: Stage 3 Overview: Customizing Setup

Internet
Content Provider

Stage 3 Overview: Customizing Setup

In this stage of the Internet Explorer Customization wizard, content providers can determine the way that Setup will appear and work:

  • Customize the CD-ROM Autorun screen, if you are creating a CD-ROM package.
  • Customize additional CD-ROM options, if you are creating a CD-ROM package.
  • Customize Windows Update Setup Wizard for Internet Explorer and Other Internet Tools. These settings affect how Setup appears to the user.
  • Specify up to 10 unique installation options and determine which components are included with each option.
  • Specify up to 10 sites from which your package will be downloaded.
  • Specify how users will receive updates to their components.
  • Specify that Setup detects whether a component exists and fine-tune which components users can customize.
  • Determine whether components you've downloaded, but haven't added to all packages, will be made available to users through the Automatic Install feature.
  • Specify certification authority information, if you have a digital certificate, so you can sign programs as you build your IEAK package.

Note

  • For more information about setup, see Windows Update Setup Wizard for Internet Explorer and Other Internet Tools.


ICP: Stage 4 Overview: Customizing the Browser

Internet
Content Provider

Stage 4 Overview: Customizing the Browser

In this stage of the Internet Explorer Customization wizard, content providers can customize the following:

  • The browser title bar and toolbar background bitmap. When you select a bitmap, make sure that the colors contrast with text.
  • Browser toolbar buttons. You can add custom toolbar buttons to run scripts and programs.
  • The Internet Explorer logo in the upper right corner of the browser.
  • Home, search, and online support pages for the browser.
  • Favorites, Favorites folders, and links for the Links bar.
  • Channels. You can add a channel or channel category, which is a folder of channels.
  • Welcome page, which appears when users start their browser for the first time.
  • A user agent string. A user agent is optional; it's a way to track the usage of your customized browser.


ICP: Stage 5 Overview: Customize Components

Internet
Content Provider

Stage 5 Overview: Customize Components

In this stage of the Internet Explorer Customization wizard, content providers can customize the following:

  • System policies and settings, to preset Internet options.


ICP: How to Distribute Your Browser

Internet
Content Provider

How to Distribute Your Browser

By default, the Internet Explorer Customization wizard creates files for downloading via the Internet or an intranet server. You can also create a custom browser package on CD-ROM or on multiple floppy disks.

Downloadable files

If you created the browser package on an Internet or intranet server, you need to set up your Web site so that users can download the files. For example, you might create a page where you post download information and a link to the install engine, IE5setup.exe.

If you created the browser package on your hard disk or network drive, you need to move the following items to an Internet or intranet server:

  • The folder that contains the language version you are posting and the folder contents. For example, the folder for the English version is named En, so you need to move the En folder and the files it contains. This folder will be in folders for your media type, such as Download, and platform, such as Win32.
  • The file named Ie5sites.dat. This file points to the download site (or sites) you specified when you ran the wizard.

For an illustration, see How to Set Up Files for Distribution.

Signing your custom packages

Web browsers have security features that help protect users from downloading harmful programs. Depending on the security level and the platform, the user may be prevented from or warned against downloading programs that aren't digitally signed.

The custom .cab files created by the Customization wizard for 32-bit versions of the browser should be signed, unless you preconfigure the Local intranet zone with a Low security setting. Any custom components you distribute with your browser package for these platforms should also be signed. If you have a digital certificate, the Customization wizard can sign these files automatically.

Unlike Internet Explorer 32-bit versions of the browser, 16-bit and UNIX versions of the browser do not perform digital signature verification. Programs or cabinet files for these operating systems do not need to be signed.

Notes

  • Signing the cabinet files and custom programs requires two steps: obtaining a digital certificate and specifying the certificate information when you run the Customization wizard. For more information, see Signing Your Programs.
  • You may need to change the case of file names on a UNIX FTP server. Below are the conventions you should use for specific UNIX operating systems.
    • Solaris UNIX
      If you are using a case-sensitive UNIX FTP server, you must make sure your cab folder is not capitalized, but the following file names are capitalized: BRANDING.CAB, CUSTOM.CIF, DESKTOP.CAB, IE.CIF, IECIF.CAB, and IE5SITES.DAT.
    • AT&T UNIX
      All file names must be capitalized on an AT&T UNIX FTP server.
    • IRIX UNIX (Silicon Graphics)
      The following file names must be capitalized: BRANDING.CAB, CUSTOM.CIF, DESKTOP.CAB, IE.CIF, IECIF.CAB, and IE5SITES.DAT. You should also use a text editor to modify the file names listed in IE.CIF to match the case of the files.

CD-ROM

If you distribute your custom browser for Windows 95 and Windows 98 users, a splash screen Autorun program appears when the user inserts the compact disc. This program offers users the choice of installing your custom browser or viewing more information. If the current version of Internet Explorer is already installed, the Autorun program detects it. The browser appears in what is known as Kiosk mode with the Start.htm file loaded.

Multiple floppy disks

You can also distribute your custom browser on multiple floppy 1.44 MB disks. In the destination directory you have specified, you will find a folder named \Mfloppy that contains subfolders named Disk1, Disk2, and so on. Copy the contents of these folders to your floppy disks.


Overview for Internet Service Providers

You can use this kit to do the following:*

Customize the Setup program

  • Customize the appearance of the Setup program and configure types of installation (such as Standard, Minimal, and Full).
  • Point users to Internet or intranet servers to access the latest product versions with Windows Update Setup Wizard for Internet Explorer and Other Internet Tools.
  • Roll out additional programs, custom scripts, or maintenance scripts with Internet Explorer.
  • Specify the language version of Internet Explorer to include in the installation package. You must run the Internet Explorer Customization wizard once for each language version you want to create.

Customize the browser and channels

  • Set home, Search, and support pages.
  • Load links and folders into the Favorites list.
  • Change the title bar and logos of the browser.
  • Add a channel or channel category.

Control how customers sign up for your service

  • Create a Sign-up Server Package: If a user has not already signed up with your service, you can provide a user with a fully active account by using a simple-to-implement, HTML-based sign-up server.
  • Create a Non-Server-Based Package: If a user already has an account with your service or another service, you can update the user's site with a custom browser by using a simplified process without a server. This type of package requires the user to specify some final settings at installation time.

Use of the Internet Explorer logo

In accordance with the terms of the license agreement, you must display the Internet Explorer logo on your packaging and promotional goods, as well as on your Web site. The artwork for your Web site, packaging, and promotional goods is located in the following folder \Ieak\Toolkit\Graphics\Samples\.

*Note

  • Some features may not be available, depending on your license agreement. For more information, consult your contract.


ISP: Prepare to Run the Wizard

Internet
Service Provider

Prepare to Run the Wizard

Verify that the computer you will build your package from meets the hardware and software requirements.

Determine the encryption levels for your browser packages. For information about encryption of Internet Explorer, see the IEAK Web site.

Choose a sign-up method

For more information, see Internet Sign-up with the Internet Connection Wizard, Setting Up a Sign-up Server for Full-Screen Kiosk Mode, and Creating a Serverless Sign-up Package.

Create the structure

  • Decide how you will be distributing your custom package (floppy disk, CD, or download). After the IEAK builds your package, you will need to move the files to the selected media. If you build a downloadable package, you must move the package to the appropriate place on your server.
  • If you decide to publish your browser package to an Internet server, you need to gather the path to the server and the URL from which the files will be downloaded. Then create a folder on the Web server, such as CIE, to publish all the files and folders associated with your custom browser. For example, you might create a server path of C:\Inetpub\Wwwroot\Cie.

  • Make initial preparations for signing certain files, such as customization files created by the Internet Explorer Customization wizard and any custom components, if you distribute files over the Internet or an intranet that isn't especially configured. With browser security features, users are warned about or prevented from downloading files that aren't signed. Digital signatures identify the source of programs and guarantee that the code hasn't changed since it was signed.

    The Customization wizard can sign your files if you have a publishing certificate from a certification authority. To prepare certificates for use by the IEAK, you can import them onto your computer by using the Certificate Manager Import wizard. If you have received a file with an .spc extension, you can start the Certificate Manager Import wizard by double-clicking the .spc file in Windows Explorer or My Computer.

    You can also open the Certificate Manager from Internet Explorer. To do so, click the Tools menu, click Internet Options, click the Content tab, and then click Certificates. Click Import to start the Certificate Manager Import wizard, and then follow the steps in the wizard.

  • Create the following folder structure:
    Folder name | Description
    \CIE | Parent root for all files
    \CIE\Custom | Custom files (such as Signup.isp, Signup.htm, Icwsign.htm, Install.ins, and Cancel.ins, depending on your sign-up method) for server-based sign-up
    \CIE\Dist | Destination directory for the files (this folder is needed only if you are creating your browser package on a hard disk or network drive)
    \CIE\Bitmaps | Custom bitmap files (graphic files needed for your custom browser)
  • Copy the necessary files.
    1. Select all the files contained in the following subfolders where the IEAK is installed: \Toolkit\Isp\Servless for serverless Internet sign-up, or \Toolkit\Isp\Server\ for server-based Internet sign-up.
    2. Copy these files to CIE\Custom.
  • Customize the sign-up file.

    Using the existing files on your desktop computer, you can start to customize your browser. If your customers will sign up for your services by using the browser in kiosk mode, then begin by updating the Signup.htm file, which is the first page users see. When users click Install on this page, setup information contained in the Install.ins file copies your custom settings to the users' browsers. If your customers will sign up for your services by using the Internet Connection wizard, see Internet Sign-up with the Internet Connection Wizard for more information.

    • To modify Signup.htm

    1. Open the Signup.htm file using an editor such as Microsoft Notepad or Microsoft FrontPage Express.
    2. Modify any information to fit your situation. For example, you might want to add technical support information. If you are using multiple sign-up servers, you can replace the links to .isp files.

    Note

    • If you want to prevent a default area code from being set, you can set a flag in the .isp file. The syntax for this flag is:
      Dial_As_Is=Yes

      You might want to set this flag if, for example, some users might be calling from an area code different than the default. If users aren't aware that the default area code differs from their current area code, they could unexpectedly incur long-distance charges.

  • Create animated bitmaps.

    Two tools are included with the IEAK to help you create customized animated bitmaps for your browser. One tool is used to stack bitmaps in the format described above, while the other tool previews the animation. For information about how to use these tools, see Animated Bitmap Tools.

  • Create a bitmap for the Autorun splash screen.

    If you plan to distribute your custom browser on a compact disc, you'll need to create bitmaps as part of the Autorun splash screen that is displayed after the user has inserted the compact disc. To create this bitmap, see Create a Bitmap for the Autorun Splash Screen.

  • Edit your graphic.

    The custom backgrounds and buttons are displayed only on computers with 256-color (8-bit) display capabilities. On computers with 16-color (4-bit) display capabilities, a standard low-resolution background bitmap and button set are displayed.

  • Gather the URLs for home, Search, and support pages.

    It's a good idea to create a support page that will appear if your users encounter problems when installing the browser. You will be prompted for the URLs for these pages when you run the Internet Explorer Customization wizard.


Creating a Serverless Sign-up Package

The serverless sign-up process enables users to install your custom Internet Explorer browser by compact disc, floppy disks, or files that can be downloaded. The installation process requires them to change only the user name, password, and connection information to set up an account and connect to the Internet by using your custom browser.

The serverless process enables ISPs to customize user settings without using a sign-up server. Because configuration information is distributed with the IEAK package, and therefore becomes local to the user's computer, the process is not as dynamic as server-based sign-up.

Or, you can allow the user to select each component from an installation menu. You cannot use the serverless sign-up method to customize the Internet Connection wizard.

Using a serverless sign-up process

Because the configuration file is distributed with the IEAK package, you cannot dynamically change user settings on the sign-up server.

The regular sign-up server gathers information about a user and then prepares a custom configuration file that is downloaded to the user's desktop computer. Software in the Internet Explorer installation package uses the configuration file to configure the desktop computer.

In the serverless version, the configuration file is created before the package is shipped, and it is included in the installation package. Therefore, the configuration file contains no user-specific configuration information. The configuration file, Install.ins, is invoked as a link from the local HTML page and configures most aspects of Internet Explorer. Because the configuration file is included in the installation package, it becomes local to the user's computer.

Creating multiple customized versions

If you are creating multiple customized versions of Internet Explorer and have many settings that stay the same across several or all versions, you can simplify the process. For more information, see Creating Multiple Versions of the Browser.


Creating a Server-Based Sign-up Package

The server-based sign-up process is a Web-browser-based mechanism that automates the task of adding new customers to your customer database. The sign-up process happens in three steps:

  1. The new customer connects to your sign-up server.
  2. An HTML/HTTP-based dialog box collects information from the user and adds the customer information to your customer database.
  3. Your server passes a configuration packet back to the customer's computer. The packet includes information about configuration and branding. It also includes the local phone number so the customer can access the Internet service provider.

    4. Note that if the user's security options are set to High, the sign-up server will not work because the necessary files will not be downloaded.

Passing a configuration packet back to the computer

After the customer has provided you with the information you need, you must return the following information to the customer:

  • Data for configuring Internet connections
  • Capabilities of the customer's account (including e-mail and newsreaders)
  • Branding information

This information must be passed back to the computer in an IEAK profile, or .ins, file. Your development team creates the first two types of data as part of the server, and the Internet Explorer Customization wizard prepares the .ins file data for branding. Some settings, such as Entry, User, Phone, Device, Server, and TCP/IP, cannot be specified in the wizard. You must assign these settings manually.

If you want to provide a variety of custom "private branded" versions of Internet Explorer (containing such items as custom logos, title bar, favorites, Search bar, home page, special links on the Links bar, and the location for online assistance) to different customer groups, you should maintain a variety of sets of branding information on the server for downloading in the .ins file. This means that all of the compact discs you send out will be the same, but they will be branded differently when the user signs up. This eliminates the potential for a large inventory problem.

Setting up a sign-up server

Your users can use the Internet Connection wizard or the Internet Explorer browser in full-screen kiosk mode to sign up for Internet Services. You need to set up your sign-up server to receive client requests. To learn more about how to create the sign-up packages and prepare your server, see Internet Sign-up for the Internet Connection Wizard and Setting Up a Sign-up Server for Full-Screen Kiosk Mode, depending on your sign-up method.


Internet Sign-up with the Internet Connection Wizard

If you're an ISP, you can specify the Internet Connection wizard (ICW) as the tool that customers use to sign up and configure their computers for Internet services. You can create server-based solutions that exchange information with the screens of the ICW. This feature is not available for the serverless sign-up method.

Customizable solutions for Internet sign-up are located in the IEAK Toolkit. The code is provided in Active Server Pages as well as Perl format, thus allowing you to build an ICW sign-up server for Web servers on different platforms with a minimum of effort. If you use the sample code, the only work you need to do is to integrate the sign-up server with your registration and billing systems.

In the Windows 98 Referral Server Program, the sign-up server code is similar for both IEAK sign-up and Referral Server registrations.

The following topics describe how to develop a sign-up process for the Internet Connection wizard. Although these topics describe a tested, comprehensive sign-up solution, which is recommended in most cases, you can customize the sign-up process to meet the needs of your organization.

Internet sign-up by using the Internet Connection wizard (ICW) is not available through single-disk branding on Internet Explorer 4.01 SP1 unless the user is running version 5 of the ICW. The ICW version that was released with Windows 98 was not enabled for use with the new ICW sign-up method with the IEAK. You can also create an Internet sign-up program through single-disk branding by using the kiosk sign-up method.

  • Coding and Accessibility Requirements for Internet Connection Wizard Sign-up
  • Working with the ICW Sample Sign-up Files
  • Creating Icwsign.htm, Error Pages, and the Finish Page for ICW Sign-up
  • Creating the Name and Address Screen for ICW Sign-up
  • Creating the Billing Options Screen for ICW Sign-up
  • Creating the Method of Payment Screen for ICW Sign-up
  • Creating the ISP Account Login/E-mail Screen for ICW Sign-up
  • Creating the ISP POP Selection Screen for ICW Sign-up
  • Creating the ISP Terms and Conditions Screen for ICW Sign-up
  • Using ICW Auto-Config for ISP Sign-up


ISP: Stage 1 Overview: Gathering Information

Internet
Service Provider

Stage 1 Overview: Gathering Information

In the first stage of the Internet Explorer Customization wizard, Internet Service Providers will be prompted for the following information:

  • Your company name and 10-digit customization code. The customization code was included with other kit information you received from Microsoft.
  • Your role based on your license agreement. You must specify whether you are a content provider or developer, service provider, or corporate administrator.
  • The platform for which you will build your Internet Explorer package.
  • The file locations for creating your customized browser package.
  • The language of the browser package you are creating. You will need to run the Customization wizard for each international version you want to create.
  • The distribution media you plan to use, such as CD-ROM or multiple floppy disks.
  • The features you plan to customize. For example, if you are making only minor modifications to the browser, you won't need to view all of the IEAK wizard screens.

Note

  • The Customization wizard will not work correctly if Internet Explorer 5 is not installed. For more information, see Hardware and Software Requirements.


ISP: Stage 2 Overview: Specifying Setup Parameters

Internet
Service Provider

Stage 2 Overview: Specifying Setup Parameters

In this stage of the Internet Explorer Customization wizard, Internet service providers are prompted for the following information:

  • Download or update any Microsoft components with Automatic Version Synchronization. You must download Internet Explorer, but you can choose which other Internet Explorer components to download.

    Red, yellow, and green icons indicate whether you have downloaded the components and whether they are the latest versions.

  • Select any custom components you want to include.

    You can also specify up to 10 additional components, which can be self-extracting executable (.exe) files or compressed cabinet (.cab) files.


ISP: Stage 3 Overview: Customizing Setup

Internet
Service Provider

Stage 3 Overview: Customizing Setup

In this stage of the Internet Explorer Customization wizard, Internet service providers can determine the way that Setup will appear and work:

  • Customize the CD-ROM Autorun screen, if you are creating a CD-ROM package.
  • Customize additional CD-ROM options if you are creating a CD-ROM package.
  • Customize Windows Update Setup Wizard for Internet Explorer and Other Internet Tools. These settings affect how Setup appears to the user.
  • Specify up to 10 unique installation options and determine which components are included with each option.
  • Specify up to 10 sites from which your package will be downloaded.
  • Specify how users will receive updates to their components.
  • Specify that Setup detects whether a component exists and fine-tune which components users can customize.
  • Determine whether components you've downloaded, but haven't added to all packages, will be made available to users through the Automatic Install feature.
  • Import a custom profile from or create a new profile with the Connection Manager Administration Kit.
  • Specify certification authority information, if you have a digital certificate, so you can sign programs as you build your IEAK package.

Note

  • For more information about setup, see Windows Update Setup Wizard for Internet Explorer and Other Internet Tools.


ISP: Stage 4 Overview: Customizing the Browser

Internet
Service Provider

Stage 4 Overview: Customizing the Browser

In this stage of the Internet Explorer Customization wizard, Internet service providers can customize the following:

  • The browser title bar and toolbar background bitmap. When you select a bitmap, make sure that the colors contrast with text.
  • Browser toolbar buttons. You can add custom toolbar buttons to run scripts and programs.
  • The Internet Explorer logo in the upper right corner of the browser.
  • Home, search, and online support pages for the browser.
  • Favorites, Favorites folders, and links for the Links bar.
  • Channels. You can add a channel or channel category, which is a folder of channels.
  • Welcome page, which appears when users start their browser for the first time.
  • A user agent string. A user agent is optional; it's a way to track the usage of your customized browser.
  • The user's connection settings by customizing the settings, importing your settings, or deleting the user's existing settings.
  • Proxy settings.
  • Root certificate.
  • Method of user sign-up.
  • Sign-up files. You can specify the path of the folder that contains the sign-up files, and specify whether you want to edit these files.
  • Parameters for the dial-up networking connection and Internet settings files that customers will use to connect to your Internet sign-up server.
  • Internet Connection wizard settings, if your users will use the wizard to sign up for your services.


ISP: Stage 5 Overview: Customize Components

Internet
Service Provider

Stage 5 Overview: Customize Components

In this stage of the Internet Explorer Customization wizard, Internet service providers can customize the following:

  • Your users' news and mail servers, if you're including Outlook Express in your customized package.
  • IMAP e-mail server settings for your users, if you are deploying Outlook Express and have an IMAP server.
  • Outlook Express custom content, by adding your own welcome e-mail message to welcome users and customizing the InfoPane that appears when users start the program.
  • Outlook Express custom settings, such as setting default mail and news clients, providing assistance to users who need to obtain additional mail accounts, and creating a default message rules file for your users.
  • Outlook Express user interface, such as whether the Folder bar, Folder list, MSN Messenger Contacts, Status bar, or Outlook bar are displayed.
  • Outlook Express compose settings, if you want to provide a corporate disclaimer or signature with Internet newsgroup or e-mail messages.
  • Windows Address Book Directories, if you want to provide Internet directory services to your users and customize Lightweight Directory Access Protocol (LDAP) servers.
  • System policies and settings, to preset Internet options.


ISP: How to Distribute Your Browser

Internet
Service Provider

How to Distribute Your Browser

By default, the Internet Explorer Customization wizard creates files for downloading via the Internet. You can also create a custom browser package on CD-ROM or on multiple floppy disks. Or you can distribute a single floppy disk that contains the files necessary to initiate the Setup and connection processes.

Downloadable files

Internet service providers can distribute a single file to users that contains the install engine, which will then download application components from an Internet server.

If you created the browser package on an Internet server, you need to set up your Web site so that users can download the files. For example, you might create a page where you post download information and a link to the install engine, IE5setup.exe.

If you created the browser package on your hard disk or network drive, you need to move the following items to your Internet server:

  • The folder that contains the language version you are posting and the folder contents. For example, the folder for the English version is named En, so you need to move the En folder and the files it contains. This folder will be in folders for your media type, such as Download, and platform, such as Win32.
  • The file named Ie5sites.dat. This file points to the download site (or sites) you specified when you ran the wizard.

    • For an illustration, see How to Set Up Files for Distribution.

Signing your custom packages

Web browsers have security features that help protect users from downloading harmful programs. Depending on the security level and the platform, the user may be prevented from or warned against downloading programs that aren't digitally signed.

The custom .cab files created by the Customization wizard for 32-bit versions of the browser should be signed, unless you preconfigure the Local intranet zone with a Low security setting. Any custom components you distribute with your browser package for these platforms should also be signed. If you have a digital certificate, the Customization wizard can sign these files automatically.

Unlike Internet Explorer 32-bit versions of the browser, 16-bit and UNIX versions of the browser do not perform digital signature verification. Programs or cabinet files for these operating systems do not need to be signed.

Notes

  • Signing the cabinet files and custom programs requires two steps: obtaining a digital certificate and specifying the certificate information when you run the Customization wizard. For more information, see Signing Your Programs.
  • You may need to change the case of file names on a UNIX FTP server. Below are the conventions you should use for specific UNIX operating systems.
    • Solaris UNIX
      If you are using a case-sensitive UNIX FTP server, you must make sure your cab folder is not capitalized, but the following file names are capitalized: BRANDING.CAB, CUSTOM.CIF, DESKTOP.CAB, IE.CIF, IECIF.CAB, and IE5SITES.DAT.
    • AT&T UNIX
      All file names must be capitalized on an AT&T UNIX FTP server.
    • IRIX UNIX (Silicon Graphics)
      The following file names must be capitalized: BRANDING.CAB, CUSTOM.CIF, DESKTOP.CAB, IE.CIF, IECIF.CAB, and IE5SITES.DAT. You should also use a text editor to modify the file names listed in IE.CIF to match the case of the files.

CD-ROM

If you distribute your custom browser for Windows 95 users, a splash screen Autorun program appears when the user inserts the compact disc. This program offers users the choice of installing your custom browser or viewing more information. If the current version of Internet Explorer is already installed, the Autorun program detects it. The browser appears in what is known as Kiosk mode with the Start.htm file loaded.

Single floppy disk

With the Windows Update Setup wizard, you can just post the files to the Internet. You can also provide users with a single disk that contains the files they need to initiate the Setup and connection processes. These files will be placed in the \Sfloppy\Win32\<language>\Disk1 subfolder of the folder in which your custom browser is created (for example \Sfloppy\Win32\En\Disk1). The rest of the files are downloaded from the Internet during the Setup process.

Multiple floppy disks

You can also distribute your custom browser on multiple floppy 1.44 MB disks. In the destination directory you have specified, you will find a folder named \Mfloppy that contains subfolders named Disk1, Disk2, and so on. Copy the contents of these folders to your floppy disks.


Overview for Corporate Administrators

The Microsoft Internet Explorer Administration Kit (IEAK) enables you to create a hands-free customized installation of Microsoft Internet Explorer 5 that fits the needs of your organization.

You can use this kit to do the following:*

Customize the Setup program

  • For Windows versions of Internet Explorer, customize the appearance of the Setup program and configure types of installation (such as Standard, Minimal, and Full).
  • Point users to Internet or intranet servers to download the latest product versions with Windows Update Setup Wizard for Internet Explorer and Other Internet Tools.
  • Roll out internal programs, custom scripts, or maintenance scripts when your users install Internet Explorer.
  • Specify the language version of Internet Explorer to include in the installation package. You must run the Customization wizard once for each language version you want to create.

Customize the browser and Windows Desktop Update

  • Specify the home, Search, and support pages you want to use.
  • Load links and folders into the Favorites list.
  • Change the title bar and logos of the browser.*
  • For 32-bit versions of the browser, configure and control the Windows Desktop Update, including Active Desktop items, desktop toolbars, Control Panel, and My Computer.
  • Control which channels appear on your corporate desktops.
  • Create a default desktop for your organization and determine which settings a user can change.

Manage security and ratings

  • Preinstall certificates on a user's computer and block users from downloading other certificates.
  • Preset your users' ratings configurations to adhere to your organization's policies.
  • Set a corporate standard disclaimer for any newsgroup postings created by users in your organization.
  • Use security zones to establish different levels of security and zones of trust.
  • Specify proxy settings for addresses and ports.

*Note

  • Some features may not be available, depending on your license agreement. For more information, consult your contract.


Corp. Admin.: Prepare to Run the Wizard

Corporate
Administrator

Prepare to Run the Wizard

Before running the wizard, you should gather the information you will need and create custom bitmaps.

  • Verify that the computer you will build your package from and the computers you will install your package on meet the hardware and software requirements.
  • Decide how you will be distributing your custom package (floppy disk, CD, or download). After the Internet Explorer Customization wizard builds your package, you will need to move the files to the selected media. If you build a downloadable package, you must move the package to the appropriate place on your server.
  • Determine the encryption levels for your browser packages. For information about encryption of Internet Explorer, see the IEAK Web site.

  • The UNIX functionality in the Customization wizard supports the more common UNIX method of installing the customized product on only a few servers. Users can then run Internet Explorer from this location rather than installing the product locally. This configuration is recommended for UNIX installations. Windows Update Setup Wizard for Internet Explorer and Other Internet Tools, which downloads .cab files, is not available on the UNIX platform.

    If the dial-up stack or Winsock.dll is not present on Windows 3.x computers, then you should create the CD-ROM customized browser package. You can then distribute this build on your network through a UNC (Universal Naming Convention) connection or through drive mapping.

  • If you decide to publish your browser package to an Internet server, you need to gather the path to the server and the URL from which the files will be downloaded. Then create a folder on the Web server, such as CIE, to publish all the files and folders associated with your custom browser. For example, you might create a server path of C:\Inetpub\Wwwroot\Cie. The corresponding URL would be http://computername/Cie.
  • Create a folder on your hard disk or network drive for the custom bitmaps you will use.

  • Make initial preparations for signing certain files, such as customization files created by the Internet Explorer Customization wizard and any custom components, if you distribute files over the Internet or an intranet that isn't especially configured. With browser security features, users are warned about or prevented from downloading files that aren't signed. Digital signatures identify the source of programs and guarantee that the code hasn't changed since it was signed.

    The Customization wizard can sign your files if you have a publishing certificate from a certification authority. To prepare certificates for use by the IEAK, you can import them onto your computer by using the Certificate Manager Import wizard. If you have received a file with an .spc extension, you can start the Certificate Manager Import wizard by double-clicking the .spc file in Windows Explorer or My Computer.

    You can also open the Certificate Manager from Internet Explorer. To do so, click the Tools menu, click Internet Options, click the Content tab, and then click Certificates. Click Import to start the Certificate Manager Import wizard, and then follow the steps in the wizard.

  • You should decide whether to configure the Windows Desktop Update for your organization.
  • Create the following folder structure:
    Folder name | Description
    \CIE | Parent root for all files
    \CIE\Bitmaps | Custom bitmap files (graphic files needed for your custom browser)

    • You can also create a custom browser package on a CD-ROM.

  • For the UNIX platform, prepare your add-on components. You should create a cabinet file that contains your add-ons and installation scripts. Then, specify the name of the cabinet file, the script name, and size information when you run the wizard. You can specify up to 10 components. For more information, see Preparing a UNIX component for installation.
  • Create animated bitmaps.

    Two tools are included with the IEAK to help you create customized animated bitmaps for your browser. One tool is used to stack bitmaps in the format described above, while the other tool previews the animation. For information about how to use these tools, see Animated Bitmap Tools.

  • Create a bitmap for the Autorun splash screen.

    If you plan to distribute your custom browser on a compact disc, you'll need to create bitmaps as part of the Autorun splash screen that is displayed after the user has inserted the compact disc. To create this bitmap, see Create a Bitmap for the Autorun Splash Screen.

  • Edit your graphic.

    The custom backgrounds and buttons are displayed only on computers with 256-color (8-bit) display capabilities. On computers with 16-color (4-bit) display capabilities, a standard low-resolution background bitmap and button set are displayed.

  • Gather the URLs for home, Search, and support pages.

    It's a good idea to create a support page that will appear if your users encounter problems when installing the browser. You will be prompted for the URLs for these pages when you run the Customization wizard.

  • Plan your security and Windows Desktop Update strategies.

    You can customize and control many user options, such as security and the Windows Desktop Update. You should plan your strategy before you run the Customization wizard.


Corp. Admin.: Stage 1 Overview: Gathering Information

Corporate
Administrator

Stage 1 Overview: Gathering Information

In this stage of the Internet Explorer Customization wizard, corporate administrators are prompted for the following information:

  • Your company name and 10-digit customization code. The customization code was included with other kit information you received from Microsoft.
  • Your role based on your license agreement. You must specify whether you are a content provider or developer, service provider, or corporate administrator.
  • The platform for which you will build your Internet Explorer package.
  • The file locations for creating your customized browser package.
  • The language of the browser package you are creating. You will need to run the Customization wizard for each international version you want to create.
  • The distribution media you plan to use, such as CD-ROM or multiple floppy disks.
  • The features you plan to customize. For example, if you are making only minor modifications to the browser, you won't need to view all of the IEAK wizard screens.

Note

  • The Customization wizard will not work correctly if Internet Explorer 5 is not installed. For more information, see Hardware and Software Requirements.


Corp. Admin.: Stage 2 Overview: Specifying Setup Parameters

Corporate
Administrator

Stage 2 Overview: Specifying Setup Parameters

In this stage of the Internet Explorer Customization wizard, corporate administrators are prompted for the following:

  • Download or update any Microsoft components with Automatic Version Synchronization. You must download Internet Explorer, but you can choose which other Internet Explorer components to download.

    Red, yellow, and green icons indicate whether you have downloaded the components and whether they are the latest versions.

  • Select any custom components you want to include.

    You can also specify up to 10 additional components, which can be self-extracting executable (.exe) files or compressed cabinet (.cab) files.

Note

  • The UNIX functionality in the IEAK supports the more common UNIX method of installing the customized product on only a few servers. Users can then run Internet Explorer from this location rather than installing the product locally. This configuration is recommended for UNIX installations. Internet Explorer 5 Setup, which downloads .cab files, is not available on the UNIX platform.


Corp. Admin.: Stage 3 Overview: Customizing Setup

Corporate
Administrator

Stage 3 Overview: Customizing Setup

In this stage of the Internet Explorer Customization wizard, corporate administrators can determine the way that Setup will appear and work:

  • Customize the CD-ROM Autorun screen if you are creating a CD-ROM package.
  • Customize additional CD-ROM options if you are creating a CD-ROM package.
  • Customize Windows Update Setup Wizard for Internet Explorer and Other Internet Tools. These settings affect how Setup appears to the user.
  • Determine whether you want to install the package "silently," with few or no prompts to the user.
  • Specify up to 10 unique installation options and determine which components are included with each option.
  • Specify up to 10 sites from which your package will be downloaded. You can specify up to 10 sites, unless you are a corporate administator performing a silent install.
  • Specify how users will receive updates to their components.
  • Specify where you want Internet Explorer to be installed on your users' computers and whether users can change the installation location.
  • Determine whether users can customize Setup, whether uninstall information is installed, whether Internet Explorer can be installed side-by-side with a previous version, and whether Internet Explorer is the default browser.
  • Specify that Setup detects whether a component exists and fine-tune which components users can customize.
  • Determine whether components you've downloaded, but haven't added to all packages, will be made available to users through the Automatic Install feature.
  • Import a custom profile from or create a new profile with the Connection Manager Administration Kit (CMAK). The CMAK is installed with the IEAK.
  • Specify whether you want to integrate Web browser functionality into your desktop and folders. This functionality is integrated into Windows 98.
  • Specify certification authority information, if you have a digital certificate, so you can sign programs as you build your IEAK package.

Notes

  • For more information about Setup, see Windows Update Setup Wizard for Internet Explorer and Other Internet Tools.
  • The UNIX functionality in the IEAK supports the more common UNIX method of installing the customized product on only a few servers. Users can then run Internet Explorer from this location rather than installing the product locally. This configuration is recommended for UNIX installations. Internet Explorer 5 Setup, which downloads .cab files, is not available on UNIX operating systems.

  • Unlike Internet Explorer 32-bit versions of the browser, 16-bit and UNIX versions of the browser do not perform digital signature verification. Programs or cabinet files for these operating systems do not need to be signed.


Corp. Admin.: Stage 4 Overview: Customizing the Browser

Corporate
Administrator

Stage 4 Overview: Customizing the Browser

In this stage of the Internet Explorer Customization wizard, corporate administrators can customize the following:

  • The browser title bar and toolbar background bitmap. When you select a bitmap, make sure that the colors contrast with text.
  • Browser toolbar buttons. You can add custom toolbar buttons to run scripts and programs.
  • The Internet Explorer logo in the upper right corner of the browser.
  • Home, search, and online support pages for the browser.
  • Favorites, Favorites folders, and links for the Links bar
  • Channels to enable users to receive content that's updated automatically.
  • Welcome page, which appears when users start their browser for the first time.
  • My Computer and Control Panel by specifying your own Mycomp.htt and Controlp.htt files, if you are also installing the Windows Desktop Update. You must have the Active Desktop installed on the build computer for this screen to be displayed.
  • A user agent string. A user agent is optional; it's a way to track the usage of your customized browser.
  • Automatic configuration. You can provide a path to files that automatically configure your browser.
  • The user's connection settings by customizing the settings, importing your settings, or deleting the user's existing settings.
  • Proxy settings.
  • Desktop toolbar settings. You can import the desktop toolbar settings from your own computer as the standard for your company. You must have the Active Desktop installed on the build computer for this screen to be displayed.
  • Active Desktop customization, if you are also installing the Windows Desktop Update. You must have the Active Desktop installed on the build computer for this screen to be displayed.
  • Settings for security certificates and Authenticode.
  • Settings for security zones and ratings.


Corp. Admin.: Stage 5 Overview: Customize Components

Corporate
Administrator

Stage 5 Overview: Customize Components

In this stage of the Internet Explorer Customization wizard, corporate administrators can customize the following:

  • Your users' news and mail servers, if you're including Outlook Express in your customized package.
  • UNIX mapping to associate extensions with files or programs for UNIX browser packages.
  • UNIX programs to specify the programs that will run when the user performs mail, news, HTML editing, and print tasks.
  • IMAP e-mail server settings for your users, if you are deploying Outlook Express and have an IMAP server.
  • Outlook Express custom content, by adding your own welcome e-mail message to welcome users and customizing the InfoPane that appears when users start the program.
  • Outlook Express custom settings, such as setting default mail and news clients, providing assistance to users who need to obtain additional mail accounts, and creating a default message rules file for your users.
  • Outlook Express user interface, such as whether the Folder bar, Folder list, MSN Messenger Contacts, Status bar, or Outlook bar are displayed.
  • Outlook Express compose settings, if you want to provide a corporate disclaimer or signature with Internet newsgroup or e-mail messages.
  • Windows Address Book Directories, if you want to provide Internet directory services to your users and customize Lightweight Directory Access Protocol (LDAP) servers.
  • System policies and settings, to preset or control settings, including options for the browser, e-mail, security, and the desktop.


Corp. Admin.: How to Distribute Your Browser

Corporate
Administrator

How to Distribute Your Browser

By default, the Internet Explorer Customization wizard creates files for downloading via the Internet or an intranet. You can also create a custom browser package on CD-ROM or on multiple floppy disks.

For UNIX, you will install the package from one self-contained file. Your users will run it from the location you specify.

The UNIX functionality supports the more common UNIX method of installing the customized product on only a few servers. Users can then run Internet Explorer from this location rather than installing the product locally. This configuration is recommended for UNIX installations. Windows Update Setup Wizard for Internet Explorer and Other Internet Tools, which downloads .cab files, is not available on UNIX operating systems.

Downloadable files

If you created the browser package on an Internet or intranet server, you need to set up your Web site so that users can download the files. For example, you might create a page where you post download information and a link to the install engine, IE5setup.exe.

If you created the browser package on your hard disk or network drive, you need to move the following items to your Internet or intranet server:

  • The folder that contains the language version you are posting and the folder contents. For example, the folder for the English version is named En, so you need to move the En folder and the files it contains. This folder will be in folders for your media type, such as Download, and platform, such as Win32.
  • The file named Ie5sites.dat. This file points to the download site (or sites) you specified when you ran the wizard.

Your users install the browser by clicking IE5setup.exe. This file is located in the folder for your language and platform version within the \Download folder, such as \Download\Win32\En, \Download\Win16\En, or \Download\Unix\En.

For an illustration, see How to Set Up Files for Distribution.

Signing your custom packages

Web browsers have security features that help protect users from downloading harmful programs. Depending on the security level and the operating system, the user may be prevented from or warned against downloading programs that aren't digitally signed.

The custom .cab files created by the Customization wizard for 32-bit versions of the browser should be signed, unless you preconfigure the Local intranet zone with a Low security setting. Any custom components you distribute with your browser package for these operating systems should also be signed. If you have a digital certificate, the Customization wizard can sign these files automatically.

Unlike Internet Explorer 32-bit versions of the browser, 16-bit and UNIX versions of the browser do not perform digital signature verification. Programs or cabinet files for these operating systems do not need to be signed.

Notes

  • Signing the cabinet files and custom programs requires two steps: obtaining a digital certificate and specifying the certificate information when you run the Customization wizard. For more information, see Signing Your Programs.
  • You may need to change the case of file names on a UNIX FTP server. Below are the conventions you should use for specific UNIX operating systems.
    • Solaris UNIX
      If you are using a case-sensitive UNIX FTP server, you must make sure your cab folder is not capitalized, but the following file names are capitalized: BRANDING.CAB, CUSTOM.CIF, DESKTOP.CAB, IE.CIF, IECIF.CAB, and IE5SITES.DAT.
    • AT&T UNIX
      All file names must be capitalized on an AT&T UNIX FTP server.
    • IRIX UNIX (Silicon Graphics)
      The following file names must be capitalized: BRANDING.CAB, CUSTOM.CIF, DESKTOP.CAB, IE.CIF, IECIF.CAB, and IE5SITES.DAT. You should also use a text editor to modify the file names listed in IE.CIF to match the case of the files.

CD-ROM

If you distribute your custom browser for Windows 95 or Windows 98 users, a splash screen Autorun program appears when the user inserts the compact disc. This program offers users the choice of installing your custom browser or viewing more information. If the current version of Internet Explorer is already installed, the Autorun program detects it. The browser appears in what is known as Kiosk mode with the Start.htm file loaded.

With the Windows Update Setup wizard, you can post all your files to an intranet or Internet server. You can also create CD-ROM versions for users who do not initially have Internet access.

Multiple floppy disks

You can also distribute your custom browser on multiple floppy 1.44 MB disks for users who do not initially have Internet access. In the destination directory you have specified, you will find a folder named \Mfloppy that contains subfolders named Disk1, Disk2, and so on. Copy the contents of these folders to your floppy disks.


Managing User Settings

After the user options are set and the browser is distributed, administrators can still manage these options. By storing a master .ins file on the server and downloading it with each logon, administrators can adjust user option settings on an ongoing basis. By tieing into existing logon scripts, administrators can manage and regularly update user settings from a centralized server.

Using the IEAK Profile Manager, you can easily administer configuration files. The Profile Manager lets you open any .ins file and make changes to settings, such as proxy, home page, Search bar, and Lightweight Directory Access Protocol (LDAP) information.

After installation, administrators can remotely manage all allowed publisher (and site) certificates by adding certificates to or removing certificates from the allowed list.


How to Use the IEAK Profile Manager

If you're a corporate administrator, the IEAK Profile Manager can help you maintain your versions of Internet Explorer by providing quick and easy access to system settings. You can use the Profile Manager to create, save, and load .ins files. You can configure user options from a central location.

For an illustration of this process, see How Automatic Configuration Works.

You can use an automatic configuration URL to automatically point your users' browsers to the IEAK Profile. You can either specify the .ins file, or create and specify an Active Server Page (.asp) file that generates an .ins file automatically.

You can also specify script files in .js, .jvs, or .pac format that enable you to configure and maintain advanced proxy settings. If you specify URLs for both automatic configuration and automatic proxy (auto-proxy), the auto-proxy URL will be incorporated into the .ins file. The correct form for the URL is http://share/test.ins.

In the Internet Explorer Customization wizard, you are prompted for the automatic configuration and auto-proxy script URLs.

To enable automatic configuration

  1. Select the Enable automatic configuration check box.
  2. In the Auto-configure URL (.ins) file box, type the URL for the .ins or .asp file you want.
  3. In the Auto-proxy URL (.js) or (.pac) file box, type the URL for the auto-proxy script.

To run the IEAK Profile Manager

  1. On the Start menu, point to Programs.
  2. Point to Microsoft IEAK, and then click IEAK Profile Manager.
  3. On the File menu, click Open, and then open the .ins file from your customized browser package. By default, the .ins file is named Install.ins.

    To work with policy files for a different operating system, click the option you want on the Platform menu.

  4. To modify settings, click Wizard Settings or System Policies and Restrictions to display the categories of settings.
  5. On the left, click each category you want to change, and then on the right, change the options you want.
  6. On the File menu, click Save.

    Type the path to your .ins file, the URL to your .cab files, and the names of your .cab files if they differ from the defaults provided.

Notes

  • Because 16-bit and UNIX versions of the browser do not support certificates, automatic configuration files are not signed. Therefore, you should make sure that your automatic configuration Web site has restricted access.
  • The default location for saving the .ins file is <build directory>\Ins\operating system\language (for example, Build1\Ins\Win32\En\). If you want to move the file, you must make sure to specify the correct path to your .cab files, put the Ie5sites.dat file in this location, and make sure the download sites you specified are correct.
  • If the version number of the .ins file doesn't change, new .cab files will not be downloaded. The version number consists of the date the .ins file was modified and the number of times the file has been revised.
  • Automatic configuration is not available for Outlook Express on the Windows 3.x operating system.
  • If you are familiar with .adm files, you can use the policies and restrictions you have set up in your own .adm files by clicking Policy, and then clicking Import.

  • If you are using automatic configuration, and you are supporting both Internet Explorer 5 and Internet Explorer 4.0 with the same automatic configuration file, some settings that differ between the versions will not be configured on Internet Explorer 4.0.


IEAK References

The IEAK reference section in the Table of Contents contains information about resources and technologies for the IEAK and Internet Explorer. Key features covered are security, support, the IEAK Toolkit, and add-on components.

To check for the latest resources and updates to technology, visit the following Web sites:

  • The IEAK Web site
  • Microsoft Security Advisor Web site
  • Microsoft Site Builder Network Workshop


Getting Technical Support

If you have a simple question and need an answer fast

Quickly find answers yourself online For easy access to a list of support resources, such as documentation sets, newsgroups and Frequently Asked Questions (FAQs), visit the IEAK Web site at http://ieak.microsoft.com/support.asp.

If you've already tried the FAQs, use Support Online to easily search the Microsoft Knowledge Base and other technical resources for fast, accurate answers. You can also customize the site to control your search. To begin your search, go to http://support.microsoft.com/support.

If your question isn't urgent

Send e-mail to a Microsoft Product Support Engineer Convenient for use anytime day or night, submit a question using one of the following options:

Standard No-Charge Support on the Web Microsoft currently offers unlimited incidents of no-charge support for usability issues for the IEAK creation wizard only. Usability issues are general questions about the features and functionality of the wizard, as well as dialog box messaging within the wizard. Submit your no-charge usability incident via the web forms available at http://ieak.microsoft.com/support.asp.

Please note that since usability submissions from customers often become FAQs, you may wish to try searching the FAQ list at http://ieak.microsoft.com/support.asp to save time.

Pay-Per-Incident Web Response For more advanced IEAK issues, such as troubleshooting deployment, interoperability issues, and features other than the creation wizard, Pay-Per-Incident support is available. Web Response support is ideal for very complex questions or issues requiring attached files.

For a fee of $195 US, submit a question at http://support.microsoft.com/support/webresponse.asp and receive a response within one business day.

If your question is urgent and more complex

Telephone a Microsoft Product Support Engineer For cases you consider urgent or high priority, Microsoft recommends working with a support engineer on the phone.

Pay-Per-Incident Support Telephone support for this product is available on a Pay-Per-Incident basis for a fee of $195 US. In the U.S. and Canada call (800) 936-5900, 24 hours a day, seven days a week, including holidays Support fees will be billed to your VISA, MasterCard, or American Express card.

For additional support needs

If you need text telephone (TTY/TDD) Available Monday - Friday, excluding holidays. In the United States, call (425) 635-4948, 6:00 A.M. - 6:00 P.M. Pacific time. In Canada, call (905) 568-9641, 8:00 A.M. - 8:00 P.M. eastern time.

If you need support services for a business Priority Annual, Priority Plus, and Premier provide a selection of support packages geared for businesses. To learn which account meets your needs, go to http://www.microsoft.com/support. Or call (800) 936-3500 for information on accounts for small- to medium-sized businesses and (800) 936-3200 for large, enterprise businesses.

If you need on-site, multivendor, or proprietary product support Microsoft Certified Solution Providers (MCSPs) and Authorized Support Centers (ASCs) specialize in providing support packages for hardware, network, and software products from both Microsoft and other vendors. For more information about MCSPs, call (800) 765-7768 or visit http://www.microsoft.com/mcsp. For more information about ASCs, contact your Microsoft account representative, or visit http://www.microsoft.com/support.

If you need support outside the United States and Canada

The services and prices listed here are available in the United States and Canada only. Support outside the United States and Canada may vary. Microsoft's support services are subject to Microsoft's then-current prices, terms, and conditions, which are subject to change without notice. Microsoft Product Support Services Worldwide If you are outside the United States or Canada and have a question about a Microsoft product, first:

  • Check the information in Help or product documentation.
  • Check the readme files that come with your product disks. These files provide general information that became available shortly before the product was released.
  • Go to Support Online at http://support.microsoft.com/support/.

If you cannot find a solution, you can receive information on how to obtain technical support by contacting the Microsoft subsidiary office in your area.

Important Phone numbers for Microsoft Subsidiaries are subject to change. For the most recent listing, please see the options and phone number section on the Support Online web site at http://support.microsoft.com/support. If there is no Microsoft subsidiary office in your country, please contact the establishment from which you obtained your Microsoft product.

Argentina
Microsoft de Argentina S.A.
Customer Service: (54) (1) 316-4600
Fax: (54) (1) 316-1922
Technical Support Phone: (54) (1) 316-4664

Armenia
See Russia

Australia
Microsoft Pty. Ltd.
Phone: Products and Services 13 20 58
Fax: (61) (02)9870-2285
Sales Information Centre: (61) (02) 9870-2100
Internet://www.microsoft.com.au/Australia
Technical Support:
Phone: (61) (02) 9870-2131
Fax: (61) (02) 9805 0519

Austria
Microsoft Ges.m.b.H.
Phone: (+43) 1 610 64 -0
Fax: (+43) 1 610 64 -200
Information: 0660-6520
Prices, updates, etc.: 0660-6520
Standard Support:
Installation and Handling: 01 50222-2255
General information about Support Network in Central Europe:
FAX: 01805-251191

Azerbaijan
See Russia

Belgium
Microsoft NV
Phone: +32-2-730 39 11
Fax: +32-2-726 96 09
Microsoft Support Network Info. Center: 0800 18307
TechNet Subscription: +353 1 703 8738
MSDN Subscription: +353 1 708 8690
Microsoft Information Center: +32-2-481 52 52
Bulletin Board: +32-2-726 85 45 (14400/1200/2400/9600 bd, 8N1, ANSI)
Technical Support:
+32-2-513 32 74 (Dutch speaking)
+32-2-502 34 32 (English speaking)
+32-2-513 22 68 (French speaking)
Internet: www.microsoft.com/benelux/support

Belorussia
See Russia

Bolivia
See Uruguay

Brazil
Microsoft Informatica Ltda.
Phone: (55) (11) 5514 –7100
Fax: (55) (11) 5514 - 7106/5514-7107
Technical Support:
Phone: (55) (11) 5506-8087
Fax: (55) (11) 5506-7621
Automatic Fax: (55) (11) 5506-8506
Technical Support Bulletin Board Service: (55) (11) 5506-1234
Customer Support: (55) (11) 822-5764
Customer Services Fax: (55) (11) 822-6227

Canada
Microsoft Canada Co.
Head Office Phone: 1 (905) 568-0434
Customer Information Centre: 1 (800) 563-9048
Technical Support:
Desktop Systems including Microsoft Windows 95: (905) 568-4494
Microsoft Office and Office Components: (905) 568-2294
Other Standard Technical Support: (905) 568-3503
Priority Support Information: (800) 668-7975
Text Telephone (TTY/TDD) (905) 568-9641
Technical Support Bulletin Board Service: (905) 507-3022

Caribbean
Microsoft Caribbean, Inc.
Phone: (809) 273-3600
Fax: (809) 273-3636
Technical Support: (408) 953 8086
Support E-Mail: mscarsup@microsoft.com
Customer Service: (800) 297 5982 for area codes 787 and 809 only
Customer Service E-mail: msccatus@microsoft.com

Central America
Technical Support: (506) 298 2020
Support E-Mail: mscasup@microsoft.com
Customer Service: (506) 298 2000
Customer Service E-mail: msccatus@microsoft.com

Chile
Microsoft Chile S.A.
Phone: 56-2-330-6000
Fax: 56-2-330-6190
Customer Service: 56-2-800-330600
Personal Operating System and Applications:
Phone: 56-2-330-6222
Fax: 56-2-341-1439

Colombia
Microsoft Colombia
Phone: (571) 618 2245
Fax: (571) 618 2269
Technical Support:
Línea de Respuesta Microsoft
Phone: (571) 5230022
Fax: (571) 5231220
Voice Mail: (571) 5034216

Croatia
Microsoft Hrvatska d.o.o.
Phone: (+385) (1) 304 555
Fax: (+385) (1) 335 051
Technical Support: (Please contact the subsidiary.)

Czech Republic
Microsoft s.r.o.
Phone (+420) (2) 611 97 111
Fax: (+420) (2) 611 97 100
Technical Support: (+420) (2) 2150 3222

Denmark
Microsoft Denmark
Phone: (45) 44 89 01 00
Fax: (45) 44 68 55 10
Technical Support:
Phone: (45) 44 89 01 11
Microsoft Sales Support: (45) 44 89 01 90
Microsoft FastTips: (45) 44 89 01 44
(Document 303030 in FastTips contains detailed instructions)
Microsoft MSDL (BBS): (45) 44 66 90 46

Dominican Republic
See Central America

Dubai
Microsoft Middle East
Phone: (971) 4 513 888
Fax: (971) 4 527 444
Technical Support:
Personal Operating Systems and Desktop Applications ONLY:
Phone: (971) (4) 524 488
Fax: (971) (4) 524 495
email: mts@emirates.net.ae
Priority Support Information: (971) (4) 555 752
Customer Service Center:
(Version upgrade / TechNet and MSDN subscription)
Phone: (971) (4) 655 082
Fax: (971) (4) 655 097

Ecuador
Corporation Microsoft del Ecuador S.A.
Phone: (593) 2 460-447, (593) (2) 460-451
Customer Service: (593) (2) 460-453, (593) (2) 460-458
Technical Support: (593) (2) 463-094

Egypt
Microsoft Egypt
Phone: +202 594 2445
Fax: +202 594 2194
Technical Support:
Personal Operating Systems and Desktop Applications ONLY:
Phone: +202 261 3991 / 6
Fax: +202 403 2718

England
See United Kingdom

Estonia
See Germany
Technical Support: (+372) 650 49 99

Finland
Microsoft OY
Phone: +358-(0)9-525 501
Fax: +358-(0)9-878 8770
Technical Support:
Phone: +358-(0)9-525 502 5026
Standard +358 (0) 9-525-502-500
Priority: +358 (0) 9-525-502-20
Premier: +358 (0) 9-525-502-03
Microsoft MSDL: +358-(0)9-878 77 99
(Information in Swedish and English): +358 (0) 9-455-03-66
Microsoft FastTips: +358-(0)9-525 502 550

France
Microsoft France
Phone: (33) 01 69-86-46-46
Fax: (33) 01 64-46-06-60
Telex: MSPARIS 604322
Technical Support:
Phone: (33) 01-69-86-10-20
Fax: (33) (01) 69-28-00-28

French Polynesia
See France

Georgia
See Russia

Germany
Microsoft GmbH
Phone: 089/3176-0
Fax: 089/3176-1000
Telex: (17) 89/83 28 MS GMBH D
Information: 089/3176 1199
Prices, updates, etc.: 08105-25-1199
Internet: www.microsoft.com/germany
Standard Support:
Installation and Handling: 01805/67 22 55
General information about Microsoft support in Central Europe:
Fax: 1805-25-1191

Greece
Microsoft Hellas, S.A.
Phone: (30)(1) 6806-775 through (30)(1) 6806-779
Fax: (30)(1) 6806-780
Technical Support:
Phone: (30) (1) 9247-030
Fax: (30) (1) 9215-363

Hong Kong SAR, PRC
Microsoft Hong Kong SAR, PRC Limited
Fax: (852)2560-2217
Product support Faxback Service: (852)2535-9293
Microsoft Club Hotline: (852)28044277
Technical Support: (852) 2804-4222

Hungary
Microsoft Hungary
Microsoft Magyarország Kft.
Phone: +36 (1) 327-2800
Fax: +36 (1) 327-2899
Technical Support: +36 (1) 267-4636 (2MSINFO)

Iceland
See Denmark

India
Microsoft India
Phone: (011) (91) (80) 559 5733, (011) (91) (11) 646 0767, 646 0694
Fax: (011) (91) (80) 559-7133, (011) (91) (11) 647- 4714

Indonesia (SP)
Microsoft Indonesia - Jakarta
Technical Support:
Phone: 62 21 570 42 54
Fax: 62 21 520 81 22

Ireland
See United Kingdom

Israel
Microsoft Israel Ltd.
Phone: 972-3-613-0833
Fax: 972-3-613-0834

Italy
Microsoft Spa
Phone: (39) (2) 7039-21
Fax: (39) (2) 7039-2020
Microsoft Rome Office: (39) (6) 5095-01 - Fax: (39) (6) 5095-0600
Microsoft by Fax (Fax-on-demand service): (39) (2) 70-398-888
Customer Service (New product info, product literature): (39) (2) 70-398-398
Dealer Support (Customer Service for resellers only): (39) (2) 70-398-388
Technical Support: (39) (2) 70-398-398
Microsoft Consulting Service: (39) (2) 7039-21

Japan
Microsoft Company Ltd.
Technical Support (Standard Support): (81) (424) 41-8700
(Technical Support options/ Support Contract)
Phone: 0120-37-0196 (toll free domestic only)
Channel Marketing Information Center:
(Presales Product Support)
Tokyo Phone: (81) (3) 5454-2300
Osaka Phone: (81) (6) 245-6995
Customer Service Phone:
(Version upgrade/Registration)
Phone: (81) (48) 226-5500
Fax: (81) (48) 226-5511

Kazakhstan
See Russia

Kirgizia
See Russia

Korea
Microsoft CH
Phone: (82) (2) 531-4500
Fax: (82) (2) 531-1724
Customer Service: 080-022-7337 (toll free domestic only)
Technical Support:
Office Technical Support: (82) (2) 508-0040
Windows Technical Support: (82) (2) 563-0054
Developer Technical Support: (82) (2) 566-0071
Microsoft FastTips: (82) (2) 3453-7555
Support Sales: (82) (2) 531-4544

Latin America
Microsoft
Latin American Headquarters (U.S.A.)
Phone: (305) 489-4800
Fax: (305) 491-1616
Customer Service: (425) 936-8661
Technical Support: (214) 714-9100
http://www.microsoft.com/latam/soporte

Liechtenstein
See Switzerland (German speaking)

Luxembourg
Microsoft NV
Phone: +32-2-730 39 11
Microsoft Support Network Info. Center +31-800-9977-57
TechNet Subscription: +353-1-703 8738
MSDN Subscription: +353-1-708-8690 Microsoft Information Center: +32-2-481 52 52
Bulletin Board: +32-2-726 85 45
(1200/2400/9600/14400 bd, 8N1, ANSI)
Technical Support:
+32-2-513 32 74 (Dutch speaking)
+32-2-502 34 32 (English speaking)
+32-2-513 22 68 (French speaking)
Web: www.microsoft.com/benelux/support

Malaysia (SP)
Microsoft (Malaysia) Sdn Bhd:
Phone: (60-3) 793-9595
Fax: (60-3) 791-6080

México
Microsoft México, S.A. de C.V.
267-2110 Atencion a Distribuidores
265-3380 Atencion a Clientes
265-3399 Soporte Sistemas Operativos y Applicaciones de Escritorio
267-2190 Soporte de Servidores y Herramientas de Desarrollo
Fast Tips: (52)(5) 2612199
Microsoft BBS 628-6200/02 MSMEXICO sin password

Morocco
Microsoft Afrique Du Nord
Phone: (212) 2 47 10 72
Fax: (212) 2 47 10 86

Netherlands
Microsoft BV
Phone: 023-5689189
Customer Service: 023-5677700
Microsoft Support Network Info Centre: 0800 099 7757
TechNet Subscription: 0800 022 6801
MSDN Subscription: 0800 022 7261
Bulletin Board: 023-5634221
(1200/2400/9600/14400bd, 8N1, ANSI)
Technical Support:
023-5677877 (Dutch speaking)
023-5677853 (English speaking)
Web: www.microsoft.com/benelux/support

New Zealand
Microsoft New Zealand Ltd
Phone: 64 (9) 357-5800
Fax: 64 (9) 358-3726
Technical Support:
Phone: 64 (9) 357-5575
Fax: 64 (9) 307-0516 and 357-5577

Northern Ireland

See United Kingdom

Norway
Microsoft Norway AS
Phone: +(47) 22 02 25 00
Fax: +(47) 22 95 06 64
Technical Support:
Standard: +(47) 22 02 25 50
Priority: + (47) 22 02 25 45
Premier: + (47) 22 02 25 46
Microsoft Sales Support: +(47) 22 02 25 80
Microsoft MSDL: +(47) 22 18 22 09
Microsoft FastTips: +(47) 22 02 25 70
(Document 404040 in FastTips contains detailed instructions)

Panama
Technical Support: (506) 298 2020
Support E-mail: mscasup@microsoft.com
Customer Service: (506) 298 2000
Customer Service E-mail: msccatus@microsoft.com

Papua New Guinea
See Australia

Paraguay
See Uruguay

People’s Republic of China
Microsoft (China) Co. Ltd
19th Floor, Metro Tower
No. 30 Tian Yao Qiao Road,
Shanghai, 200030, P.R.C.
Phone: 011-86-21-64691166; 011-86-21-64691188
Fax: 011-86-21 64691188 Ext. 6988

Peru
Centro de Servicio al Cliente
Central de Soporte: (51) (1) 422- 4116
Fax: (51) (1) 221 9052
Central de Informacion (51) (1) 242-5980
Fax: (51) (1) 447 8591

Philippines (SP)
Microsoft Philippines
Phone: 632 811 0062
Technical Support:
Phone: 632 892 2295/2495 and 632 813-2494
Fax: 632 813 2493

Poland
Microsoft Sp. z o.o.
Phone: +(48-22) 661-54-00
Fax: +(48-22) 661-54-34
Information Service: +(48-22) 865-99-33
Technical Support: +(48-22) 865-99-66

Portugal
Microsoft Portugal MSFT, Lda.
Phone: (351) 1 4409200
Fax: (351) 1 4412101
Technical Support:
Standard Support: (351) 1 4409280/1/2/3
Fax: (351) 1 4411655

Puerto Rico
Technical Support: (408) 953 8086
Support E-Mail: mscarsup@microsoft.com
Customer Service: (800)297 5982 for area codes 787 and 809 only
Customer Service E-mail: msccatus@microsoft.com

Republic of Ireland
See United Kingdom

Romania
Microsoft s.r.l.
Phone: (+40) (1) 222 90 16
Fax: (+40) (1) 222 90 12
Technical Support: (+40) (1) 312 09 48

Russia
Microsoft Z.A.O.
Microsoft Information Center: (095) 916 7171
Russia: 125252
Moscow: Postbox 70
Technical Support:
Moscow (095) 745-54-45
St.-Petersburg: (812) 118-36-36
Novosibirsk (3832) 119-019
Web: www.microsoft.com/rus/

Saudi Arabia
Microsoft Saudi Arabia
Phone: +966-1-488-1165
Fax: +966-1-488-1576
Technical Support:
(Personal Operating System and Desktop Applications only):
Phone: 800 124 0500
(toll free within Saudi Arabia)
Fax: +966-1-474-0576

Scotland
See United Kingdom

Singapore
Microsoft Singapore Pte Ltd
Phone: (65) 337-6088
Fax: (65) 337-6788
Customer Services:
Phone: (65) 324-5255
Fax: (65) 324-6181
Product Support Services:
Phone: (65) 378-3600
Fax: (65) 378-3662

Slovak Republic
Microsoft Slovakia s.r.o.
Phone (+421) (7) 37 63 02
Fax: (+421) (7) 37 66 71
Technical Support: (+421) (7) 531 20 83

Slovenia/Slovenija
Microsoft d.o.o.
Phone: (+386) (61) 1800 8-00
Fax: (+386) (61) 1800 822
Technical Support: (+386) (61) 185 3449

South Africa
Microsoft South Africa
Phone: (27) 11 445 0000
Fax: (27) 11 445 0046
Technical Support:
(Toll Free): 0 802 11 11 04
(Toll): (27) 11 445 0000
Fax: (27) 11 445-0343

South East Africa and Indian Ocean Islands
See South Africa

Spain
Microsoft Iberica SRL
Phone: (34) 1-807-9999
Fax: (34) 1-803-8310
Technical Support: (34) 1 -3754004
Customer Service: (34) 1-3754004
From Spain Only: 902-187 198
Fax Back telephone: (34) 1-3754004

Sweden
Microsoft AB
Phone: +46-(0)8-752 56 00
Fax: +46-(0)8-750 51 58
Technical Support:
Standard: +46-(0) 8- 752 09 29
Priority: +46 (0) 8 751 09 80
Premier: +46 (0) 8 632 57 01
Sales Support: +46-(0)8- 752 56 30
Microsoft MSDL: +46-(0)8-750 47 42
Microsoft FastTips: +46-(0)8-752 29 00
(Document 202020 in FastTips contains detailed instructions)

Switzerland
Microsoft AG
Phone: 01-839 61 11
Fax: 01-831 08 69
Customer Service: 0848-858-868
Documentation:
Phone: 0800-55-59-00
Fax: 01 311-72-27, Microsoft Info-Service, Postfach, 80998001 Zürich
Standard Technical Support:
(German speaking) Installation and Handling: 0848 80 - 2255
Standard Technical Support:
(French speaking): 022-738 96 88
General information about Microsoft Support in Central Europe:
Tel. 0848-80-2330
Internet: www.microsoft.com/switzerland

Tadzhikistan
See Russia

Taiwan Region
Microsoft Taiwan Region Corp.
Phone: (886) (2) 504-3122
Fax: (886) (2) 504-3121
Technical Support: (886) (2) 508-9501

Thailand
Microsoft (Thailand) Limited
Phone: (662) 266-3300
Fax: (662) 266-3310
Product Support:
Phone: (662) 613-7208 through 11
Fax: (662) 613-7198

Turkey
Microsoft Turkey
Phone: 90 (212) 258 59 98
Fax: 90 (212) 258 59 54
Support Hotline:
Phone: 90 (212) 258 96 66
Fax: 90 (212) 258 95 99
Bulletin Board Service: 90 (212) 227 93 90

Turkmenistan
See Russia

United Kingdom
Microsoft Limited
Fax: (0870) 60 20 100
Phone: (0870) 60 10 100
Microsoft KeyData:
(Bulletin Board Service)
(0870) 50 30 200 (up to 28.8Kbaud, n, 8, 1)
Microsoft KeyFax:
(Faxback Information Service)
(0870) 50 30 100
Technical Support:
Desktop Applications, Home Products, Desktop Systems and hardware:
0870 50 10 100
Developer Products: 0870 50 10 200
Business Systems: 0870 50 10 300
Customers phoning from Ireland should dial 706 5353 for technical support.
Minicom Line 0870 50 30 400
Pre-Sales Information: Microsoft Connection (0345) 00 2000

Uruguay
Technical Support:
Phone: (598) (2) 774934
Fax: (598) (2) 774935

Uzbekistan
See Russia

Venezuela
Corporation MS 90 de Venezuela S.A.
Other information: (582) 265-9922
Fax: (582) 265-0863
Technical Support: (582) 993-6755

Wales
See United Kingdom


Understanding Connection Settings and Management

You can customize and control how users connect to the Internet by using the Internet Explorer Customization wizard and the Connection Manager Administration Kit. There are several ways to do this.

Import connection settings

You can preset users' connection settings by importing your settings on the Connection Settings screen of the wizard. To see which settings you'll import, click the Tools menu, click Internet Options, and then click the Connections tab. Click Settings to view dial-up settings, and click LAN Settings to view network settings. The address for automatic configuration is not imported, however.

Set connection system policies and restrictions

If you are a corporate administrator, you can set system policies and restrictions to determine whether users can change their connection settings. You can set policies and restrictions in Stage 5 of the Internet Explorer Customization wizard or through automatic configuration.

Customize the Connection Manager dialer

To customize the appearance and settings of the Connection Manager, you can use the Connection Manager Administration Kit (CMAK) to create a custom service profile. The Connection Manager consists of the interface that appears and settings that are used when users dial in to the Internet. You can start the CMAK when you are using the Internet Explorer Customization wizard, or you can import an existing service profile.


Windows Update Setup for Internet Explorer and Other Internet Tools

The Windows Update Setup wizard makes it easier for administrators to distribute Internet Explorer. It is also easier for users to install Internet Explorer and to recover failed installations.

The Setup wizard is small and compact; it contains a bare minimum of code necessary to give the client Internet access and provide a basic level of file download capabilities.

The process begins with a small setup package. This self-extracting file can be downloaded to the computer by using an existing browser, or it can be copied directly onto a computer with no existing browser. It can fit on a single floppy disk and download very quickly.

Setup works differently on UNIX operating systems. The UNIX functionality in the IEAK supports the more common UNIX method of installing the customized product on only a few servers. Users can then run Internet Explorer from this location rather than installing the product locally. This configuration is recommended for UNIX installations.

Advantages of the Windows Update Setup wizard

This small setup package also allows setup to collect information about the host computer before download begins. Setup uses this information to intelligently manage the download of Internet Explorer 5 .cab files and make installation as efficient and problem-free as possible. Downloading this small setup package at the beginning of the process has many advantages, including the following:

  • Speed: It takes about two minutes to download IE5setup.exe over a 28 kbps link.
  • Users receive feedback early in the setup process if there is not enough disk space (rather than waiting until after a long download phase that may fail).
  • All user options are collected at the beginning, so users do not have to be present while the files are downloaded and installed.
  • If the link to a distribution server is not reliable and you need to reconnect, the download picks up where it failed previously. This process gets the user closer to a complete installation each time setup is run, instead of starting over from the beginning.
  • When a link to a distribution server cannot be reestablished, setup automatically tries other distribution servers.
  • Users receive useful progress information about the download (not just bytes per second, but how long in minutes they have before installation is complete).
  • When the current version of a component is already installed, the files are not re-installed unnecessarily.
  • You can create and run a custom download package without rewriting setup.
  • Unnecessary temporary files can be removed from the hard disk to free disk space for installation.

For an illustration, see Windows Update Setup for Internet Explorer and Other Internet Tools.

The setup process

After IE5setup.exe has gathered all the needed information from the user and the computer, it downloads the necessary .cab files from one of the official Microsoft distribution servers on the Internet. Because setup has already inventoried any existing Internet Explorer 5 components on the computer, and has already asked the user which components are desired, it does not download any unnecessary .cab files.

The next phase of the Setup wizard uses the traditional setup program (ACME) used by many Microsoft products. At this point, the only difference between the Setup wizard and traditional setup is that the .cab files are in a folder on the local hard drive rather than on a removable disk or network drive.

If you are an intranet administrator, you can create a custom setup package (also known as an IExpress package) without rewriting setup. To do that, you create a custom version of IE5setup.exe using a tool named IExpress.

Logging features

Enhanced logging features simplify user, administrator, and Microsoft troubleshooting of setup problems. The Setup wizard creates the following two log files that help you pinpoint any issues that may occur. The log files appear in the Windows or NT folder:

  • Active Setup Log.txt: Logs all actions during the Setup wizard or component installation. Refer to this log if Internet Explorer 5 components are not installed properly. For more information, see Error Log Information for Active Setup Log.txt.
  • RunOnceEx Log.txt: Logs all actions during Dynamic Link Library registration. Refer to this log if you receive a message stating that a specific .dll file did not register properly, or if any unexpected dialog box appears during the final phase of the setup process.


Internet Explorer 5 Security

Internet Explorer 5 allows you to control security in several ways: through site certificates, Authenticode publishers, and security zones. You can preinstall certificates on users' computers and block users from downloading other certificates. You can also set ratings for the content your users view.

Corporate administrators can specify security settings and ratings in Stage 4 and Stage 5 of the Internet Explorer Customization wizard.

About security zones

The Internet Explorer 5 security options enable you to assign specific Web sites to various zones, depending on how much you trust the content of the Web site.

When you install Internet Explorer 5, the following security zones are set up:

  • An Internet zone that by default contains all Internet sites
  • A Local Intranet zone for computers connected to a local network
  • A Trusted Sites zone, to which you can assign sites you trust
  • A Restricted Sites zone, to which you can assign sites you don't trust
  • A My Computer zone, which contains the files on the local computer

Note

  • You can configure the My Computer zone only from the IEAK; these settings are not available in the browser interface. It is recommended that you generally use the default settings for this zone unless your organization has a specific requirement. Lower security settings could result in security risk, whereas higher security settings could impair functionality.

The following four default settings can be applied to these zones: High, Medium, Medium-low, and Low. In addition, you can set custom security levels for each zone.

You can view all the security settings by clicking the Internet icon in Control Panel, and then clicking the Security tab. For specific information about these options and how they interact, see Internet Explorer Security Options.

Remember, security on the Internet is as good as your settings. Internet Explorer 5 provides you with the information you need to make good security decisions and with flexible tools to implement those decisions.

You can preset security options when you run the Customization wizard, and you can determine whether or not users can change these settings. If you do not preset the security options, then you may want to recommend the optimum security level for your users, based on your organization's needs and your users' level of expertise.

Note

  • If the language of the package of the Internet Explorer browser you are building differs from your browser on your computer, and you import your security zones, some unrecognizable characters may appear in the security zones interface of the browsers that you build.

Setting up the Internet zone

The Internet zone consists of all sites not included in any of the other zones. By default, the Internet zone is set to the Medium security level. If you are concerned about possible security problems browsing the Internet, you might want to change the setting to High. If you raise the security setting, some Web pages will not be allowed to perform certain potentially hazardous operations, although this may prevent some useful functionality from working and some pages may appear not to be working properly.

You can choose custom settings so that you can control each individual security decision for the zone. To do this, click the Internet icon in Control Panel, click the Security tab, and then click Custom Level.

Adding sites to the Trusted Sites and Restricted Sites zones

There are two zones available to which you can assign specific Web sites that you trust more or less than those in the Internet zone or the Local Intranet zone. To add sites to these zones, first choose the zone, and then click Sites.

The Trusted Sites zone is assigned a Low security setting by default. It is intended for highly trusted sites, such as companies that you frequently do business with, sometimes known as an "extranet." If you assign a site to the Trusted Sites zone, the site will be allowed to perform more powerful operations. Also, Internet Explorer will ask you to make fewer security decisions. Add a site to this zone only if you trust all of its content never to do anything harmful to your computer. For the Trusted Sites zone, we strongly recommend that you use the HTTPS: protocol or otherwise ensure that connections to the site are secure.

The Restricted Sites zone is assigned a High security setting by default. If you assign a site to the Restricted Sites zone, the site will be allowed to perform only minimal, very safe operations. This zone is for the rare case of a site you don't trust. To ensure a high level of security for content that isn't trusted, many pages in this zone will not function properly.

Setting up the Local Intranet zone (for network administrators)

To be secure, it is imperative that the Local Intranet zone be set up in conjunction with the proxy server and firewall. All sites in the zone should be "inside the firewall," and proxy servers should be configured so that they do not allow an external DNS name to be resolved to this zone. Configuring the client zone security requires a detailed knowledge of the existing network configuration, proxy servers, and secure firewalls. If you don't know this information, contact your network administrator.

By default, the Local Intranet zone consists of local domain names and those set in proxy override on the Connections tab. You can configure these settings on the Connection Settings screen of the Internet Explorer Customization wizard. Note that multiple connection settings can now be configured for each user. The network administrator should confirm that these settings are indeed secure for the installation or adjust the settings to be secure.

When setting up the zone, you can specify which categories of URLs should be considered. You can also add specific sites to the zone.

To specify categories of URLs to include in the zone from the browser

  1. On the Tools menu in Internet Explorer, click Internet Options, and then click the Security tab.
  2. Click the Local Intranet zone, and then click Sites.
  3. Select the following check boxes that apply:

    Include all local (intranet) sites not listed in other zones
    Include all sites that bypass the proxy server
    Include all network paths (UNCs)

Notes

  • To add a specific site to this zone, click Advanced, type the URL, and then click Add. To require that server verification be used, select the Require server verification (https:) for all sites in this zone check box.
  • To specify categories of URLs for your IEAK packages, click Customize Security Zones settings on the Security Settings screen of the Customization wizard, and then click Modify Settings.

The following rules apply to the Local Intranet zone options. Note that adding a site to any zone takes precedence over the following rules:

  • Include all local (intranet) sites not listed in other zones: Intranet sites have names that do not include dots (for example, http://local). A site name such as http://www.microsoft.com is not local because it contains dots. This site would be assigned to the Internet zone. The intranet site name rule applies to file: as well as http: URLs.
  • Include all sites that bypass the proxy server: Typical intranet configurations use a proxy server to access the Internet with a direct connection to intranet servers. This setting uses this kind of configuration information to distinguish intranet from Internet content for purposes of zones. If the proxy server is otherwise configured, you should clear this option and use other options to designate files that are assigned to the Local Intranet zone. In systems that do not have a proxy server, this setting has no effect.
  • Include all network paths (UNCs): Network paths (for example, \\local\file.txt) are typically used for local network content that should be included in the Local Intranet zone. If there are network paths that should not be in the Local Intranet zone, you should clear this option and use other options to designate files that are assigned to the Local Intranet zone. For example, in certain Common Internet File System (CIFS) configurations, it is possible for a network path to reference Internet content.

After the Local Intranet zone is confirmed secure, consider changing the zone's security level to Medium-Low or Low to enable a wider range of powerful operations to be performed. It is also possible to adjust individual security settings in the Custom Settings dialog box.

If there are parts of your intranet that are less secure or otherwise not trustworthy, they can be excluded from this zone by assigning them to the Restricted Sites zone.

The Local Intranet zone is intended to be configured via the IEAK, although you can also use the options on the Security tab in the Internet Properties dialog box.

Working with domain name suffixes

If you want to be able to reference a Web server by using a shorter version of its address that doesn't include the domain, you can use a domain name suffix. For example, a Web server named sample.microsoft.com can be referenced as sample; the same content can also be accessed by entering http://sample.microsoft.com or http://sample.

To set this up, you must add the domain suffix to the TCP/IP properties domain suffix search order by carrying out the following steps:

  1. Right-click the Network Neighborhood icon, and then click Properties.
  2. Click TCP/IP, and then click Properties.
  3. Click the DNS Configuration tab, and then in the Domain Suffix Search Order area, add the information you want.

It's important to set up security zones correctly for this configuration. By default, the URL without dots (http://sample) is considered to be in the Local Intranet zone, while the URL with dots (http://sample.microsoft.com) is considered to be in the Internet zone. Therefore, when you use such a configuration and there is no proxy server bypass to clearly assign the content to the proper zone, you need to change the zone settings.

Depending on whether the content accessed by the domain suffix is to be considered as intranet or Internet content, you need to assign the ambiguous site URLs to the appropriate zones. To assign URLs such as http://sample to the Internet zone, clear the Include all local (intranet) sites not listed in other zones check box for the Local Intranet zone, and include the site in the site list for the zone.

Other notes about security that apply to all zones

Web content can be addressed either via Domain Name System (DNS) name or by Internet Protocol (IP) address. For sites that use both, it is important to configure both references to the same zone. In the common cases, the Local Intranet sites are identifiable by either local name or by IP addresses in the proxy bypass list; all other names and IP addresses would be mapped to the Internet zone. However, if a site name is entered into the Trusted Sites or Restricted Sites zone list but its IP address range isn't, then the site may be treated as part of the Internet zone if it is accessed by the IP address.

It is important to understand that a user could copy content from one zone to another, potentially increasing or decreasing the level of security intended for the content.

If you are using automatic configuration, and you are supporting both Internet Explorer 5 and Internet Explorer 4.0 with the same automatic configuration file, some security settings that differ between the versions will not be configured on Internet Explorer 4.0.


Preparing a UNIX Component for Installation

The following procedure helps you create a script and a cabinet file so that you can prepare the UNIX component for your IEAK package. For an example, see UNIX Component and Script Sample.

  1. Prepare or download the component you want to install.

    2. Compress the program if needed. You can use formats such as .tar and .gz.

  2. Create a script to install your program. For the IEAK, the script must begin with #!/bin/sh.

    If you are familar with writing setup programs, you can add setup functionality to your compiled program instead of writing a script.

    Your script can use the following default parameters; no custom parameters can be specified:

    Argument 1 ($1) is the location of the installation.
    Argument 2 ($2) [install_dir]/[target] is the target destination of the component (the place where you want the cabinet files to be located).
    Argument 3 ($3) is an integer that represents whether silent mode is used [0=standard installation/1=silent installation]. It is not used in the example below, but you can use it in your setup script.

    The current folder (default folder) when the script is run is the user's home folder. This is important, because the files are extracted to the root folder of the installation.

    A script must contain the characters #! and the path to the script interpreter on the first line. If Setup encounters #! on the first line of the script, it processes the file by using dos2unix, which converts line-terminating characters (from the Windows and MS-DOS platforms) to the UNIX equivalent. Without this process, a script created on a personal computer will not be able to run.

    The sample script shown below specifies the target location and decompresses the executable file.

    3. #!/bin/sh |
cd $2 | # Go to the location of the zip file.
mkdir <directory name> | # Create an installation folder.
mv <compressed component> <directory name> | # Move the zip file into that folder.
cd <directory name> | # Switch to that folder.
gunzip <compressed component> | # Unzip the component.
chmod +x <uncompressed component> | # Assign "execute" or other needed permissions to this file, so it can be run as a program.
cd $1/bin | # Switch to the Internet Explorer bin folder.
ln -s ../<directory name>/<uncompressed component executable> | # Create a link to the executable program.
  3. Test this script on the UNIX operating system.
  4. Move the script and the compressed component to the computer running a Windows 32-bit operating system where you plan to run the Internet Explorer Customization wizard.
  5. Create a cabinet file consisting of your program and script. You can use a tool such as Cabarc.exe, which is located in \Program Files\IEAK\Tools\. The following is a simple example, but you can also include wildcards, such as ? and *:

    6. "cabarc n <program name.cab> <compressed component> + <script name>"

  6. Start the Customization wizard, and complete the steps for the UNIX platform until you reach the "Add Custom Components" screen in the wizard.
  7. Type the following information:

    8. Component
    The friendly name of the component you plan to install.

    Location
    The location of the cabinet file on your Windows 95, Windows 98, or Windows NT 4.0 computer.

    Program
    The name of the installation script <script name>. No additional parameters can be specified.

  8. Complete the steps in the Customization wizard. When you reach the UNIX Mapping screen in the wizard, you may need to create an association for your component.

    9. When you install your customized IEAK package, it decompresses the cabinet file, runs the script, and installs your component before it customizes the browser. After the setup script has run, it is deleted automatically.


Updating Users Periodically

Your users can be notified automatically when a new version of Internet Explorer is available. You can control whether Internet Explorer checks for this updated information and if it does, how often it checks.

Here's how it works:

  • When a new version of Internet Explorer is detected, the user's home, or start, page is temporarily replaced by an update notification page. From this page, users can upgrade their browser, add the page to their Favorites list, or cancel the update.
  • By default, the Microsoft Internet Explorer page for the Microsoft Windows Update is used as the update notification page. Or you can display a custom Web page instead that provides product update information or even company news. For example, you could create a Web page to notify users of new Internet Explorer releases, new server paths, and company news.

    The update notification page enables you to periodically distribute information to users in .htm format. If you want to distribute this information to users by using channels and the .cdf format, this functionality is still available as well.

  • The next time the user starts the browser, the user's default home page is displayed.

You can specify the settings for the update notification page by carrying out the following steps:

  1. If you are changing this setting in the Internet Explorer Customization wizard, on the System Policies and Restrictions screen in Stage 5, click Internet Settings.

    If you are changing this setting in the Profile Manager, click Policies and Restrictions, and then click Internet Settings.

  2. Select the Automatically check for Internet Explorer Updates check box.
  3. In the left side of the screen, click Component Updates.
  4. If you want to use the default Windows Update page, do not replace the default URL.

    If you want to use a custom page, type the address of the page in the URL to be displayed for updates box.

  5. Under Update check interval, specify the number of days between intervals to check for updated information.

Note

  • Under the Internet Restrictions area in both the Profile Manager and the Policies and Restrictions page of the wizard, you can also restrict whether Internet Explorer checks for periodic updates on the Periodic Update Check screen.


Creating Customized Graphics

Before preparing graphics for the logo, you should consult your license agreement to verify that this customization is available.

Graphic name | What it's used for | Size/type | Preparation
Static logo | To brand the Internet Explorer browser with your logo | 38-by-38 pixel and 22-by-22 pixel .bmp files | Create two 256-color bitmaps (38-by-38 pixels and 22-by-22 pixels). Save the files in the custom bitmap folder (CIE\Bitmaps). When the browser isn't active, the first frame of the animated logo will be used as your static logo.
Animated logo | To brand the Internet Explorer browser with your animated logo | 38-by-38 pixel and 22-by-22 pixel .bmp files | Create two 256-color bitmaps (38-by-38 pixels and 22-by-22 pixels). The bitmaps must contain a vertical stack of animation cell images that follow Internet Explorer animation rules (see below). Save the files in the custom bitmap folder (CIE\Bitmaps). When the browser isn't active, the first frame of the animated logo will be used as your static logo.
Setup bitmaps (for Windows operating systems only) |  | For 32-bit versions of the browser Left vertical: 162-by-312 pixel 256-color .bmp (on first Windows Update Setup wizard page) Top horizontal (on all but first page): 496-by-56 pixel 256-color .bmp For 16-bit versions of the browser 162-by-312 pixel .bmp (16-color recommended, with few or no background colors and patterns) | For 32-bit versions, the top horizontal banner needs to be light, like a "watermark," to allow text in the user interface to be readable.
Toolbar background |  | No specific dimensions | Background should be the size of the toolbar and light enough to show black text.
Internet Connection wizard |  | Top image 49-by-49 pixel .bmp file Left image 164-by-458-pixel .bmp file | Not available for serverless sign-up
Browser toolbar button |  | Two icon files, with black-and-white and color images for active and inactive states | For more information, see Designing Toolbar Icons for Internet Explorer 5.
Icons for Favorites list |  | A 16-by-16 pixel .bmp file for each item you want to customize |
Autorun splash screen (Windows 32-bit platforms only) | To display a splash screen when the user inserts the CD | If you distribute your custom browser on a CD, you need to create a (540-by-357 pixel) bitmap for the Autorun splash screen that is displayed when the user inserts the CD. | Before you create the splash screen, you need to convert any 24-bit images to 256-color identity palette.
Channels |  | For each channel: 32-by-32 pixel icon, 80-by-32 pixel graphic for channel bar, and 194-by-32 pixel graphic for channel pane. The 80-by-32 pixel and 194-by-32 pixel graphics can be in .gif, .bmp, or .jpeg format. The channel category graphic is used in Windows 32-bit platform versions of Internet Explorer only. |
LDAP service bitmap |  | 134-by-38 pixel, 16-color .bmp file |

Internet Explorer animation rules

  • Cells 1 through 4 are lead-in cells, which are played when Internet Explorer begins to browse.
  • Cells 5 through X, where X is the total number of cells, loop until the browse operation is complete.

Note

  • Two tools are included with the IEAK to help you create customized animated bitmaps for your browser. One tool is used to stack bitmaps in the format described above, while the other tool previews the animation. For information about how to use these tools, see Animated Bitmap Tools.


Working with Channels

With the channels feature in Internet Explorer, you can specify which content is downloaded, and when. You can provide the latest news reports and company information. If your users are upgrading from Internet Explorer 4 or running Windows 98, they can display channels in a channel bar on their desktop.

A channel is a Web site that has been enabled for information-receiving programs. The mechanism that makes this possible is the Channel Definition Format (.cdf) file. You can use the content you already have, such as Web pages and graphics, for channels. You may want to structure it differently so you can make sure users receive the right amount of content in an organized way.

If you are creating channels for multiple operating systems, you should make sure your content works correctly and is readable on all platforms.

A software distribution channel is a mechanism for updating program files (in the form of Java™ class libraries, Java stand-alone applications, ActiveX™ Controls, or platform-native code) to the user's computer. A software distribution channel is based on a .cdf file and the Open Software Distribution (OSD) format.

Additional resources

The .cdf and OSD formats are based on XML (eXtensible Markup Language), a standard for storing and transmitting structured data. Like HTML, an XML-based document contains text annotated with tags. For more information and samples, see the Microsoft Site Builder Network Workshop.

The Channel Definition Format file

The .cdf file provides an index of resources available in the channel and a recommended schedule for when the channel should be updated on the local computer. A .cdf file contains some tags that specify logos, the files to be updated, and the schedule for updating them.

If the .cdf file includes the ABSTRACT element for each item in a channel, users can view a description of those items. Abstract descriptions are displayed in a ToolTip when the user rests the cursor over the item. Web publishers can use this feature to describe the content of a particular Web page or to attract users' attention and encourage them to review that content immediately.

Note

  • When specifying a .cdf file for a custom channel in the IEAK, the .cdf file should not contain the LOGO tag with the IMAGE or ICON parameter.

The OSD format

Open Software Distribution (OSD) provides automatic download of only the software that the user needs, and the correct version of the software. By querying users' computers about existing software and hardware, OSD can make more intelligent decisions about what users need. With new versions of software always coming out, major revisions, minor revisions, and build numbers can bewilder even hard-core users.

OSD simplifies the computing experience further by installing missing components as needed. This means that if the user is missing a component that prevents another program from functioning, OSD can detect this and automatically retrieve the missing component for you. Users get only the components they need. Many of the tags and functions performed with OSD can also be used in .cdf files.


Batch File Syntax

You can use a batch file with Setup to control the Setup process and the Windows Update Setup Wizard for Internet Explorer and Internet Tools. The following table shows the sections and entries for the batch file. For more information about how to use a batch file, see Using Batch Mode Setup.

Batch file entry | Description
[Options]
SaveUninstallInfo=[0,1] Determines whether or not information about removing components is stored.
  • 0 specifies that information is not stored. If you use this switch, you will not be able to uninstall Internet Explorer from Control Panel.
  • 1 (default) specifies that information is stored.
ExtraSection= | Runs the sections specified in the Iesetup.inf file. Separate sections with commas (for example, section1,section2,section3).
Quiet=[A,C,U] Represents quiet mode, in which the installation is run with little or no input from the user.
  • A specifies administrative mode, in which Setup does not appear to the user and error checking is not performed.
  • C suppresses the Cancel button on the progress page.
  • U specifies that Setup does not appear to the user unless required input (e.g., download location) is not available.
ShowErrors=[0,1] Determines whether or not Setup errors are displayed to the user.
  • 0 specifies that Setup carries out the default action for each message with no user input.
  • 1 (default) specifies that Setup errors are displayed to the user.
[Welcome]
Display=[0,1] Determines whether or not the initial Setup screen is displayed on the user's computer.
  • 0 specifies that the initial Setup screen is not displayed to the user.
  • 1 (default) specifies that the initial Setup screen is displayed to the user.
[SetupChoice]
Display=[0,1] Determines whether or not the screen on which users can choose the Setup option whether or not to customize Setup is displayed on the user's computer.
  • 0 specifies that the Setup type screen is not displayed to the user.
  • 1 (default) specifies that the Setup type screen is displayed to the user.
SetupChoice=[0,1] Determines which Setup option is chosen.
  • 0 (default) specifies Install now - Typical Setup of Components.
  • 1 specifies Custom Setup.
[Custom]
Display=[0,1] Determines whether or not the Component Options screen, in which users can select components and click Advanced to specify more options, is displayed on the user's computer.
  • 0 specifies that the Component Options screen is not displayed to the user.
  • 1 (default) specifies that the Component Options screen is displayed to the user.
InstallDir=foldername | Specifies the folder for installing files. If you do not include this setting, Setup uses the current settings in the Iesetup.inf file. If you have installed an earlier version of Internet Explorer, Setup installs into the same folder as the earlier version.
InstallDirRO=[0,1] Specifies whether or not the user can change the installation folder.
  • 0 (default) specifies that the user can change the installation folder.
  • 1 specifies that the user cannot change the installation folder.
UseInfInstallDir=[0,1] Specifies the folder into which Internet Explorer is installed.
  • 0 (default) specifies that Setup uses the default installation folder or the same folder in which an earlier version of Internet Explorer is already installed.
  • 1 specifies that the installation folder is the folder specified in the Iesetup.inf file.
SetupMode=[0,1,2] Specifies what kind of installation will be performed.
  • 0 specifies a Minimal installation.
  • 1 (default) specifies a Typical installation.
  • 2 specifies a Full installation.
SetupModeRO=[0,1] Determines whether or not the user can change the Setup type.
  • 0 specifies that the user can change the Setup type.
  • 1 (default) specifies that the user cannot change the Setup type.
Component=[Comma-separated list of component IDs]

Specifies that only the components specified in the Component= setting will be installed. The ComponentID is a string that uniquely identifies a component; you can find the corresponding string in the component sections of the Iesetup.cif file. You can also find ComponentID information on the IEAK Web site.
ComponentListRO=[0,1]

Determines whether or not the user can specify which components are installed (in addition to the components in the Setup type).

  • 0 (default) specifies that the user can change the list of components.
  • 1 specifies that the user cannot change the list of components.
DownloadOnly=[0,1] Determines whether or not Internet Explorer is just downloaded, or downloaded and installed.
  • 0 (default) specifies that the files are downloaded and then installed.
  • 1 specifies that the files are downloaded but not installed.
DownloadOnlyRO=[0,1] Determines whether or not the user can specify that files are downloaded or downloaded and installed.
  • 0 (default) specifies that the user can change this setting.
  • 1 specifies that the user cannot change this setting.
IECompat=[0,1] Determines whether or not Internet Explorer 5 is installed on the same computer as Internet Explorer 4, so that functionality from both programs is available.
  • 0 specifies that Internet Explorer 5 cannot be installed side-by-side with Internet Explorer 4.
  • 1 (default) specifies that Internet Explorer 5 can be installed so that it works with Internet Explorer 4.
IECompatRO=[0,1] Determines whether or not the user can specify if Internet Explorer 5 will be installed with Internet Explorer 4.
  • 0 (default) specifies that the user can change this setting.
  • 1 specifies that the user cannot change this setting.
IECompatShow=[0,1] Determines whether or not the Compatibility check box, which enables users to run Internet Explorer 5 side-by-side with Internet Explorer 4, is displayed.
  • 0 specifies that the check box is not displayed in the wizard.
  • 1 (default) specifies that the check box is displayed in the wizard.
ShowAdvanced=[0,1] Determines whether or not the Advanced button is displayed on the Component Options screen in the Windows Update Setup wizard. Clicking the Advanced button displays the Download only, Compatibility, and Don't associate file types options.
  • 0 specifies that the Advanced button is not displayed in the wizard.
  • 1 (default) specifies that the Advanced button is displayed in the wizard.
IEDefault=[0,1] Determines whether or not Internet Explorer is the default browser.
  • 0 specifies that Internet Explorer is not the default browser.
  • 1 (default) specifies that Internet Explorer is the default browser.
IEDefaultRO=[0,1] Specifies whether or not users can determine if Internet Explorer is their default browser.
  • 0 specifies that users can determine whether Internet Explorer is their default browser.
  • 1 (default) specifies that users cannot determine whether Internet Explorer is their default browser.
[Download]
Display=[0,1] Determines whether or not the option to download or install files is displayed on the user's computer.
  • 0 specifies that the option to download or install files is not displayed to the user.
  • 1 (default) specifies that the option to download or install files is displayed to the user.
DownloadDir=foldername | Specifies the folder for downloading files. If you do not include this setting, Setup creates a folder named Windows Update Setup Files on the drive that has the most disk space.
DownloadDirRO=[0,1] Specifies whether or not users can change the folder where their files are downloaded.
  • 0 (default) specifies that users can change the download folder.
  • 1 specifies that users cannot change the download folder.
DownloadOS=[0,1,2,3] Specifies that files for a specific operating system are downloaded; this setting is valid only if you are downloading but not installing files (DownloadOnly=1).
  • 0 (default) specifies the current operating system.
  • 1 specifies Windows NT and Windows 95/Windows 98.
  • 2 specifies Windows 95/Windows 98 only.
  • 3 specifies Window NT only.
DownloadOSRO=[0,1] Determines whether or not users can specify the operating system of the files that are downloaded to their computer.
  • 0 (default) specifies that users can change this setting.
  • 1 specifies that users cannot change this setting.
[DownloadSite]
Display=[0,1] Determines whether or not the download sites are displayed to the user.
  • 0 specifies that the download sites are not displayed to the user.
  • 1 (default) specifies that the download sites are displayed to the user.
DownloadLocation=URL | Specifies the address of the Web site that users download .cab files from, if you are distributing from the Web. If you used Display=0 for this section, or any switch that would result in this page not being displayed, you should enter a download site.
DownloadSiteList=URL Specifies the location for the list of download sites; by default, this list is the Ie5sites.dat file. If you do not include this setting, Setup uses the current settings in the Iesetup.inf file.
[PrepareSetup]
Display=[0,1] Determines whether or not the Preparing Setup screen is displayed on the user's computer.
  • 0 specifies that the Preparing Setup screen is not displayed to the user.
  • 1 (default) specifies that the Preparing Setup screen is displayed to the user.
[Diskspace]
Display=[0,1] Specifies whether or not to display on the user's computer the amount of disk space needed.
  • 0 specifies that the amount of disk space needed is not displayed on the user's computer. If the user does not have enough disk space, Setup will close.
  • 1 (default) specifies that the amount of disk space needed is displayed on the user's computer.
[Progress]
Display=[0,1] Specifies whether or not to display the installation progress to the user.
  • 0 specifies that the installation progress is not displayed to the user.
  • 1 (default) specifies that the installation progress is displayed to the user.
[RebootPartial]
Display=[0,1] Determines whether or not the Installation Incomplete screen appears if a component fails to install.
  • 0 specifies that the Installation Incomplete screen does not appear if a component fails to install.
  • 1 (default) specifies that the Installation Incomplete screen appears if a component fails to install.
[Finish]
Display=[0,1] Specifies whether or not to display the message that the computer is restarting after Setup.
  • 0 specifies not to display the message that the computer is restarting after Setup. If you plan to turn off restarting after installation, use 0.
  • 1 (default) specifies to display the message that the computer is restarting after Setup.
[Reboot]
Reboot=[0,1] Specifies whether or not to restart the computer after Setup.
  • 0 specifies that you do not want to restart the computer after Setup. If you turn off restarting, your program should take care of restarting the computer. Internet Explorer will not be configured correctly until the computer is restarted.
  • 1 (default) specifies that you do want to restart the computer after Setup.
[Upgrade]
ReinstallAll=[0,1] Specifies whether or not to reinstall all components if Setup is run a second time.
  • 0 (default) specifies not to run Setup again if all components are already installed.
  • 1 specifies to reinstall all components.


Customizing Setup

The Internet Explorer Customization wizard enables you to control functionality and user experience during setup. If you want to further customize the setup process for your organization, you have two options:

  • Batch text file

    It's easy to create a batch text file and integrate it with your IEAK custom package. You can also place the batch file in the same installation location as Ie5setup.exe, such as in the same download server folder or the same folder on the installation CD-ROM.

    You might want to keep the batch file separate if it was not available when you prepared your IEAK package or if you want to temporarily or permanently change the setup options that you specified in your custom IEAK package.

  • Command-line switches

    You would typically use command-line switches in connection with a program that bundles the IEAK package program, switches, and any custom component you want to include. If you want to modify setup using command-line switches, you can use the IExpress wizard, which is included with the IEAK, or you can use your own setup program.

Here are some reasons you might want to customize Setup:

  • Implement hands-free installation: Perhaps you want to set up Internet Explorer after hours. Although the IEAK helps you set up a "silent" or "quiet" installation that requires little user interaction, perhaps you want to further control this process. By using settings in the batch text file or command-line switches, you can determine which messages the user sees and whether the computer is restarted by setup.
  • Gain more control over specific components: The batch file enables you to install and control components, regardless of whether you specified them in the IEAK. You can also restrict the types of setup (Standard, Custom) that are available. Use the ComponentID, a string such as NetMeeting, to identify your component. You can find ComponentID information in the Iesetup.cif file and at the IEAK Web site.
  • Redistribute Internet Explorer as part of your custom program: Perhaps you want to install Internet Explorer without the icons or browser interface; for example, you may want to do this if you plan to host Internet Explorer with your custom application. To do so, you would use a batch file with the Redist option or with the /X switch.
  • Change setup options without rebuilding your IEAK package: Perhaps you need to set up Internet Explorer in a particular way, and you don't want to rebuild your IEAK package. You can use a batch file or switches to change settings you specified in the IEAK.


Internet Explorer Batch Mode Setup Switches

You may want to control the way that Setup is run. You can use command-line switches to choose the installation mode, specify a quiet mode (which removes or reduces the prompts the user receives), or control whether the computer is restarted after installation.

You can have users include these switches when they run Setup, but a more typical scenario is packaging Internet Explorer with another program, such as IExpress, for a batch installation.

The IExpress wizard helps you pass switches to Setup for another program. When using IExpress with Internet Explorer switches, the Internet Explorer switches are placed inside the IExpress expression as follows:

Ie5setup <Iexpress switches> /c:" ie5wzd <Internet Explorer switches>"

If you are installing Internet Explorer 5 over an existing installation of Internet Explorer 4.0 by using command-line switches, you should make sure to include the Offline Browsing Pack component. If it is not part of all installation options, then you should add this as a required component using the /E: switch. The component ID name to use is MobilePk.

IExpress Switches

The following are frequently used IExpress switches that control the extraction process during Setup. They are not specific to Internet Explorer:

  • /Q - Specifies quiet mode, or supresses prompts, when files are being extracted. This switch does not supress prompts when Windows Update Setup is running.
  • /Q:U - Specifies user-quiet mode, which presents some dialog boxes to the user.
  • /Q:A - Specifies administrator-quiet mode, which does not present any dialog boxes to the user.
  • /C:<> - Specifies the path and name of the Setup .inf or .exe file.
  • /R:N - Never restarts the computer after installation.
  • /R:A - Always restarts the computer after installation.
  • /R:S - Restarts the computer after installation without prompting the user.
  • /T:<directory path> - Specifies the target folder for extracting files

Internet Explorer Switches

You can use the following switches to control Internet Explorer Setup:

  • /Q - Specifies a quiet "hands-free" mode. The user is prompted for information that isn't specified.
  • /B:iebatch.txt - Specifies the batch script file to use.
  • /Q:A - Specifies a quiet mode with no user prompts.
  • /Q:C - Specifies a quiet mode with the Cancel button not displayed, so the user cannot cancel Setup. The Internet Explorer Customization wizard uses this switch if you select the Install package silently option when you are installing as a corporate administrator.
  • /M:[0|1|2|3...] - Specifies the installation mode. For customized IEAK packages, 0 refers to the first installation choice, 1 refers to the second choice, and so on (for example, 0=minimal, 1=typical (default), 2=full).
  • /E:ComponentID,ComponentID - Specifies extra components to be installed regardless of the installation mode. Use this switch to specify components that aren't a part of the installation type you specified in the Customization wizard. This switch also overrides settings in the batch text file, if used. The ComponentID is a string that uniquely identifies a component; you can find the corresponding string in the component sections of the Iesetup.cif file.
  • /S:""#e"" - Designates the source path of Ie5setup.exe. The ""#e"" refers to the full path and name of the .exe file. Note that the path must be surrounded by two pairs of double quotation marks.
  • /R:N - Suppresses restarting the computer after installation. If you suppress restarting, your program should take care of restarting the computer. Internet Explorer is not configured correctly until the computer is restarted.
  • /D - Specifies that you want to download only the files for the current operating system.
  • /D:1 - Specifies that you want to download files for Microsoft Windows and Windows NT operating systems.
  • /G: - Runs specified installation sections in Iesetup.inf. Separate sections with commas.
  • /X - Installs Internet Explorer without the shell, icons, or links. This option is useful for hosting browser controls in your own application.
  • /X:1 - Installs Internet Explorer with the shell, icons, or links, but does not take over default browser or http protocol associations.
  • /P - Reports the required component and disk space cost for an installation. It enables you to see how much disk space will be used based on the installation options selected.
  • /F -(Fix) Reinstalls all items on the user's computer that are the same version or newer. Using the /F switch ensures that no component is replaced with an earlier version.

Examples

Here are some example scenarios:

  • The following expression performs a quiet installation. It does not prompt the user, and the computer is not restarted after installation:

    ie5setup.exe /Q:A /C:"ie5wzd /S:""#e"" /Q /R:N"

  • The following expression overrides the Ie5sites.dat site list and installs Internet Explorer from the specified location:

    ie5setup.exe /C: "ie5wzd /L:""\\yourserv\yourdir\yourlist.dat"" /S:""http://www.yourserver.com/directory/ie5setup.exe""

    This expression would be used to point users to another download location (for example, in another country) without rebuilding your IEAK package.


IEAK Toolkit

The IEAK Toolkit contains helpful tools, programs, and sample files. The Toolkit contents are located in the \Program Files\IEAK\Toolkit folder and its subfolders.

In the Toolkit folder, you will find a reference for .isp and .ins files named Insref.xls.

Addons folder

This folder contains sample Add-on Components pages.

Corp folder

This folder contains sample .ins files for automatic configuration and customizable Active Server Page (.asp) scripts. The .asp files are designed for Web servers running Internet Information Server 3.0 (and later), but they can be viewed by any standard Web browser.

Graphics folder

This folder contains sample art and tools.

Inf folder

This folder contains a sample .inf file for creating an uninstall program.

ISP folder

This folder contains various tools and samples: dialer information; a tool (Inetlogn.exe) that can help you cache each user's password, so the user doesn't have to type it at each logon; sample scripts, tools, and customizable solutions for server-based, Internet Connection wizard, and non-server-based sign-up packages.


Working with Setup Information (.inf) Files

An information (.inf) file is a text file that specifies the files that need to be present or downloaded for your component to run on 32-bit versions of Windows. The Internet Component Download service uses these instructions to install and register software components downloaded from the Internet and any files required by the components. The Internet Component Download service has been part of Internet Explorer since version 3.0.

An Internet software distribution unit is a "package" consisting of a cabinet file (.cab) that contains an .inf file or a software distribution (.osd) file (or both). A distribution unit can also contain a software component, such as an ActiveX control (.ocx), a .dll file, an .exe file, a Java class file, or an applet. When a cabinet file that contains an .inf file is referenced by the CODEBASE attribute of an OBJECT element on a Web page, Internet Explorer 3.0 and later automatically treats the cabinet file as a software distribution unit.

With .inf files, you can create customized software installation instructions that include registry entries and destination directories. An .inf file can provide limited platform independence and specify limited software dependencies.

The following topics provide you with more information about working with .inf files:

  • Manipulating Folders and Files by Using Setup Information (.inf) Files
  • Setup Information File (.inf) Definition
  • Extensions to Windows 32-bit Setup
  • Providing Uninstall Functionality in an .inf Script
  • Using RunOnce Technology
  • Sample .inf File

Note

  • For more information about the Internet Component Download service, see the Microsoft Site Builder Network Workshop.


Troubleshooting

Reference

Troubleshooting Setup

Problems with the Setup Process

If the Internet Explorer setup process fails, you can troubleshoot setup errors using the Active Setup Log.txt file. The Active Setup Log.txt file is a log of the entire Setup process from the moment IE5Setup.exe is executed until the download of the last .cab file is complete.

When IE5Setup.exe is executed, Active Setup Log.txt is created in the folder where Windows is installed (typically, the C:\Windows folder). If an Active Setup Log.txt from a previous Internet Explorer Setup session exists, it is renamed to Active Setup Log.bak.

The log begins with the date and time Setup was launched and ends with the date and time it successfully downloads the last .cab file. As you go through the Setup wizard, logging entries are continually written to this file. It is the most informative log file for determining what caused a download failure and when the failure occurred. Most entries logged in this file are also written to the registry; this data is recorded to assist with safe recovery.

The error codes can help you determine what Setup was doing when it failed and also help you determine the cause of the failure. For information about the error codes, see Error Log Information for Active Setup Log.txt.

Problems with Uninstalling Files

When the uninstall process fails, the most important tool for troubleshooting an uninstallation is the uninstall log, IE5 Uninstall Log.txt, which is located in the \Windows folder. This log covers the entire uninstallation process sequentially, including every file addition or removal; every registry addition, change, or removal; and any dialog boxes shown to the user.

The log is divided into Passes, which denote the different phases of an uninstall. Entries in the log also have an Object number that corresponds to the line entry in Setup.stf. Lines without an Object number result from custom actions specific to Internet Explorer 5 and are contained in the IE5.inf file or in an .inf file from an external component uninstallation.

If you cannot use Add/Remove Programs in Control Panel to uninstall Internet Explorer, uninstall information may have been deleted from the computer. The following are the key uninstall files:

  • IE5bak.dat
  • IE5bak.ini
  • Integrated Browser.dat
  • Integrated Browser.ini.

The Internet Explorer Advanced Uninstall dialog box offers the option of uninstalling this backup information, but doing so prevents you from uninstalling Internet Explorer in the future.


Troubleshooting Wizard Navigation

If you are not able to locate some of the wizard screens, check the following:

  • Make sure you selected the correct role (ICP/developer, ISP, corporate administrator).
  • Make sure you selected the correct operating system.
  • For Outlook Express customization, verify that you downloaded Outlook Express files and added Outlook Express to at least one of your Setup options.
  • For the Windows Desktop Update, verify that you included it in your IEAK package. If you plan to customize the Windows Desktop Update, your build computer must be running the desktop.
  • On the Feature Selection screen, make sure that all the features you want to customize are selected. Screens for each feature are not displayed if the check boxes for the features are not selected.
  • If you are setting up a silent installation or running the Internet Explorer Customization wizard from the Office Installation wizard, some of the Setup options will not be available.


Troubleshooting the Uninstallation Process

Reference

Troubleshooting Download Problems

Setup has the ability to switch servers during an installation to maintain maximum throughput or recover from a distribution site that is not responding. Switching servers occurs when Setup detects no throughput or less than one byte in two minutes.

If a connection times out, Setup will try to connect to the next download site in the list and continue the setup process at the beginning of the partially downloaded .cab file. If a connection times out and Setup does not switch servers, it will attempt to reconnect to the download site and continue the setup process at the point where it left off. If a connection to the download site cannot be established, Setup asks if you want to abort the installation or try again.


IEAK Examples

The IEAK Examples section in the Table of Contents contains automatic proxy configuration scripts, setup batch files, and a sample .inf file. The section also contains illustrations, which may help you understand some Internet Explorer and IEAK concepts.

You can also find examples, such as sign-up server and add-on pages, in the IEAK Toolkit.


Sample .inf File

;The sample .inf file below performs the following actions:
; - Copies files to the Windows, System, Inf, and Help folders.
; - Makes a number of registry entries (including entries that
; will rename the copied files to long file names).
; - Creates a link on the Help menu.
; - Has an uninstall section that registers the uninstall
; action in the Add/Remove Programs dialog box in Control Panel.
; - Uses replaceable strings to make localization easy.

[Version]
Signature=$CHICAGO$

[DestinationDirs]
SampleCopy = 24,%PROGRAMF%\Sample
SampleDel = 24,%PROGRAMF%\Sample
SampleWinCopy = 25
SampleSysCopy = 11
SampleINFCopy = 17
SampleHLPCopy = 18

[DefaultInstall]
CopyFiles = SampleCopy, SampleWinCopy, SampleSysCopy, SampleINFCopy, SampleHLPCopy
AddReg = SampleRegisterApp, SampleRegUninstall, SampleRenameFiles
UpdateInis = SampleAddLinks

[RemoveSample]
DelFiles = SampleWinCopy, SampleSysCopy, SampleINFCopy, SampleHLPCopy
DelReg = SampleUnRegisterApp, SampleRegUninstall
AddReg = SampleRemoveLFNs
UpdateInis = SampleRemoveLinks

[SampleCopy]
sample.bmp

[SampleWinCopy]
sample.exe

[SampleSysCopy]
sample.dll

[SampleINFCopy]
sample.inf

[SampleHLPCopy]
sample.hlp

[SampleRegisterApp]
;Makes an arbitrary registry entry (for private use of Sample.exe):
HKLM,Software\Sample,Installed,,"1"

[SampleUnRegisterApp]
;Deletes the registry entry (note that this deletes the entire key):
HKLM,Software\Sample

[SampleRegUninstall]
;Adds entry to the Add/Remove Programs dialog box in Control Panel to uninstall the program:
HKLM,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Sample,"DisplayName",,"Sample Application"
HKLM,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Sample,"UninstallString",,"RunDll setupx.dll,InstallHinfSection RemoveSample 4 sample.inf"

[SampleRenameFiles]
;Renames 8.3 file names to long file names:
HKLM,Software\Microsoft\Windows\CurrentVersion\RenameFiles\Sample,,,"%24%\%PROGRAMF%\Sample"
HKLM,Software\Microsoft\Windows\CurrentVersion\RenameFiles\Sample,sample.bmp,,"Sample Bitmap.bmp"

[SampleRemoveLFNs]
;Deletes files with long file names during uninstall:
HKLM,Software\Microsoft\Windows\CurrentVersion\DeleteFiles\Sample,,,"%24%\%PROGRAMF%\Sample"
HKLM,Software\Microsoft\Windows\CurrentVersion\DeleteFiles\Sample,sample.bmp,,"Sample Bitmap.bmp"

[SampleAddLinks]
;Adds shortcut to Sample.exe on the Start menu:
setup.ini, progman.groups,, "Sample=%SampleFolder%" ;creates folder
setup.ini, Sample,, """%SampleDesc%"", %25%\SAMPLE.EXE" ;creates link

[SampleRemoveLinks]
;Removes shortcut to Sample.exe on the Start menu during uninstall:
setup.ini, progman.groups,, "Sample=%SampleFolder%" ;creates folder
setup.ini, Sample,, """%SampleDesc%""" ;deletes link

[SourceDisksNames]
99 = %DiskName%,Sample,0

[SourceDisksFiles]
sample.exe = 1,,13456
sample.dll = 1,,20987
sample.bmp = 1,,64098
sample.hlp = 1,,55441
sample.inf = 1,,5687

[Strings]
PROGRAMF = "PROGRA~1"
SampleFolder = "Samples"
SampleDesc = "Sample Application"
DiskName = "Sample Application Installation Disk"


JavaScript or JScript Auto-Proxy Example Files

The following scripts provide examples of how a .pac file could be used to specify an auto-proxy URL. To use these functions, you must change the proxy names, port numbers, and IP addresses.

Notes

  • The isInNet() ,isResolvable(), and dnsResolve() functions query a DNS server.
  • References to Object Model objects, properties, or methods cause the Proxy Auto-Configuration file to fail silently. For example, the following references - window.open(...), alert(...), password(...) - all cause the Proxy Auto-Configuration file to fail on Internet Explorer.

Example 1: Local hosts connect direct, all others connect via proxy

The following function checks to see whether the hostname is a local host, and if it is, whether the connection is direct. If the hostname is not a local host, the connection is through the proxy (proxy).

function FindProxyForURL(url, host)
  {
    if (isPlainHostName(host))
      return "DIRECT";
    else
      return "PROXY proxy:80";
  }

The isPlainHostName() function checks to see if there are any dots in the hostname. If so, returns false, else returns true.

Example 2: Hosts inside the firewall connect direct, outside local servers connect via proxy

The following function checks to see whether the host is either a "plain" hostname (meaning the domain name is not included) or part of a particular domain (.company.com) but the hostname is not either www or home.

function FindProxyForURL(url, host)
  {
    if ((isPlainHostName(host) ||
       dnsDomainIs(host, ".company.com")) &&
      !localHostOrDomainIs(host, "www.company.com") &&
      !localHostOrDoaminIs(host, "home.company.com"))

      return "DIRECT";
    else
      return "PROXY proxy:80";
  }

Notes

  • The localHostOrDomainIs() function is executed only for URLs in the local domain.
  • The dnsDomainIs() function returns true if the domain of the hostname matches the domain given.

Example 3: If host is resolvable, connect direct, else connect via proxy

The following function asks the DNS server to try to resolve the hostname passed to it. If it can, then a direct connection is made. If it cannot, the connection is made via proxy. This is useful when an internal DNS server is used to resolve all internal hostnames.

function FindProxyForURL(url, host)
  {
    if (isResolvable(host))
      return "DIRECT";
    else
      return "PROXY proxy:80";
  }

See note on the isResolvable() function at the top of the page.

Example 4: If host is in specified subnet, connect direct, else connect via proxy

The following function compares a given IP address pattern and mask with the hostname. This is useful if certain hosts in a subnet should be connected directly and others should be connected via proxy.

function FindProxyForURL(url, host)
  {
    if (isInNet(host, "999.99.9.9", "255.0.255.0"))
      return "DIRECT";
    else
      return "PROXY proxy:80";
  }

See note on the isInNet() function at the top of the page.

The isInNet(host, pattern, mask) function returns true if the host IP address matches the specified pattern. The mask indicates which part of the IP address to match (255=match, 0=ignore).

Example 5: Determine connection type based on host domain

The following function specifies a direct connection if the host is local. If the host is not local, this function determines which proxy to use based on the host domain. This is useful if the host domain name is one of the criteria for proxy selection.

function FindProxyForURL(url, host)
  {
    if (isPlainHostName(host))
      return "DIRECT";
    else if (shExpMatch(host, "*.com"))
      return "PROXY comproxy:80";
    else if (shExpMatch(host, "*.edu"))
      return "PROXY eduproxy:80";
    else
      return "PROXY proxy";
  }

The shExpMatch(str, shexp) function returns true if str matches the shexp using shell expression patterns.

Example 6: Determine connection type based on protocol being used

The following function extracts the protocol being used and makes a proxy selection accordingly. If no match is made on the protocol, then a direct connection is made. This is useful if the protocol being used is one of the criteria for proxy selection.

function FindProxyForURL(url, host)
  {
      if (url.substring(0, 5) == "http:") {
        return "PROXY proxy:80";
      }
      else if (url.substring(0, 4) == "ftp:") {
        return "PROXY fproxy:80";
      }
      else if (url.substring(0, 7) == "gopher:") {
        return "PROXY gproxy";
      }
      else if (url.substring(0, 6) == "https:") {
        return "PROXY secproxy:8080";
      }
      else {
        return "DIRECT";
      }
  }

The substring() function extracts the specified number of characters from a string.

Example 7: Determine proxy setting by checking to see if hostname matches IP address

The following function makes a proxy selection by translating the hostname into an IP address and comparing it to a specified string.

function FindProxyForURL(url, host)
  {
      if (dnsResolve(host) == "999.99.99.999") { // = http://secproxy
        return "PROXY secproxy:8080";
      }
      else {
        return "PROXY proxy:80";
      }
  }

See note on the dnsResolve() function at the top of the page.

Example 8: If host IP matches specified IP, connect via proxy, else connect direct

The following function is another way to make a proxy selection based on specifying an IP address. This example, unlike Example 7, uses the function call to explicitly get the numeric IP address (Example 7 uses the dnsResolve() function to translate the hostname into the numeric IP address).

function FindProxyForURL(url, host)
  {
      if (myIpAddress() == "999.99.999.99") {
        return "PROXY proxy:80";
      }
      else {
        return "DIRECT";
      }
  }

The myIpAddress() function returns the IP address (in integer-dot format) of the host that the browser is running on.

Example 9: If there are any dots in the hostname, connect via proxy, else connect direct

The following function checks to see how many dots are in the hostname. If there are any dots in the hostname, make a connection via proxy. If there are no dots in the hostname, make a direct connection. This is another way to determine connection types based on hostname characteristics.

function FindProxyForURL(url, host)
  {
      if (dnsDomainLevels(host) > 0) { // if the number of dots in host > 0
        return "PROXY proxy:80";
      }
        return "DIRECT";
  }

The dnsDomainLevels() function returns an integer equal to the number of dots in the hostname.

Example 10: Specify days of the week to connect via proxy, other days connect direct

The following function determines the connection type by specifying days of the week that are appropriate for a proxy. Days that do not fall between these parameters use a direct connection. This function could be useful in situations where you might want to use a proxy when traffic is heavy and allow a direct connection when traffic is light.

function FindProxyForURL(url, host)
  {
    if(weekdayRange("WED", "SAT", "GMT"))
     return "PROXY proxy:80";
    else
     return "DIRECT";
  }

The weekdayRange( <day1> [,<day2>] [,<fGMT>] ) function returns whether the current system time falls within the range specified by the parameters <day1>, <day2>, and <fGMT>. Only the first parameter is necessary. The GMT parameter sets the times to be taken in GMT rather than in the local time zone.


UNIX Component and Script Sample

The following example shows how to create a script and cabinet file to prepare a UNIX component for an IEAK package.

  1. Download the compressed component from the Microsoft Web site.
  2. To install the component, create a script named componentname_install.sh. For the IEAK, the script must begin with #!/bin/sh. The script contains the following lines (comments are preceded by the # sign):
    3. #!/bin/sh |
cd $2 | # Argument $2 is the target location of the component ([install_dir]/[target]). Go to the location of the compressed file.
mkdir foldername | # Create an installation folder (you may want to use the component's name).
mv compressed_filename foldername | # Move the compressed file into the installation folder.
cd foldername | # Switch to the installation folder.
gunzip compressed_componentname | # Decompress the component.
chmod +x componentname | # Assign "execute permissions" to this file, so it can be run as a program.
cd $1/bin | # Argument $1 is the installation location. Switch to the Internet Explorer bin folder.
ln -s ../foldername/componentname | # Create a link to the executable program.
  3. Test this script on the UNIX operating system.
  4. Move the script and compressed component to the computer running Internet Explorer 5 and any Windows 32-bit operating system (except Windows NT 3.51) where you plan to run the Internet Explorer Customization wizard.
  5. Create a cabinet file named componentname.cab. Use the following syntax:

    6. "cabarc n componentname.cab compressedcomponent + componentname_install.sh"

  6. Start the Customization wizard and complete the steps for the UNIX platform until you reach the "Add Custom Components" screen in the wizard.
  7. Type the following information:

    8. Component
    componentname

    Location
    The location of the componentname.cab file

    Program
    componentname_install.sh

  8. Complete all of the steps in the Customization wizard.

    9. When you run the wizard, it decompresses the cabinet file, runs the script, and installs your component before it customizes the browser.


Sample Setup Batch File

;Example of a simple Iebatch.txt file that shows install folder choice,
;performs the first listed installation option, and automatically restarts the computer.

[Welcome]
Display=0

[SetupChoice]
Display=0

[Custom]
Display=0
Mode=0
InstallDir=c:\Int_exp\en

[Download]
Display=0
DownloadDir=c:\Int_exp\download\

[Finish]
Display=0

[Reboot]
Reboot=1


Illustrations of IEAK Concepts

The following illustrations show how some key features and concepts work.

  • System Policies and Settings
  • Windows Update Setup for Internet Explorer and Other Internet Tools
  • ISP Sign-up Process
  • How Customization Works
  • Automatic Version Synchronization
  • How Automatic Configuration Works
  • How to Set Up Files for Distribution
  • How the IEAK Generates Custom Packages


Add-on Components

After creating your customized browser package, you'll want to post it to sites where users can download it. You specify these sites in Stage 3 of the Internet Explorer Customization wizard. You can also specify where your users get any new components or component updates. These are called Add-on Components.

When the user clicks Tools and then clicks Windows Update in 32-bit versions of the browser, the browser opens the Add-on Component URL that you specify. This also happens when the user clicks Add/Remove Programs in Control Panel, clicks Internet Explorer 5 and Internet Tools, clicks Add/Remove, and then selects Add a component.

Note

  • The Add-on Component URL you specify should be the full path to Addon.htm (for example, http://myserver/addons/addon.htm).

Sample Add-on Components Web pages

The IEAK Toolkit contains a sample Add-on Components Web page, Addon.htm, which you can customize. This page is located in the \Program Files\IEAK\Toolkit\Addons\HTML folder. This page also links to the files Head.htm, Main.htm, and Info.htm.

The following is a description of the four sample files in the \Toolkit\Addons\HTML folder:

  • Addon.htm: Frameset that references these two files:
    • Head.htm: Header frame for title
    • Main.htm: Main frame with install scripting and link to Info.htm
  • Info.htm: Information about all of the available components

You'll be making most of your changes in Main.htm, which has three parts:

  • Install scripting
  • Table of check boxes, component names, and sizes
  • Setup ActiveX control

Using the sample files

Copy all four sample files to your download location or to the location you specify, then edit them in a text editor or an HTML editor.

For the scripting to work properly, your files must be set up as follows:

  • The IEcif.cab file should be on a Web server. In Main.htm, the L_cab_Address= entry in the <script LANGUAGE="VBScript"> section should point to the same folder location.
  • The table in Main.htm should contain only the components you have downloaded from Microsoft and want to provide.

To add new components

  1. Make sure you have downloaded the components during Automatic Version Synchronization (AVS).
  2. Look up the correct name of the component in IESetup.cif.
  3. Add a check box with that name to Addon.htm.

If you are an expert Web-page author, you may choose not to use the template provided in the IEAK.

Information for expert Web-page authors

Two scripting languages are used in Main.htm: JScript and VB Script. The JScript code contains the function Install(). This function is called when the user clicks the Install button at the bottom of the page. It controls the flow of the install process. The Install() function makes calls to several VB Script subroutines.

The scripts use the name property (part of the input tag) of the check boxes to read the IESetup.cif file. This file is contained in the IEcif.cab file and is opened by the Window_onLoad() subroutine.

Note

  • There may be different names for Windows and Windows NT components. This information can be found in IESetup.cif.

To find out whether a component is already installed, you can use the IsComponentInstalled() VB Script subroutine. Use this syntax:

IsComponentInstalled(ComponentID):
Where ComponentID is the same as the check box name and the value in IESetup.cif.

Return:

  • 0 = Component not installed
  • 1 = Component already installed
  • 2 = Component installed, but newer version available
  • 3 = User security lockout: No status determined

When the first component is checked using this method, the ActiveX engine activates a security dialog box that requests permission to check the status of installed components on the user's computer. If the user chooses "No," then the return for all components is 3.


Managing the Windows Desktop Update

The Windows Desktop Update makes the desktop and folders look and work more like the Web. Although the Windows Desktop Update is not a part of Internet Explorer 5, you can include it with your IEAK package. If your users have Windows 98, then they already have the desktop features.

If you choose to install the Windows Desktop Update, you can customize its settings later in the wizard, if your build computer is running one of the following configurations:

  • Internet Explorer 5 upgraded from Internet Explorer 4.0 with the Windows Desktop Update installed
  • Internet Explorer 5 and Windows 98, which includes the new desktop

This can be helpful in setting a corporate standard desktop.

When the Windows Desktop Update is installed, users can browse their computers just as they browse the Web, and they can browse the Web from nearly anywhere on their computer. They will find the Go and Favorites menus everywhere. They can also add "active content," such as a stock ticker, to their desktop, the taskbar, or folders. And they can single-click files to open and run them.

You can also control whether or not users can change these settings, as well as security and proxy settings. You can specify these settings in Stage 5 of the Internet Explorer Customization wizard or by using the IEAK Profile Manager. Then you can control profiles on an ongoing basis by using the automatic configuration feature.


What to Do After You Run the Wizard

After you click Finish, the wizard builds your custom browser package. In most cases, your next steps will be preparing your files for downloading from the Web, and then preparing other media (such as compact discs) for distribution.

Programs and cabinet files distributed via the Internet, or an intranet that isn't especially configured, for users of 32-bit operating systems must be digitally signed. Digital signatures show where programs come from and verify that programs haven't been altered. For more information, see Signing Your Programs. If you specified that the Internet Explorer Customization wizard will sign your programs and custom files, then the wizard will sign your programs as it builds your package. If you did not specify that the wizard sign your programs and files, then you need to sign them before users download them.

Unlike Internet Explorer 32-bit versions of the browser, 16-bit and UNIX versions of the browser do not perform digital signature verification. Programs or cabinet files for these operating systems do not need to be signed.

The steps you take to distribute your customized browser will vary, depending on your role and the media you plan to use. For more information, click the applicable link below:

  • Corporate Administrator
  • Internet Content Provider (ICP) or Developer
  • Internet Service Provider (ISP)


Animated Bitmap Tools

Before preparing graphics for the logo, you should consult your license agreement to verify that this customization is available.

Two separate tools are included with the IEAK to help you create customized animated bitmaps for your browser:

  • The Animated Bitmap Creator takes a series of sequentially numbered bitmaps and stacks them into one bitmap with the correct form for animation.
  • The Animated Bitmap Previewer allows you to preview the animation of the bitmap. This tool can also be used to display any correctly formatted bitmap.

Be sure to use the correct size and format for the bitmaps. For more information, review Creating Customized Graphics.

Note

  • These tools are provided for the benefit of the administrator and are not to be distributed as supported Microsoft products. Both tools can be found in the \Toolkit\Tools\Animate folder.

Animated Bitmap Creator (Makebmp.exe)

To run this tool, type the following at an MS-DOS command prompt:

makebmp basename numfiles outputname

Where:
makebmp is the executable file
basename is the root file name (without numbers and .bmp extension)
numfiles is the number of bitmaps to sequentially add
outputname is the output file name (you must include the .bmp file extension)

Example
To combine files Bitmap0.bmp through Bitmap19.bmp, you would type the following:

makebmp bitmap 20 final.bmp

Note

The files you use should be numbered sequentially beginning with 0. For example, Iebmp0.bmp Iebmp1.bmp Iebmp2.bmp ... Iebmp24.bmp. When referring to these files, the basename would be Iebmp.

Animated Bitmap Previewer (Animbmp.exe)

You can start the previewer either from an MS-DOS command prompt or from Windows Explorer. After Animbmp.exe is started, there are two ways to preview an animated bitmap: drag the file into the box, or click the File menu, and then click Open. The lead-in frames are shown only once, then the bitmap loops continuously.


Assessing the Installed Size of Internet Explorer

You can use batch-mode switches to pass information about Internet Explorer installation to your custom program. Two key reasons you might want to do this are to display the amount of disk space needed for installing Internet Explorer (dynamically, based on the options the user chooses) and to provide progress information during installation.

When you use the /P switch, this information is stored in the registry during installation. After this information is determined, Setup returns the following information to the HKLM\Software\Microsoft\ActiveSetup\InstallInfo registry branch:

  • String Value - InstallSize=KB (real install size)

  • Binary - AdminRights=1/0

  • String Value - EstimatedCopy=KB (usually larger than InstallSize, because more size is needed for the installation process. Use as an estimate of how the progress information would appear in a "gas-gauge" style estimate.)

Adding components

Office 98 can add components to the installation, even if they aren't already included in one of the setup options that you created in your custom IEAK package. The following command overrides the list specified in the Iebatch.txt file, regardless of the Setup mode:

  • /E:ComponentID,ComponentID

Return codes and status

After an application is installed or its installation fails, Setup needs to report the outcome. Because IE5wzd.exe is packaged inside Ie5setup.exe, return codes can't be passed back directly. Instead, after installation, Setup returns the information in the HKLM\Software\Microsoft\ActiveSetup\InstallInfo registry branch.

Return codes:

String Value - Complete=DWORD reflecting the HRESULT from setup.

  • 0 = Success

Any Failed HResult in this branch means some sort of failure. Here are the return codes that you may see:

  • 0x80100003 = Files are missing for the requested installation.
  • 0x80100001 = Setup succeeded partially. One or more components are not downloaded/installed. Check FailedComponents for the list of components.
  • 0x80100002 = Setup succeeded partially, but the user canceled Setup. One or more components are not downloaded/installed.

For items that were not successfully installed, Setup also returns the following information:

  • MultiSZ - FailedComponents=<Name of Components from CIFID>null<Name of Component...>
  • Binary - InstallStatus=0 install is fine
  • 1= Suspend setup. The user canceled Setup and is asked if he or she really wants to cancel.
  • 2 = No Cancel, resume Setup.
  • 3 = Yes, Cancel confirmed, quit Setup as soon as possible. In some cases, a task in progress, such as copying or extracting files, may need to be completed.


Signing Your Programs

Digital signatures show where programs come from and verify that they haven't been altered. You should digitally sign your customized browser packages and any custom programs to ensure that users don't receive warnings when installing the custom browser. Users may be prevented from installing ActiveX controls and Java packages that aren't signed. You must specify information about your digital certificate when using the Internet Explorer Customization wizard.

If you plan to distribute custom packages for 32-bit versions of the browser over the Internet, you should have the IEAK sign the custom cabinet (.cab) files that it creates. If you plan to distribute your custom packages over an intranet, you should sign the custom files, unless you preconfigure the Local Intranet zone with a Low security setting. The default security setting will not allow users to download programs or code that isn't signed. For more information about security zones, see Internet Explorer 5 Security.

Signing the .cab files and custom programs requires two steps: obtaining a digital certificate and signing the code. You do not need to sign files for 16-bit or UNIX versions of the browser.

You can now use the IEAK to sign your custom packages. You will need to obtain a digital certificate to sign your files with. You will designate the location of the certificate when you run the Internet Explorer Customization wizard, and it will sign the files when the package is created.

These custom files will be signed:

  • Branding.cab
  • Desktop.cab
  • Iecif.cab
  • IE5setup.exe
  • Folder<n>.cab
  • Chl<xxxx>.cab

Notes

  • Folder<n>.cab represents every numbered .cab file beginning with the name Folder, such as Folder1.cab, Folder2.cab, and so on. Chl<xxxx>.cab represents every numbered .cab file beginning with Chl, such as Chl001.cab, Chl002.cab, and so on.
  • You also need to sign any custom programs, in either .exe or .cab format, that you include in your browser package.
  • If you expect your organization to use Automatic Install over the Internet, you must sign the .cab files and specify in the security settings that the server hosting the .cab files is a trusted server, or for an intranet site only, set the security level to Low. For more information about this feature, see Managing Automatic Install.

    If your intranet security level is set to Medium or higher, you must then specify your network servers as trusted servers. To do this, carry out the following steps:

    1. On the Security Settings page in the wizard, click Customize Security Zones settings, and then click Modify Settings.
    2. Select the Local intranet zone, and then click Sites.
    3. Clear the Include all network paths (UNC) check box, and then click OK.
    4. Select the Trusted sites zone, click Sites, type the path for the download server, and then click Add.
    5. Repeat the previous step for every download server that you want to specify as trusted.

How do I obtain digital certificates?

Digital certificates are a part of Authenticode technology, which identifies where programs come from and verifies that programs haven't changed. You can obtain certificates from a certification authority or a privately controlled certificate server. Certificates can be commercial or individual.

For more information about Authenticode and security, see the Microsoft Security Advisor Web site at http://www.microsoft.com/security/.

How do I sign my cabinet files or custom programs?

After obtaining a certificate, you will need to sign the code. Tools for signing code are available from the Microsoft Site Builder Network Workshop.

You will also need to know the public and private keys, which are a matched set of keys created by the software publisher for encryption and decryption. The keys are generated at the time the certificate is requested from a certification authority (CA). They are generated on your computer, and your private key is never sent to the CA or any other party.

What happens when certificates expire?

The expiration of certificates provides an added measure of security. For example, if a university certifies all of its students with digital identifiers (IDs), it can set each ID to expire when the student leaves the university. Code that is signed with an expired certificate is invalid. After the certificate expires, the software publisher needs to resign the code and post new versions of it.

Software publishers can use a time stamp to sign code to prove that the certificate was valid at the time the code was signed. Then the signed code will remain valid even after the certificate expires.

How to use Authenticode to control what end users see

If you're a corporate administrator, you can preconfigure security zones, preset ratings, and customize certification authorities. You can also set system policies and restrictions to control whether users can modify their security settings. For information about specific settings, see Internet Explorer Security Options.

You can ensure that end users receive warnings when they try to view potentially unsafe content. You can also prevent users from downloading unsigned ActiveX controls and Java packages.

When I sign my code, what happens?

The code-signing process is simple and quick. It isn't necessary to know the technical details of how code-signing works to sign your code.

After developing and testing code, a software publisher signs the code file. The publisher uses a signing program, such as Signcode.exe, to hash the code, producing a "digest" of the file. Through the operating system layer, the program encrypts the digest with the private key and combines the digest with the name of the hash algorithm and CA certificate (containing the publisher name, public key, and so on) into a structure called a signature block. The program then embeds the block back into the code file, and the file is ready to be distributed over the Internet. Note that a .cab file that gets signed also contains a signature block.

When the user downloads the file from the Internet, the downloading application calls a verification function. As a result of that call, the operating system extracts the signature block, determines the CA who validated the certificate, and uses the public key to decrypt the digest. The system then uses the hash algorithm indicated in the signature block to create a second digest. If the code has not been modified since it was signed, the new digest should match the old one. If the two digests don't match, either the code was modified or the public and private keys aren't a matched pair. In either case, the code becomes suspect and the user is warned.


Automatic Detection and Configuration of Browser Settings

You can configure your network so that Internet Explorer is automatically customized the first time it is started. This can help reduce administrative overhead and potentially reduce help desk calls about browser settings.

Automatic detection of browser settings, which is based on Web Proxy AutoDiscovery (WPAD), is supported by both DHCP (Dynamic Host Configuration Protocol) and DNS (Domain Name System). With the appropriate settings, DHCP and DNS servers can automatically detect and configure a browser's settings.

This feature builds on existing automatic configuration technologies, in which a browser can be configured from a central location with an automatic configuration URL (.ins file) or a Javascript proxy configuration (.js, .jvs, or .pac) file.

With automatic detection, the browser can now be automatically configured when it is started, even if the browser was not first customized by the administrator. For example, if a user were to download a non-customized browser from the Internet, instead of installing a customized version from the corporate servers, automatic detection can automatically configure and customize the user's browser.

To specify in the IEAK that you want to set up automatic detection of browser settings, select Automatically detect settings on the Automatic Configuration screen of the Internet Explorer Customization wizard.

Automatic Detection of Browser Settings for DHCP and DNS

A DHCP server enables the administrator to centrally specify global and subnet-specific TCP/IP parameters, and to define parameters for clients by using reserved addresses. When a client computer moves between subnets, it is automatically reconfigured for TCP/IP when the computer is started.

DNS is a set of protocols and services on a TCP/IP network that allow users to search for other computers using hierarchical user-friendly names, often known as "hosts," instead of numeric IP addresses.

Using DHCP with automatic detection works best for LAN (local area network)-based clients, while DNS enables both LAN-based and dial-up users to detect their settings. Although DNS can handle network and dial-up users, DHCP provides for faster access to LAN users and allows greater flexibility in specifying configuration files.

To enable automatic detection of browser settings, you need to configure specific settings on DNS servers, DHCP servers, or both.

Enabling automatic detection of browser settings on DHCP

To set up automatic detection of browser settings on a DHCP server, you need to create a new option type with a code number of 252.

The following procedure shows how you can use the Microsoft DHCP Manager running on Windows NT 4.0 to create a new DHCP option; the option can be global or apply to a specific scope. If the Microsoft DHCP Manager is not installed, consult your Microsoft NT 4.0 documentation for instructions on how to install it.

To add a new DHCP option type

  1. On the DHCP Options menu, click Defaults.

  2. In the Option Class list, click the class for which you want to add a new option type, and then click New.

  3. In the Name box, type a new option name.
  4. In the Data Type list, click the String data type.
  5. For the default value of the string, type the URL that points to your configuration file. This file can be a .pac, .jvs, .js, or .ins configuration file.

    Examples:
    http://www.microsoft.com/webproxy.pac
    http://marketing/config.ins
    http://###.#.###.#/account.pac

  6. In the Identifier box, type the code number 252 to associate with this option type.

  7. In the Comment box, type a description.

Enabling automatic detection on DNS

To enable automatic detection of browser settings on DNS, you need to configure either the host record or CNAME "alias" record in the DNS database file.

Host Record

A host record is used to statically associate host (computer) names to IP addresses within a zone. A host record contains entries for all hosts that require static mappings, such as work stations, name servers, and mail servers.

The syntax is: <host name> IN A <ip address of host>

For example:

corserv | IN | A | 192.55.200.143
nameserver2 | IN | A | 192.55.200.2
mailserver1 | IN | A | 192.55.200.51

CNAME Record

These records are sometimes called "aliases" but are technically referred to as "Canonical Name" (CNAME) entries. These records allow you to use more than one name to point to a single host. Using canonical names makes it easy to do such things as host both an FTP server and a Web server on the same computer.

To configure a DNS database file for automatic detection of browser settings

  1. In the DNS database file, enter a host record named wpad that points to the IP address of the Web server that contains the .pac, .jvs, .js, or .ins automatic configuration file.

    Or, enter a CNAME alias named wpad that points to the name (the resolved name, not the IP address) of the server that contains the .pac, .jvs, .js, or .ins automatic configuration file.

Notes

  • After the record is added and the database file is propagated to the server, the DNS name wpad.domain.com should resolve to the same computer name as your server that contains the automatic configuration file.

  • When using DNS, Internet Explorer constructs a default URL template based on the host name wpad.

    For example:

    http://wpad.domain.com/wpad.dat

    Therefore, on the Web server wpad, you must set up a file or redirection point named wpad.dat, which delivers the contents of your automatic configuration file.


Create a Bitmap for the Autorun Splash Screen

These instructions assume that you are starting with 24-bit RGB bitmap files. If your file is not a 24-bit RGB bitmap, you must convert it.

  1. Create a 256-color bitmap image (540-by-357 pixels).

    This bitmap should provide an introduction to the product and should contain labels for the two buttons: one for installing Internet Explorer and one for displaying more information.

  2. In your graphics program, create a working file for your palette. To do this, paste both your background and your button file into a single file. Make sure to paste the files side by side, not overlapping.
  3. Save the file as Palette.bmp.

Note

  • The dimensions of the bitmap are important, because the dialog box will resize to the bitmap dimensions. If the bitmap isn't wide enough, then text in the dialog box may appear clipped.


Using Batch Mode Setup

The Internet Explorer Customization wizard enables you to control functionality and user experience during setup. You can further control the setup process by using a batch file. You can use this method whether Internet Explorer is installed alone or with Microsoft Office.

When installing Internet Explorer 4.0, you could further control the setup process with command-line switches. This method is also supported in Internet Explorer 5, and some new switches are available. To use command-line switches, you typically use the IExpress wizard or another program to package your Setup files.

You can also use a combination of the batch file and the command-line switches. For an example, see Internet Explorer Batch Mode Setup Switches.

In most cases, the batch-file method gives you more control over the installation of individual components and involves fewer steps. The command-line switches are provided for backwards compatibility and to support custom solutions.

Creating the batch file

To create the batch file, use a text editor such as Microsoft Notepad, and name the file Iebatch.txt. For more information, see Batch File Syntax. For an example, see Sample Setup Batch File.

You can use a batch file in two ways:

  • Include it in your IEAK package.
  • Include it with setup when you distribute your custom package.
You create the batch file the same way for both methods.

Using the batch file to modify setup

  • To include the batch file as part of your IEAK package, place it in the \Iebin\<Language>\Optional folder. <Language> represents the language of the version you are creating; for example, English language versions are created in the En folder.
  • If you distribute Internet Explorer over the Internet or an intranet, you can post the batch file to the site where users download Internet Explorer. If you distribute Internet Explorer on other media, such as a compact disc or floppy disk, you can add the batch file to the disk. Place it in the same folder as the Ie5setup.exe file.

To learn more about situations in which batch files are helpful, see Customizing Setup.


What Is a Cabinet File?

A cabinet (.cab) file is a library of compressed files stored as a single file. Cabinet files are used to organize installation files that are copied to the user's system. A large compressed file can be spread over several .cab files.

For a number of years, Microsoft has used .cab files to compress software that was distributed on disks. Originally, these files were used to minimize the number of floppy disks shipped with a product. Today, .cab files are used to reduce the file size and the associated download time for Web content that is found on the Internet or on corporate intranet servers.

One file in the cabinet is typically an information (.inf) file, which provides further installation information. The .inf file may refer to files in the .cab as well as to files at other URLs.

Digital signatures

A .cab file can be digitally signed like an ActiveX Control. A digital signature provides accountability for software developers. The signature associates a software vendor's name with a given file. A signature can be applied to a .cab file using Authenticode™ technology.

You can use .cab files to create a better end-user experience, because multiple files are downloaded and then a single certificate is presented to the user. Information about this technology is available from the Microsoft Site Builder Network Workshop.

When you mark your control "safe for scripting," users know that a script on an HTML page can't use your control to cause harm to their computers or to obtain information they haven't supplied willingly.

When you mark your control "safe for initialization," users know that there's no way an HTML author can harm their computers by feeding your control invalid data when the page initializes it.

Note

  • It is possible to use the code-signing tools to sign entire .cab files using a digital certificate.

Cabinet files and IExpress tools

The IEAK contains a set of tools that help you build cabinet files and work with IExpress technology.

The cabinet format

Each file compressed in a .cab file is stored completely within a single folder. A .cab file may contain one or more folders or portions of a folder. So, even if a compressed file does not fit in one .cab file, it will be placed in one folder that spans multiple .cab files. Such a series of .cab files form a set. Each .cab file contains name information for the logically adjacent .cab files.

The .cab format used for downloading Internet Explorer 5 components from the Internet is a non-proprietary format based on Lempel-Ziv compression.


Collecting Customer Information

Collecting sign-up information from the user involves creating a sequence of HTML pages and uploading them, on demand, from the ISS to the HTTP client. The sequence of pages walks the user through the sign-up process, much like a wizard in a Windows-based program. Although the content and format of the pages are entirely up to you, each page typically includes the following:

  • A form for the user to fill out.
  • Navigation buttons that the user can click to advance to the next page in the sequence or go back to the previous page.
  • A button that the user can click to cancel the sign-up session.

The last page contains an additional button that the user can click to submit the completed sign-up application to the ISS.

To create customer sign-up pages

  1. Use Notepad or FrontPage Express to open the example sign-up page, Home.htm, which is located in the Toolkit\Isp\Server\Scripts\Templates folder.
  2. On the View menu, click Source.
  3. Edit the information as needed.
  4. On the File menu, click Save. The file must be saved in the same folder in which it was originally located.

Note

  • In addition to providing a link to your sign-up server information, you will need to provide a link that enables users who already have Internet accounts to gain access to your custom browser.

Using HTML forms and CGI processing

Creating a wizard-like interface in HTML pages requires that you use HTML forms and CGI processing. Each form gathers information from the user and uses the GET method to pass the information to the CGI processor whenever the user clicks a navigation button.

Each HTML page typically includes a form that contains the following controls:

  • A set of input text controls for collecting customer information.
  • Next and Back navigation buttons.
  • A hidden input control for each navigation button. The hidden controls specify the names of the next and previous HTML pages in the sequence.
  • A hidden input control that contains the session handle.

When the user clicks one of the form's navigation buttons, data from a form is posted to the CGI processor, which accumulates the data in its own database. You have the option of validating the data and posting an edit page to the HTTP client if the data is not acceptable. You also have the option of storing the data in your own database as the CGI processor receives the data, or waiting until the entire sign-up session is completed.

After recording the data, the CGI processor determines which button control initiated the posting and uses that information to construct the next HTML page to upload to the customer's desktop computer. The CGI processor dynamically constructs the next page from an HTML template that contains variable tokens. When the processor parses a variable token such as a $SessionHandle token, it replaces the token in the HTML stream with the appropriate variable value. Finally, the processor writes the dynamically created HTML file to the HTTP client by means of the standard output stream.

Using dynamic HTML provides the ability to preload the form controls with data. This enables the customer to navigate backward and forward through the HTML pages to review or edit previously entered data.

Session handle

The CGI processor uses a unique session handle to identify all transactions belonging to a particular sign-up session. The processor embeds the session handle as a hidden control in the HTML forms that it uploads to the HTTP client. The client returns the handle with each form that it posts back to the CGI processor.

Idle timeout

Because HTTP is a session-less protocol, the only way the ISS can determine whether a sign-up session has been abandoned is by means of an external watchdog process. When a sign-up session is started, the ISS creates a time stamp and registers it in the sign-up database.

The watchdog process scans the database periodically and determines whether a session has exceeded the nominal time allocated for signing up. If so, the watchdog process assumes that the session has timed out and ends the sign-up transaction.


Concluding the Sign-up Session

The customer sign-up session is concluded when the customer either accepts or declines the sign-up agreement by clicking the appropriate button control on the final ISS HTML page.

If the customer accepts the sign-up agreement, the ISS builds an Internet sign-up (.ins) file that contains information about the customer and the ISP, and redirects the HTTP client to this .ins file. A Multipurpose Internet Mail Extensions (MIME) type of "application/x-Internet-signup" has been created for this file. This MIME type is associated with the configuration program on the HTTP client. When it receives data from the .ins file, the HTTP client sends the data stream to the configuration program, which continues with the sign-up procedure. This is the official handoff of responsibility from the ISS back to the HTTP client.

If the customer declines or quits the sign-up agreement, the ISS redirects the HTTP client to an "Abort" .ins file that contains only a "Status=Abort" key. As in the acceptance sequence, this is the end of the sign-up server's responsibility.

In both of these conclusions, the user's decision must be passed to the ISP database. While processing the final CGI request, during which time the Accept or Cancel .ins file is created, any required database processing needed for handling the conclusion of the sign-up transaction should be performed. In the sample sign-up CGI code, for example, the transaction state is set to either "Accepted" or "Canceled." This is the strategic section of code that is provided in this kit; you must adapt this code to your specific database environment.


Establishing a Connection with a Customer's Computer

A potential customer opens a sign-up program that starts Internet Explorer, dials the ISS, and posts an initial CGI request. The ISS then does the following:

  • Accepts the CGI request from the customer's desktop computer (the HTTP client).
  • Creates a local data store for accumulating the information that the customer enters.
  • Assigns a unique session handle that is embedded in all subsequent HTTP transactions with the client.

HTTP is a session-less protocol; however, the ISS operates in a session-oriented mode, using the session handle to identify all transactions associated with the sign-up process for a particular customer. For example, the session handle could be an automatically generated sequence number assigned to this transaction by your database system.

To install the server

  1. Install Microsoft Windows NT 4.0 and include the TCP/IP and Microsoft Internet Information Server 3.0 options. For additional information about installing Windows NT 4.0, see the Windows NT Server Resource Kit.
  2. Install Remote Access Service (RAS). You can use Dynamic Host Configuration Protocol (DHCP) to assign IP addresses automatically or set up a range of static IP addresses. You must enable user accounts for dial-up and set up RAS to receive calls.
  3. When installing RAS, you must enable user accounts for dial-up and to receive calls.

Note

  • If there is no name resolution available when users dial up, then they must use the IP address to access the IIS server.

To create a guest account

  1. Start the User Manager utility and use it to set the default Guest account password to None (that is, no password).
  2. Start the Remote Access Administrator utility.
  3. On the Users menu, click Permissions, and then enable the Guest account for dial-in permission.

To modify the Acc2.ins file

The following entries are generally required for all users and must be added manually to the .ins file. Be sure to review these entries carefully, because no error checking is provided.

Note

There can be cases where these entries will vary by user, typically when different users are serviced by different networks.
Section | Entry | Comment
[Entry] | Entry_Name | May vary for private-label customization
[Server] | All entries |
[TCP/IP] | All entries |
[Custom] | All entries | Not required
[Custom_File] | All entries | Not required
[Scripting] | All entries | Not required
[Script_File] | All entries | Not required

The following entries are user-specific and can be added to the .ins file (except for the Outlook Express entries, which are necessary only if Outlook Express features are provided by the service). The mechanism for placing these entries dynamically in the file varies based on the services available on your server. Usually, user input is required at sign-up. Most servers support some macro mechanism associated with CGI that makes the process easy.

Section | Entry | Comment
[Phone] | All entries |
[User] | All entries |
[Internet_Mail] | Email_Name |
. | Email_Address |
. | POP_Logon_Name |
. | POP_Logon_Password |
[Internet_News] | NNTP_Logon_Name |
. | NNTP_Logon_Password |

For Windows 3.1, all Outlook Express entries must be set or none of the settings will be used.

If users are assigned to different servers, the following entries need to be changed to replace the information entered into the wizard.

Section | Entry | Comment
[Internet_Mail] | POP_Server |
. | SMTP_Server |
. | Domain |
[Internet_News] | NNTP_Server |


Connection Manager Administration Kit

The Connection Manager Administration Kit (CMAK), which is included in the IEAK, is a wizard that guides you through customizing and configuring the Microsoft Connection Manager dialer. The CMAK creates a self-extracting executable (*.exe) file that installs itself on your user's computer. Then when your user clicks the custom icon to connect to the Internet, the custom dialer dialog box that you created appears.

You can create a customized dialer to provide users with a quick and easy way to connect to the Internet and to a corporate private network. With the CMAK, you can use your own custom icons, tailored help files, and special animated graphics to control the look of your Connection Manager dialer.

You can also control the functionality of Connection Manager. For example, Connection Manager supports Connect Actions. Connect Actions are small executable programs that start when the dialer connects to or disconnects from the Internet or a corporate private network. You can use Connect Actions to differentiate your service and simplify connection by automating tasks for your users.

If you've already created a custom profile by using the CMAK, you can import it while you are using the Internet Explorer Customization wizard. Or, you can start the CMAK while you are using the Customization wizard, and then create a custom profile for that IEAK package.

For more information, see online Help in the Connection Manager Administration Kit.


Internet Explorer Browser and Components

You can include many Internet components from Microsoft and other companies with the Internet Explorer browser. The Internet Explorer Customization wizard makes it easy for you to see the latest software that's available for downloading. The custom package makes it easy for users to install these components, along with your custom programs, when they install the browser.

The components range from Web authoring tools to multilanguage support. They are continually updated; the latest list appears in the Customization wizard, as long as you have an Internet connection.

For information about the latest product updates, visit the Windows Update site.


Using Proxy Selection and Proxy Bypass Lists

Using a proxy server can allow the administrator to limit access to the Internet. You can specify the proxy server in the Internet Explorer Customization wizard, in the IEAK Profile Manager (formerly the INS Editor), and through the browser. You can also restrict the ability of the user to change the proxy settings via the Restrictions page in the Customization wizard and the Profile Manager.

Note

  • The proxy bypass feature may eliminate the need for using JavaScript or JScript to select a proxy.

To configure the proxy selection and proxy bypass settings

  1. Click the Tools menu in Internet Explorer, and then click Internet Options.
  2. Click the Connections tab, and then click LAN Settings.
  3. In the Proxy Server area, select the Use a proxy server check box.
  4. Click Advanced, and then fill in the proxy location and port number for each Internet protocol that is supported.

    Note
    In most cases, only a single proxy is used for all protocols. In those cases, enter the proxy location and port number for the HTTP setting, and then select the Use the same proxy server for all protocols check box.

    The proxy locations that do not begin with a protocol (such as "http://" or "ftp://") are assumed to be a CERN-type HTTP proxy. For example, the entry "proxy" would be treated the same as the entry "http://proxy." For FTP gateways, such as the TIS FTP gateway and the WinGate Win95 Modem FTP proxy, the proxy should be listed with the protocol "ftp://" in front of the proxy name. For example, you would enter an FTP gateway "ftpproxy" as "ftp://ftpproxy."

  5. To bypass more complex addresses, type the addresses in the box labeled Do not use proxy server for addresses beginning with:.

    A proxy bypass entry can begin with a protocol type, such as http://, https://, ftp://, or gopher://. If a protocol type is used, the exception entry applies only to requests for that protocol. Note that the protocol value is not case sensitive. Multiple entries should be separated by a semicolon (;).

    Next, an Internet address, an IP address, or domain name must be entered. If no protocol is specified, any request using the address will be bypassed. If a protocol is specified, requests with the address will be bypassed only if they are of the indicated protocol type. As with the protocol type, address entries are not case sensitive.

    Finally, a port number can be added. If it is used, the request is processed only if all previous requirements are met and the request uses the specified port number.

    The exception dialog box allows a wildcard character ( * ) to be used in the place of zero or more characters.


Designing Toolbar Icons for Internet Explorer 5

To create a toolbar icon, you will need to provide each image in two sizes for two toolbar states (grayscale for the default state and color for the active state, when the user's mouse is pointing to it), and in two color depths. The following is a summary of the images that are needed:

  • One 20-pixel-by-20-pixel color image (256-color Windows half-tone palette)
  • One 20-pixel-by-20-pixel gray image (256-color Windows half-tone palette)
  • One 20-pixel-by-20-pixel color image (16-color Windows palette)
  • One 20-pixel-by-20-pixel gray image (16-color Windows palette)
  • One 16-pixel-by-16-pixel color image (16-color Windows palette)
  • One 16-pixel-by-16-pixel gray image (16 color Windows palette)

These images would look like the following:

Images needed for icons

Designing toolbar icons

Here are some general points to keep in mind when designing toolbar icons:

  • Make sure the visual transitions between your default and active images are smooth. An easy way to test this is to create separate layers for the default and active images in a photo imaging program so that you can view the images on top of each other.
  • When you design 16-color icons, use the Windows 16-color palette. For both the default and active states, there should be a black border around the icon. Exceptions are where the readability of the image may be affected, such as for an arrow or an "X." The images should have little shading and appear flat.
  • When you design 256-color icons, use the Windows half-tone palette. For both the default and active states, the icons should have icon-style borders with gray or color top and left borders and black bottom and right borders. They can have more shade and visual depth than 16-color images, with a light source from the upper left and shading where appropriate.

Creating .ico files

You will need to create two .ico files for one icon:

  • The first .ico file contains the active images (color) in both sizes and color depths.
  • The second .ico file contains the default images (grayscale) in both sizes and color depths.

It is recommended that you use a graphics program to draw your icons and a development environment, such as Microsoft Visual C++ Development Studio, to create the .ico files.

The two icon files would contain the following graphics:

Drawing your images

  1. After drawing your images in a graphics program, place the 16-color and 256-color images in separate files.
  2. Index each file to the appropriate palette, either the Windows 16-color palette or the Windows half-tone palette.
  3. Save each file as a .bmp.

Creating your icon files in Visual C++:

  1. Open each .bmp file.
  2. On the File menu, click New, and then click Icon. By default, the icon window that opens displays a standard 32-pixel-by-32-pixel device image.
  3. In the Icon window, click New Device Image. Click Custom, and then create these image devices:
    • One 22-pixel-by-20-pixel 16-color image
    • One 22-pixel-by-20-pixel 256-color image
    • One 18-pixel-by-16-pixel 16-color image

    Note that the device images are two pixels wider than the images, which reflects the actual width of the button. Center your images in the device image area.

  4. Delete the default 32-pixel-by-32-pixel device image.
  5. Copy and paste the color images from your .bmp files into the appropriate device image size and color depth.
  6. To make the background transparent, select the transparent color in the color palette and fill the background of each image where you want transparency.
  7. Save this file as an .ico file.
  8. To create your default (grayscale) .ico file, follow the same steps.


 System Policies and Settings


 Internet Explorer 5 Setup


 ISP Sign-up Process


 How Customization Works


 Automatic Version Synchronization


 How Automatic Configuration Works


 How to Set Up Files for Distribution


 How the IEAK Generates Custom Packages


What Is a Globally Unique Identifier?

A globally unique identifier (GUID) is an identifier that distinguishes one program or object from another. When using the IEAK, you can generate a GUID for your custom program.

A GUID, sometimes known as a UUID (universally unique identifier), is generated using an algorithm defined by the Open Systems Foundation to guarantee uniqueness.

The number is based on various identifiers, such as the time of day, and system information. The same number is never produced twice. If your computer contains a network card with a 48-bit IEEE network card hardware address, this globally unique address will be incorporated into the GUID. Otherwise, a random pseudo-address is created from computer-state information.


Hardware and Software Requirements

You must build the UNIX, 16-bit, and 32-bit IEAK packages from a computer running Internet Explorer 5 and any Windows 32-bit operating system (except Windows NT 3.51).

Before you start the Internet Explorer Customization wizard, check the amount of disk space that is available in the Program Files folder and on the destination drive (where you build your customized package). The destination drive can be, but isn't required to be, on the same computer.

When you build IEAK packages, you need to add the following to the system requirements for Internet Explorer:

  • Depending on the number of components you download, you will need up to 100 MB of disk space.
  • For every custom package you generate, you could need an additional 100 MB of disk space. When you build a package for a different media type, such as CD-ROM, it is considered to be a separate package.

For hardware and software requirements for specific versions of Internet Explorer, see the readme files for those versions.

Windows NT 4.0 computers must also be running Service Pack 3 (or higher) On Windows NT 4.0, you must have administrative privileges to install and uninstall Internet Explorer. This includes having administrative privileges the first time users start their computers after installing or uninstalling Internet Explorer.


Creating the Name and Address Screen for ICW Sign-up

When the user connects to your sign-up server, the first page the user sees on the sign-up server is the name and address page.

The name and address HTML section is displayed in a frame within the wizard. The frame is 444 pixels wide by 273 pixels high. Scroll bars do not appear if the HTML page exceeds these dimensions.

For information about HTML design and required form elements, see HTML Page Design.


Creating the Billing Options Screen for ICW Sign-up

On the Billing Options page, you can present the service billing options from which the user can choose. The options are presented using an HTML form within a frame in the wizard window.

The user should be able to select an option using an HTML radio button, and one of the radio button options must be selected by default. If the user needs to make multiple selections, you can also include HTML check boxes in the frame.

The billing option HTML file that you supply is displayed in a floating frame within the wizard. The frame is 444 pixels wide by 273 pixels high. Scroll bars do not appear if the HTML page exceeds these dimensions.

For information about HTML design and required form elements, see HTML Page Design.


Creating the Method of Payment Screen for ICW Sign-up

The Payment Methods page is where users specify how they want to pay for the Internet service. Each ISP controls which payment methods are available in the payment method list. The information is collected in the form that appears in a frame below the selection, which changes depending on the payment option selected in the list.

You can choose to offer any type of payment method:

  • Credit card (you can specify the type of card, such as Visa or American Express)
  • Debit card
  • Invoice
  • Phone bill charges

For information about HTML design and required form elements, see HTML Page Design.


Creating the ISP Account Login/E-mail Screen for ICW Sign-up

The fourth page on the sign-up server is the Account Login/E-mail page, which enables the user to select an account login and/or e-mail ID and password.

The Account Login/E-mail HTML page that is sent by your sign-up server is displayed in a floating frame within the wizard. The frame is 444 pixels wide by 273 pixels high. Scroll bars do not appear if the HTML page exceeds these dimensions.

For information about HTML design and required form elements, see HTML Page Design.


Creating the ISP POP Selection Screen for ICW Sign-up

The POP selection page is where the user selects a local phone number for Internet access.

The POP Selection HTML page that is sent by the ISP's sign-up server is displayed in a floating frame within the wizard. The frame is 444 pixels wide by 273 pixels high. Scroll bars do not appear if the HTML page exceeds these dimensions.

The user should not be asked to enter an area code or phone number a second time. Any area code or phone number fields in the frame should be pre-populated using the information already sent to the ISP's sign-up server from the Name/Address form.

For information about HTML design and required form elements, see HTML Page Design.


Creating the ISP Terms and Conditions Screen for ICW Sign-up

The ISP Terms and Conditions page is where the ISP shows the legal agreement the user must read to subscribe to the service. To ensure that the user accepts the agreement, the Next button of the ICW is not available until the user clicks I accept the agreement.

The user can save the terms HTML for viewing later by clicking on the Save Copy button. When they click the button they will be prompted for a filename and path to save the file to. The actual terms HTML file from the ISP's sign-up server will be saved to that location.

The Terms and Conditions HTML page that is sent by the ISP's sign-up server is displayed in a floating frame with a 2-pixel border within the wizard. The frame's width is 426 pixels (without the 2-pixel border and vertical scroll bar). A horizontal scroll bar does not appear if the HTML page exceeds the width dimension.

The Terms and Conditions page should begin with the document's title and instructions explaining how the user can find a copy of the legal document on the ISP's Web site if they want to view it again or print it.

For information about HTML design and required form elements, see HTML Page Design.

Note

  • There are no accessibility requirements for this page because no HTML form elements are allowed on the page.


Using ICW Auto-Config for ISP Sign-up

ICW Auto-Config enables users who already have an Internet account with an Internet service provider to have an account setting automatically reconfigured. When users buy a new computer, this feature helps them configure it for the same Internet account they had on a previous computer or on a computer at work. It also helps users whose Internet settings become corrupted. The Auto-Config feature restores their settings; the user needs to know only the user ID, password, and POP server.

In a custom version of Internet Explorer, the user reaches the automatic configuration server from the Internet Explorer CD by clicking a link on the Icwsign.htm page. This link connects the user to the Auto-Config registration server. After the user is connected to your sign-up server, you can ask for the user name, password, and POP server. With this information, you can send an .ins file to the user's computer to reconfigure the user's account.

Two methods for supporting ICW Auto-Config

There are two models you can use to restore user accounts using Auto-Config:

  • Ask the user for the user name, password, and POP server. This should be sufficient information for you to re-create the .ins file, send it to the user, and reconfigure the account. If you are concerned about abuse of this feature, you might want to re-collect the user's credit card number and run a check against the registration database.
  • Store .ins files with the rest of the user's account information. When a user connects to the Auto-Config server, the user can obtain the .ins file by providing only the user name and password. The Auto-Config server would then look up the user's account and deliver a copy of the user's original .ins file. As with the previous model, if you are concerned about abuse of this feature, you might want to re-collect the user's credit card number and run a check against the registration database.

To set up ICW Auto-Config, follow the Coding and Accessibility Requirements for Internet Connection Wizard Sign-up and design the ISP account login/e-mail page, the ISP POP selection page, and the ISP finish page.

Working with the sample sign-up files

If you want to simulate the Auto-Config process before creating your own files, you can use the sample files from the IEAK Resource Kit. To do this, carry out the following steps:

To work with the sample sign-up pages for Auto-Config
  1. Create a directory named Autocfg in the wwwroot directory on your server.
  2. Copy the files from the Resource Kit to the Autocfg directory.
  3. In the files, change all the references to point to your sign-up server.
  4. In the HTML code of the sign-up server pages, change all the references from Acme ISP to your organization's name.
  5. Modify the last sign-up server page to reflect your .ins settings.

The following sample files can give you a general idea of how the sign-up process works and the type of information that you'll need to provide.

  • ISP account login/e-mail page: This is the first page on the Auto-Config server, which asks the user to provide the account login and/or e-mail ID and password. It is similar in design to the ISP Account Login/E-mail Page for traditional ICW sign-up.
  • ISP POP selection page: The POP selection page is where the user selects a local phone number for Internet access. After the user provides this information, the ISP should have sufficient information to re-create the .ins file. It is similar in design to the ISP Account Login/E-mail Page for traditional ICW sign-up.
  • ISP finish page: This is the last page of the Auto-Config account restoration. The text provided by your HTML page is purely informational with no visible form elements. The check box and text at the bottom of the page are provided by the ICW. If the user selects the check box and clicks Next, then the HTML code from your sign-up server shown on this page is saved to the user's desktop as an HTML file. The user can refer to this file to remember passwords or service information.

    You can decide whether or not you want to display the Save Information check box and text. By default, it is not shown. To turn on the check box, add the following form type to the finish page HTML code:

    <FORM NAME=PAGEFLAG ACTION=1></FORM>


Coding and Accessibility Requirements for Internet Connection Wizard Sign-up

The new ICW-mode sign-up mechanism in the IEAK is based on the idea that an Internet sign-up server should look and act like a standard Windows wizard. Although the ICW uses the power and flexibility of HTML, it does not use the same formatting as HTML.

This means the HTML pages in the wizard use the Windows system colors and fonts and also must meet accessibility requirements. Unless otherwise specified, the wizard HTML pages cannot contain any special HTML formatting such as tables with visible borders, images, or anchors. Only plain text and form elements (where required) are allowed. Tables with invisible borders can be used for layout.

To match the user's system colors, all HTML pages except the Icwsign.htm page should contain no color or font attributes unless otherwise specified. The parent wizard defines font styles and colors to match the user's system.

The only requirement for implementing forms within the HTML pages is that the forms use the NAME parameters in the <FORM> elements defined in the specification. You can specify all token names for other elements in your HTML pages and they will be posted to your sign-up server.

Back and Next button functionality

ICW-mode sign-up has specific requirements that must be met in order for the Back and Next buttons in the Internet Connection wizard to work correctly.

Back button

For the Back button to work properly, you must add a FORM element to the sign-up server page that specifies the URL of the Back button. To retain the data previously collected in the sign-up process, you must append all data that you would like to retain to the URL used for the Back button.

The following is the FORM element required for the Back button to send the user to the previous page of the sign-up process. Note that the data is appended to the URL in name/value pairs:

<FORM NAME="BACK"
ACTION="http://myserver/page2.asp"?firstname=bob&lastname=smith&address=..."></FORM>

Note

  • The NAME element and its value must be in all caps because the ICW is case-sensitive.

Next button

For the Next button to work properly, you must add a FORM element to the sign-up server page that specifies the URL of the Next button. For the data collected to be passed to the next page in the sign-up process, you must add hidden form fields on each of your sign-up server pages that contain the data elements collected on this and all previous screens. The URL you reference must contain code that collects the data from the previous page and displays the next page of the sign-up process.

The following is the FORM element required for the Next button to send the user to the next page of the signup process:

<FORM NAME="NEXT" ACTION="http://myserver/page2.asp"></FORM>

The sample sign-up server code included in the IEAK already conforms to these requirements.

Accessibility

To ensure that the elements on the page are accessible by using only the keyboard, each form element should meet the following requirements:

  • An access key (hotkey) must be associated with it. Use the Internet Explorer ACCESSKEY= parameter in the <INPUT> tag. The access key character should be highlighted with an underline using the <u> tag. The letters b, f, g, n, and o are reserved for the ICW and cannot be used as access keys. For more information about the ACCESSKEY parameter, see the Microsoft Site Builder Network Workshop.
  • Each element on the page must be part of the ICW TAB-key order. To be included in the ICW TAB-key order, the element must have a unique ID in the <INPUT> tag.
  • Each element should have a label associated with it. To associate a label for the different HTML form input types, use the Internet Explorer LABEL= parameter.

The following is an example of a radio button form element that meets these accessibility requirements:

<input ID="option2"
type="radio"
name="billing"
value="hour"
accesskey="h"
checked
>
<label for="option2">
5 <u>H</u>ours per month for $10.
</label>


HTML Page Design

Each page of the Internet Connection wizard should have the following design elements and adhere to the following design conventions.

Style sheet

Do not specify any font style or color attributes. The parent wizard sets these attributes. If you use a <TABLE> tag in your error pages, the tag must include the following style:

<TABLE style="font: 8pt 'ms sans serif' buttontext"> </TABLE>

Special notes

Only text and HTML form elements are allowed. No images, hyperlinks, or scroll bars are allowed.

Required form elements

This page must include four HTML <FORM> elements to specify different page properties:

  • The unique PAGEID for the page. The NAME of the form must be "PAGEID" (case sensitive). The ACTION attribute of the form must be a unique ID that does not match the PAGEID of any other page in the ISP section of the wizard (for example, <FORM NAME="PAGEID" ACTION="page4"></FORM>).
  • The Back button function. The NAME for the form must be "BACK" (case sensitive). The ACTION attribute for this form should be the absolute URL for the previous page (for example, ACTION="HTTP://signup/bin/page1.cgi"); however, no data is posted to this page.
  • The characteristics of the page. The form is identified with the NAME "PAGETYPE" (case sensitive). Because this is a standard frame where the ISP defines the entire space, the form's ACTION attribute must be an empty string (for example, ACTION="").
  • The Next button function. The NAME for the form must be "NEXT" (case sensitive). This is the form that contains the actual form elements to be sent back to the ISP's sign-up server. There are no restrictions on the token names for the <INPUT> elements within the form. The ACTION attribute for the form should be the absolute URL where the form information should be posted. The URL that you post to on your server should contain a script that receives the data and then displays the next HTML page of the wizard.


Working with the ICW Sample Sign-up Files

If you want to simulate the sign-up process before creating your own files, you can use the sample files from the IEAK Resource Kit. The sample files can give you a general idea of how the sign-up process works and the type of information that you'll need to provide.

To do this, carry out the following steps:

  1. Create a directory named Signup in the wwwroot directory on your server.
  2. Copy the files from the Resource Kit to the Signup directory.
  3. In the files, change all the references to point to your sign-up server.
  4. In the HTML code of the sign-up server pages, change all the references from Acme ISP to your organization's name.
  5. Modify the last sign-up server page to reflect your .ins settings.


Creating Icwsign.htm, Error Pages, and the Finish Page for ICW Sign-up

For ICW sign-up, you should design the initial screen the user sees, Icwsign.htm, error pages, and the finish page.

The first screen: Icwsign.htm

The first screen the user sees after installing Internet Explorer 5 and restarting the computer is the branded Icwsign.htm page. On the Icwsign.htm page, the user sees a welcome from the ISP and is asked to either: (a) click Next to begin the sign-up process if there is only one ISP file needed for sign-up; or (b) select the city and state being dialed from, so that the ICW can select the appropriate sign-up server ISP file to use.

When the user clicks Next, the ICW dials and connects the user to the ISP sign-up server. This page is specified in the IEAK and is included in your build of Internet Explorer 5. It is not hosted on your sign-up server.

Error pages for ICW sign-up

If the data submitted to the sign-up server is invalid at any time during the sign-up process, the server can display an HTML page with a friendly error message. An example would be if the user requests an e-mail name that is already in use.

The error HTML page that is sent by the ISP's sign-up server is displayed in a floating frame within the wizard. The frame is 444 pixels wide by 273 pixels high. Scroll bars do not appear if the HTML page exceeds these dimensions.

The frame should contain text that lets the user know the data entered was invalid and provides the form elements required for the user to enter new data.

For information about HTML design and required form elements, see HTML Page Design.

Finish page for ICW sign-up

When the user clicks Next on the ISP finish page, the .ins file is processed and the computer is configured for the new Internet account. After this is done, the ICW displays its final page, which informs the user that the Internet connection is ready and tells the user how to begin browsing the Internet. There is no ISP-configurable interface on this page.

The finish page also provides the option of beginning browsing immediately when the user selects the Begin browsing immediately check box.

you can use the StartURL value in the .ins file to specify the page the browser displays when it first opens.

Using the .ins file to configure a referral user's computer

After the user has finished the sign-up process, your sign-up server must return information about how to configure the user's computer for Internet access. The .ins file, downloaded at the end of your sign-up process, contains this information.


Find More Information on the Internet

You can find additional information and manage your IEAK account on the Internet.

For more information, see the IEAK Web site. This Web site is updated frequently, so you should check back often for the latest information.


IExpress Technology and the IExpress Wizard

IExpress is a technology designed to simplify the setup process. Using the step-by-step IExpress wizard, it is now possible to create self-extracting cabinet (.cab) files that automatically run the Setup program contained inside.

The Setup program can be an .inf file, an executable program, or a set of commands. IExpress .cab files automatically remove setup files after installation, saving the user time and frustration.

The IExpress wizard can help you carry out specialized installations of your customized browser package, such as determining whether the computer will need to be restarted after installation. You can find the IExpress wizard (IExpress.exe) in the \Program Files\IEAK\Tools folder. Certain choices you make in the wizard correspond to batch mode setup switches.

To create an IExpress setup package, you first start with a Self-Extraction Directive (.sed) file to store information about your package. When you run the IExpress wizard, you can start with an existing .sed file or create a new one by using the wizard. The .sed file contains information and instructions about the Setup package.

To build a self-extracting executable file with IExpress, copy the Wextract.exe and Advpack.dll files from the Iebin\<lang>\Optional folder to the \IEAK\Tools folder (where the Iexpress.exe, Makecab.exe, W95inf32.dll, and W95inf16.dll files are located).

The following are some general features of IExpress technology:

  • Silent, hands-free installation of Internet Explorer 5.
  • Support for upgrading without having to remove a previous installation.
  • Support for refreshing, or installation over, the same build.
  • Installation without having to restart computers running Windows 95 OSR2.

IExpress technology is powerful and flexible. The following are some of the settings you can specify:

  • Determine whether the self-installing package is for administrators or general users.
  • Set multiple ways of running the embedded install command, such as normal or silent modes.
  • Determine whether the IExpress dynamic-link libraries (.dll files) on a user's computer are updated if they are older than the current ones.
  • Specify target versions, such as the operating system version range, the browser version range, or any application version range (identified by one or multiple file versions) that the package is compatible with.
  • Determine, in batch mode, whether to warn the user when another copy of the package is running, block two packages from running at the same time, or not do anything.
  • Update and add files to the IExpress package with the UPDFILE tool without having to rebuild the package.
  • Replace Runonce with RunOnceEx (if the newer version of Iernonce.dll exists), giving the author control over the job executing order and status display.
  • For the Windows platform, integrate the IEAK with Setup for Internet Explorer and Other Internet Tools to eliminate the problems associated with a single 10-MB download. Setup for Internet Explorer and Other Internet Tools, which downloads .cab files, is not available on the UNIX platform.
  • Provide a mechanism for corporate administrators to set up any necessary support for roaming users.
  • Enable ICPs and ISPs to generate packages that include preconfigured desktops that present custom content to the user.
  • Provide support for multiple download sites.
  • Provide support for internal and external development, customization, expandability, and enhanced debugging.
  • Save disk space through hard-disk cleanup (Recycle Bin, Occache, Wininet cache, Temp folder) during Setup, uninstall, and maintenance mode.
  • Provide support for the Non-SBCS extended character set.
  • Support the new .inf file Internet format.


Extensions to Windows Setup

You can extend Windows Setup in three ways:

  • Execute Windows .inf files from the command line using Rundll.exe.
  • Install optional Windows software components from 32-bit program code as an alternative to the user installing software from the Add/Remove Programs dialog box in Control Panel.
  • Create an icon on the Windows desktop that the user can click to run an .inf file; this eliminates the need to develop installation program code.

Executing .inf files from a command line

You can use the Windows Rundll.exe or Rundll32.exe system commands to execute an Install section in an .inf file. The syntax of the command line is as follows:

RunDll setupx.dll,InstallHinfSection <section> <reboot-mode> <inf-name>

The <section> parameter is an Install section in the .inf file. For example, the following command line installs the Games optional component and, if Setup determines that restarting the computer is necessary, asks users if they want the computer to restart immediately after the installation is complete. (The meaning of the <reboot-mode> parameter values is described in "Using the reboot mode parameter," below.)

RunDll setupx.dll,InstallHinfSection games 4 applets.inf

Notes

  • This command assumes that the disk space required to install any files is available. It does not do any disk space checks.
  • Your installation application must not have any code to execute after the RUNDLL or RUNDLL32 call is made, because once Setupx.dll has control, it may cause the computer to restart. If your installation process requires other code to run after your code makes the RUNDLL or RUNDLL32 call, use the RunOnce list in your .inf file.
  • Do not use the RunOnce list to run the Optional Component that you are installing.

Using the reboot mode parameter

There are five reboot modes:

define HOW_NEVER_REBOOT 0
define HOW_ALWAYS_SILENT_REBOOT 1
define HOW_ALWAYS_PROMPT_REBOOT 2
define HOW_SILENT_REBOOT 3
define HOW_PROMPT_REBOOT 4

If <inf-name> specifies your .inf file instead of a Windows .inf file, add 128 to the values shown above. In the example above that installs the Games optional component, <reboot-mode> is set to 4. This is because Applets.inf is a Windows .inf file. If you were installing an optional component that has its own .inf file, you would set <reboot-mode> to 132. If you add 128 to the <reboot-mode> parameter, then all the files you are installing must be in the same folder location as your .inf file on the installation disk.

Note

  • The only recommended values for <reboot-mode> are 4, if the .inf file is a Windows 95 .inf file, or 132 if the .inf file is provided by you. Using any of the other values shown above may cause the computer to be restarted unnecessarily or cause the computer not to be restarted when it should be.

The following list describes each reboot mode:

NeverReboot
Set <reboot-mode> to 0 or 128. Whatever happens, the computer will not be restarted. It's up to the client to determine whether the computer should be restarted. For Setup, this means there is a file C:\Windows\Wininit.ini that is not zero bytes in size.

AlwaysSilentReboot
Set <reboot-mode> to 1 or 129. The user will not be prompted to restart the computer, and the computer will always restart.

AlwaysPromptReboot
Set <reboot-mode> to 2 or 130. The user will always be prompted about whether or not they want to restart the computer. Setup does not attempt to determine if restarting the computer is necessary.

SilentReboot
Set <reboot-mode> to 3 or 131. If Setup determines that the computer needs to be restarted, there is no user interaction.

PromptReboot
Set <reboot-mode> to 4 or 132. If Setup determines that the computer needs to be restarted, it prompts the user with a dialog box.

Return to top of file

Installing optional components from 32-bit application code

After Windows is installed on a computer, it may be necessary to add one or more of the Windows optional components (for example, Games). This type of installation, which occurs after Setup initially installs Windows, is called maintenance-mode setup. Typically, maintenance-mode setup is initiated from Windows by clicking the Add/Remove Programs icon in Control Panel. However, an alternative is available to vendors and suppliers of the optional software component: they can install the optional component using a CreateProcess call in a 32-bit application.

Note

  • The CreateProcess method of installing an optional component described below must be used only in 32-bit applications.

To install an optional component from a 32-bit application, use a combination of the methods described below.

Checking the registry

First, check the registry to see whether the optional component is currently installed (or look for the files). The registry key location of information about all the currently installed optional components is as follows:

[HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\SETUP\OptionalComponents]

There will be values under this key that point to subkeys, and each subkey contains information about the optional components installed, as well as information needed to install a new optional component. For example, suppose you want to install Games as an optional component. To see whether Games are installed, look for the following subkey value under the OptionalComponents key:

"Games"="Games"

Then open the "Games" key under the optional components key to find the following:

[HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\SETUP\OptionalComponents\Games]
"INF"="applets.inf"
"Section"="games"
"Installed"="0"

This shows that the Games optional component is not installed on this Windows computer, because the "Installed" flag is set to 0.

Coding a CreateProcess function call

To install an optional component such as Games, use the "INF" and "Section" values in the above key in a CreateProcess call that runs Setupx.dll via RUNDLL. This does exactly what Add/Remove Programs in Control Panel does when it installs a component. The syntax of the lpCommandLine parameter in the CreateProcess call is as follows:

RunDll setupx.dll,InstallHinfSection <section> <reboot-mode> <inf-name>

The values of the <section> and <inf-name> parameters are those found in the registry key described above. For example, the following CreateProcess call installs the Games optional component and, if Windows Setup determines that restarting the computer is necessary, asks the user whether they want the computer to restart immediately after the installation is complete. (The meaning of the <reboot-mode> parameter values is described in the section "Using the reboot mode parameter," below.)

RunDll setupx.dll,InstallHinfSection games 4 applets.inf

Note

  • It is recommended that available disk space be checked before installing the component. When checking for available disk space, consider that there must be disk space for system swap files.

Your installation application must not have any code to execute after the CreateProcess call is made, because once Setupx.dll has control, the additional code may cause the user's computer to restart. If your installation process requires other code to run after your code makes the CreateProcess call, use the RunOnce list in your .inf file.

Note

  • Do not use the RunOnce list to run the Optional Component that you are installing.

Running an .inf file by right-clicking it

Setup recognizes a particular install section name, DefaultInstall, in .inf files that install Optional Components. If you use a [DefaultInstall] section in your .inf file, the user can right-click a file icon for the .inf file in the user interface of 32-bit Windows versions to run the [DefaultInstall] section. (After the user right-clicks on the .inf file icon, a popup menu will be displayed from which the user must select the Install option in order to actually run the [DefaultInstall] section.

Using an install section named [DefaultInstall] in your .inf file provides a convenient method of installing your Optional Component. This is particularly useful during development of your application. If you are going to write an installation application, you have a method for installing your optional component before you develop the installation application code.

The following is an example DefaultInstall section that contains typical entries:

[DefaultInstall]
CopyFiles=QCD.copy.prog, QCD.copy.hlp, QCD.copy.win, QCD.copy.sys, QCD.copy.inf
UpdateInis=QCD.Links
AddReg=QCD.reg, QCD.run
Uninstall=FlexiCD_remove


Setup Information File (.inf) Definition

A basic .inf file contains the following sections (more complex .inf files may have additional sections). Bold section names are reserved keywords. Italicized section names are arbitrary names created by the .inf author:

  • Version section
  • Install sections
  • Copy File sections (CopyFiles)
  • Rename Files sections (RenFiles)
  • Delete Files sections (DelFiles)
  • Update .ini File sections (UpdateInis)
  • Update .ini Fields sections (UpdateIniFields)
  • Add Registry sections (AddReg)
  • Delete Registry sections (DelReg)
  • Add Ini File to Registry sections (Ini2Reg)
  • Update Config.sys sections (UpdateCfgSys)
  • Update Autoexec.bat sections (UpdateAutoBat)
  • DestinationDirs section
  • SourceDisksNames section
  • SourceDisksFiles section
  • Strings section
  • Optional Components section
[Version] | Basic version information for validating the .inf file
[DefaultInstall] | Installation section that is executed by default. Contains pointers to other sections specifying files to copy and delete, registry updates, .ini file updates, and so on.
[OtherInstall] | Uses same format as [DefaultInstall] section, but must explicitly be called. Useful for defining how a component should be uninstalled.
[DestinationDirs] | Specifies the location on the hard disk where a section's files will be copied, deleted, or renamed (for example, \Windows or Windows\System).
[FileCopy/Delete/RenameSection(s)] | Lists files to be copied, deleted, or renamed.
[RegistryUpdateSection(s)] | Specifies registry additions or deletions.
[IniFileUpdateSection(s)] | Specifies updates to .ini files. Links are created in this section.
[SourceDisksNames] | Lists disks that contain the files.
[SourceDisksFiles] | Lists the specific disk that each file is on.
[Strings] | Lists localizable strings used above.
Return to top of file

Version section

[Version]
Signature="$Chicago$"
LayoutFile=filename.inf
Defines the standard header for all Windows .inf files. Note that if the signature is not $Chicago$, then Windows will not accept the .inf file as an .inf file for any of the classes of devices recognized by Windows.

Note that the signature string recognition is not case sensitive. So, for example, you can use either $Chicago$ or $CHICAGO$.

file name .inf
Names the .inf file that contains the layout information (source disks and files) required to install this component. This line is optional. If not given elsewhere, the SourceDisksNames and SourceDisksFiles sections must be given in this .inf file.

The following example shows a typical Version section:

[Version]
Signature="$CHICAGO$"

Return to top of file

Install sections

[install-section-name]

Copyfiles = file-list-section[,<file-list-section>]...
Renfiles = file-list-section[,file-list-section]...
Delfiles = file-list-section[,file-list-section]...
UpdateInis = update-ini-section[,update-ini-section]...
UpdateIniFields = update-inifields-section[,update-inifields-section]...
AddReg = add-registry-section[,add-registry-section]...
DelReg = del-registry-section[,del-registry-section]...
Ini2Reg = ini-to-registry-section[,ini-to-registry-section]...
UpdateCfgSys = update-config-section
UpdateAutoBat =update-autoexec-section

Identifies the additional sections in the .inf file that contain installation information for the component.

Not all the types of items shown in the syntax above are needed or required in an Install section. If an item type is used, it must specify the name of a section in the .inf file. (An exception to this is the CopyFiles item, which may use the "@" character along with a file name to copy a single file without specifying a section name. The section name must consist of printable characters.

Only one of each type of item can be used in any one Install section. More than one section name can be listed in an item, but each additional name must be preceded by a comma.

install-section-name
Naming the install section [DefaultInstall] will cause the install section to be executed when the "Install" verb is selected when the .inf file is right-clicked. This is is also the section that is executed when selecting an .inf file as the setup option using the Cabpack wizard.

The following example shows a typical Install section. It contains Copyfiles and AddReg items that identify the sections containing information about which files to install.

[MyApplication]
Copyfiles=MyAppWinFiles, MyAppSysFiles, @SRSutil.exe
AddReg=MyAppRegEntries

Note that in this example, by renaming the [MyApplication] section to [DefaultInstall], this Install section would be executed when the "Install" verb is selected when right-clicking the .inf file.

The CopyFiles item provides a special notation that allows a single file to be copied directly from the copy line. You can copy an individual file by prefixing the file name with an @ symbol. The destination for any file copied using this notation is the DefaultDestDir, as defined in the DestinationDirs section. The following example shows how to copy individual files:

CopyFiles=FileSection1,@myfile.txt,@anotherfile.txt,LastSectionName

Return to top of file

Copy Files sections (CopyFiles)

[CopyFiles-section-name]
destination-file-name[, source-file-name][,temporary-file-name][,flag]
[destination-file-name[,source-file-name][, temporary-file-name]][,flag]

Lists the names of files to be copied from a source disk to a destination directory. The source disk and destination directory associated with each file are specified in other sections of the .inf file. The file-list-section name must appear in the CopyFiles item of an Install section.

Note that you can specify the copying of a single file in the CopyFiles item of the Install section itself, without building a CopyFiles section. To do this, use the special character "@" to force a single file copy. An example of using the "@" character in a CopyFiles-type item is in the Install section reference topic. Copying a single file in this way is somewhat limited because the source and destination file names must be the same in this case, and you cannot use a temporary file.

destination-file-name
Name of the destination file. If no source file name is given, this is also the name of the source file.

source-file-name
Name of the source file. If the source and destination file names for the file copy operation are the same, this is not required.

temporary-file-name
Name of a temporary file for the file copy operation. The installer copies the source file but gives it the temporary file name. The next time the operating system starts, it renames the temporary file to the destination file name. This is useful for copying files to a destination that is currently open or in use by Windows.

flag
Optional parameter used to perform special actions during the installation process. Multiple flags can be used by adding the values to create the combined flag. The following valid flags can be used:

1 | On CopyFiles: Warn if user tries to skip file.
1 | On DelFiles: If file is in use, queue up delayed delete in Wininit.ini. Otherwise, a file that is currently in use will not be deleted.
2 | Setup-critical: Don't allow user to skip file.
4 | Ignore version check and always copy file. This will overwrite a newer file.
8 | Force rename. Setup treats this file as if it's in use. This happens only if the file already exists on the user's computer.
16 | If file already exists on target, don't copy.
32 | Suppress version conflict dialog box and don't overwrite newer files.

The following example copies three files:

[CopyTheseFilesSec]
file11 ; copies file11
file21, file22, file23 ; copies file22, temporarily naming it file23
file31, file32 ; copies file32 to file31

All the source file names used in this example must be defined in a SourceDisksFiles section, and the logical disk numbers that appear in the SourceDisksFiles section must have been defined in a SourceDisksNames section. As an alternative, you can use a Layout.inf file to supply this information.

Return to top of file

Rename Files sections (RenFiles)

[rename-files-section-name]
new-file-name, old-file-name
.
.
Lists the names of files to be renamed. The name of the section must appear in a Renfiles item in an Install section of the .inf file.

new-file-name
New name of the file.

old-file-name
Old name of the file.

The following example renames file42 to file41, file52 to file51, and file62 to file61:

[RenameOldFilesSec]
file41, file42
file51, file52
file61, file62

All the old file names used in this example (file42, file52, and file62) must be defined in a SourceDisksFiles section, and the logical disk numbers that appear in the SourceDisksFiles section must have been defined in a SourceDisksNames section.

Return to top of file

Delete Files sections (DelFiles)

[ file-list-section]
file-name[,,,flag]
.
.
A DelFiles section lists the names of files to be deleted. The file-list-section name must appear in the Delfiles item of an Install section.

file-name
Identifies a file to be deleted.

flag
Optional parameter used to force Windows to delete the file named in the item if it is in use during the installation process. To instruct Windows to queue the file deletion operation until the computer has restarted, set the flag parameter value to 1. If a file marked with the flag=1 parameter setting cannot be deleted because it is in use, a system restart will occur after the device installation is complete.

If you do not use the flag parameter value equal to 1 along with a file-name parameter, then the file will not be deleted from the computer if it is in use when the DelFiles section is executed.

The following example deletes three files:

[DeleteOldFilesSec]
file1
file2
file3

Return to top of file

Update .ini File sections (UpdateInis)

[ update-ini-section-name]
ini-file, ini-section, [old-ini-entry], [new-ini-entry], [flags]
.
.
Replaces, deletes, or adds complete entries in the given .ini file. The section name, update-ini-section-name, must appear in the UpdateInis item in an Install section of the .inf file.

ini-file
Name of the .ini file containing the entry to change. For more information about specifying the .ini file name, see the comments below.

ini-section
Name of the section containing the entry to change.

old-ini-entry
Optional. Usually in the form Key=Value.

new-ini-entry
Optional. Usually in the form Key=Value. Either the key or value may specify replaceable strings. For example, either the key or value specified in the new-ini-entry parameter may be %String1%, where the string that replaces %String1% is defined in the Strings section of the .inf file.

flags
Optional action flags. Can be one of the following values:

0 Default. If old-ini-entry key is present in an .ini file entry, that entry is replaced with new-ini-entry. Note that only the keys of the old-ini-entry parameter and the .inf file entry must match; the value of each entry is ignored.

To add new-ini-entry to the .ini file unconditionally, set old-ini-entry to NULL. To delete old-ini-entry from the .ini file unconditionally, set new-ini-entry to NULL.

1 | If both key and value of old-ini-entry exist in an .ini file entry, that entry is replaced with new-ini-entry. Note that the old-ini-entry parameter and the .inf file entry must match on both key and value for the replacement to be made. This is in contrast to using an action flag value of 0, where only the keys must match for the replacement to be made.
2 If the key in the old-ini-entry parameter does not exist in the .ini file, then no operation is performed on the .ini file.

If the key in the old-ini-entry parameter exists in an .ini file entry and the key in the new-ini-entry parameter exists in an .ini file entry, then the .ini file entry that matches the key in the new-ini-entry parameter is deleted and the .ini file entry that matches the old-ini-entry parameter is operated on in the following way: the key of the .ini file entry is replaced with the key in the new-ini-entry parameter.

If the key in the old-ini-entry parameter exists in an .ini file entry and the key in the new-ini-entry parameter does not exist in an .ini file entry, then an entry is added to the .ini file made up of the key in the new-ini-entry parameter and the old value.

Note that the match of the old-ini-entry parameter and an .ini file entry is based on key alone, not key and value.

3 | Same as flag parameter value of 2 described above, except match of the old-ini-entry parameter and an entry in the .inf file is based on matching both key and value, not just the key.
You can use the asterisk (*) wildcard character when specifying the key and value and it will be interpreted correctly.

The ini-file name can be a string or a strings key. A strings key has the form %strkey%, where strkey is defined in the Strings section in the .inf file. In either case, the name must be a valid file name.

The name should include the name of the folder containing the file, but the folder name should be given as a logical directory identifier (LDID) rather than an actual name. The installer replaces an LDID with an actual name during installation.

An LDID has the form %ldid%, where ldid is one of the predefined identifiers or an identifier defined in the DestinationDirs section. Note that when the constants LDID_BOOT and LDID_BOOTHOST are replaced, the backslash is included in the path. For example, LDID_BOOT may be replaced with C:\. However, in your .inf file you can either use the backslash character or not. For example, either "%30%boot.ini" and "%30%\boot.ini" can be used to reference BOOT..ini in the root of the boot drive.

The following examples illustrate individual items in an Update .ini File section of an .inf file:

%11%\sample.ini, Section1,, Value1=2 ; adds new entry
%11%\sample.ini, Section2, Value3=*, ; deletes old entry
%11%\sample.ini, Section4, Value5=1, Value5=4 ; replaces old entry

The following set of items in an Update .ini File-type section of an .inf file work together to operate on the Boot section of SYSTEM..ini. The conditionality built into the flags parameter of the .inf file items is used to add the entry "comm.drv=comm.drv" to the Boot section unless the entries "comm.drv=*vcoscomm.drv" or "comm.drv=*r0dmdcom.drv" exist in the Boot section, in which case the existing entry is preserved and the entry "comm.drv=comm.drv" is not added to the .ini file. In other words, after the four .inf file entries shown below are executed, there will be one "comm.drv=" entry in the Boot section of the .ini file: "comm.drv=*vcoscomm.drv" or "comm.drv=*r0dmdcom.drv" or "comm.drv=comm.drv."

system.ini, boot, "comm.drv=*vcoscomm.drv","~CommDrvTemp~=*", 3
system.ini, boot, "comm.drv=*r0dmdcom.drv","~CommDrvTemp~=*", 3
system.ini, boot,,"comm.drv=comm.drv"
system.ini, boot, "~CommDrvTemp~=*","comm.drv=*", 3

Return to top of file

Update .ini Fields sections (UpdateIniFields)

[ update-inifields-section-name ]
ini-file, ini-section, profile-name, [old-field], [new-field],[flags]
.
.
Replaces, adds, and deletes fields in the value of a given .ini entry. Unlike the Update .ini File section type, this type of section replaces, adds, or deletes portions of a value in an .ini file entry rather than the whole value. The section name, update-inifields-section-name, must appear in the UpdateIniFields item in an Install section of the .inf file.

ini-file
Name of the .ini file containing the entry to change. For more information about specifying the .ini file name, see the topic that describes the Update .ini File section type.

ini-section
Name of the .ini file section containing the entry to change.

profile-name
Name of the entry to change.

old-field
Field value to delete.

new-field
Field value to add, if not already there.

flags
Specifies whether to treat the old-field and new-field parameters as if they have a wildcard character or not and/or what separator character to use when appending a new field to an .ini file entry. Can be any of these values:

Value | Meaning
0 | (Default) Treat the "*" character literally when matching fields and not as a wildcard character. Use a blank (" ") as a separator when adding a new field to an entry.
1 | Treat the "*" character as a wildcard character when matching fields. Use a blank (" ") as a separator when adding a new field to an entry.
2 | Treat the "*" character literally when matching fields and not as a wildcard character. Use a comma (",") as a separator when adding a new field to an entry.
3 | Treat the "*" character as a wildcard character when matching fields. Use a comma (",") as a separator when adding a new field to an entry.
Any comments in the .ini file line are removed, because they might not be applicable after changes. When fields in this line of the .ini file are processed, spaces, tabs, and commas are used as field delimiters. However, a space is used as the separator when the new field is appended to the line.
Return to top of file

Add Registry sections (AddReg)

[ add-registry-section]
reg-root-string, [subkey], [value-name], [flag], [value]
[reg-root-string, [subkey], [value-name], [flag], [value]]
.
.
Adds subkeys or value names to the registry, optionally setting the value. The add-registry-section name must appear in an AddReg-type item in an Install section.

reg-root-string
Registry root name. Can be one of the following values:

HKCR Same as HKEY_CLASSES_ROOT
HKCU Same as HKEY_CURRENT_USER
HKLM Same as HKEY_LOCAL_MACHINE
HKU Same as HKEY_USERS.
HKR Means relative from the key passed into GenInstallEx

subkey
Optional. Identifies the subkey to set. Has the form key1\key2\key3.... This parameter can be expressed as a replaceable string. For example, you could use %Subkey1%, where the string to replace %Subkey1% is defined in the Strings section of the .inf file.

value-name
Optional. Identifies the value name for the subkey. For string type, if the value-name parameter is left empty, the value of the subkey specified in the subkey parameter is set to a NULL string. Note that the value-name parameter can be expressed as a replaceable string. For example, you could use %Valname1%, where the string to replace %Valname1% is defined in the Strings section of the .inf file.

flag
Optional. Determines both the value type and whether the registry key is replaced if it already exists.

Value | Meaning
0 | (Default) Value is an ANSI string. Replace key if it exists.
1 | Value is a hexadecimal number. Replace key if it exists.
2 | Value is an ANSI string. Do not replace key if it exists.
3 | Value is a hexadecimal number. Do not replace key if it exists.
value
Optional. Value to set. Can be either an ANSI string or a number in hexadecimal notation and Intel format. Any item containing a binary value can be extended beyond the 128-byte line maximum by using a backslash (\) character. A string key of the form %strkey% can also be given. The strkey must be defined in the Strings section of the .inf file. To use a % character in the line, use %%.

At least two fields are required; however, one can be null. Thus, at least one comma is required when using this form.

The two items in the following AddReg-type section example add two value names to the registry. Note that %25% will be expanded to the computer's Windows folder.

[MyAppRegEntries]
HKLM,Software\MyApp,ProgramName,,"My Application"
HKLM,Software\MyApp,"Program Location",,"%25%\MyApp.exe"

Return to top of file

Delete Registry sections (DelReg)

[ del-registry-section]
reg-root-string, subkey, [value-name]
[reg-root-string, subkey, [value-name]]
.
.
Deletes a subkey or value name from the registry. The del-registry-section name must appear in a DelReg item in an Install section.

reg-root-string
Registry root name. Can be one of the following values:

HKCR Same as HKEY_CLASSES_ROOT
HKCU Same as HKEY_CURRENT_USER
HKLM Same as HKEY_LOCAL_MACHINE
HKU Same as HKEY_USERS.
HKR Means relative from the key passed into GenInstallEx

subkey
Identifies the subkey to delete. Has the form key1\key2\key3... This parameter can be expressed as a replaceable string. For example, you could use %Subkey1%, where the string to replace %Subkey1% is defined in the Strings section of the .inf file.

value-name
Optional. Identifies the value name for the subkey. Note that the value-name parameter can be expressed as a replaceable string. For example, you could use %Valname1%, where the string to replace %Valname1% is defined in the Strings section of the .inf file.

This type of section can contain any number of items. Each item deletes one subkey or value name from the registry.

Ini File to Registry sections (Ini2Reg)

[ ini-to-registry-section]
ini-file, ini-section, [ini-key], reg-root-string, subkey[,flags]
.
.
Moves lines or sections from an .ini file to the registry, creating or replacing a registry entry under the given key in the registry. The section name ini-to-registry-section must appear in an Ini2Reg item in an Install section of the .inf file.

ini-file
Name of the .ini file containing the key to copy. For more information about specifying the .ini file name, see the comments in the Reference topic about the Update .ini File section.

ini-section
Name of the section in the .ini file containing the key to copy.

ini-key
Name of the key in the .ini file to copy to the registry. If ini-key is empty, the whole section is transferred to the specified registry key.

reg-root-string
Registry root name. Can be one of the following values:

HKCR Same as HKEY_CLASSES_ROOT
HKCU Same as HKEY_CURRENT_USER
HKLM Same as HKEY_LOCAL_MACHINE
HKU Same as HKEY_USERS.
HKR Means relative from the key passed into GenInstallEx

subkey
Identifies the subkey to receive the value. Has the form key1\key2\key3...

flags
Indicates whether to delete the .ini key after transfer to the registry and whether to overwrite the value in the registry if the registry key already exists. Can be one of the following values:

Value | Meaning
0 | (Default) Do not delete the .ini entry from the .ini file after moving the information in the entry to the registry. If the registry subkey already exists, do not replace its current value.
1 | Delete the .ini entry from the .ini file after moving the information in the entry to the registry. If the registry subkey already exists, do not replace its current value.
2 | Do not delete the .ini entry from the .ini file after moving the information in the entry to the registry. If the registry subkey already exists, replace its current value with the value from the .ini file entry.
3 | Delete the .ini entry from the .ini file after moving the information in the entry to the registry. If the registry subkey already exists, replace its current value with the value from the .ini file entry.
For example, suppose the following entry exists in the Win.ini file:

[Windows]
CursorBlinkRate=15

If a CursorBlinkRate subkey does not exist under Control Panel\Desktop, then the following item in an Ini File to Registry section creates the subkey, sets the value of the subkey to 15, and leaves the original line in WIN..ini unchanged:

win.ini,Windows,CursorBlinkRate,HKCU,"Control Panel\Desktop"

If the subkey already exists, the .inf file item sets the value of the subkey to 15, and leaves the original line in WIN..ini unchanged.

Update Config.sys Sections (UpdateCfgSys)

[ update-config-section]
Buffers=legal-dos-buffer-value
DelKey=key
DevAddDev=driver-name,configkeyword[,flag][,param-string]
DevDelete=device-driver-name
DevRename=current-dev-name,new-dev-name
Files=legal-dos-files-value
PrefixPath=ldid[,ldid]
RemKey=key
Stacks=dos-stacks-values

Provides commands to add, delete, or rename commands in the Config.sys file. The section name, update-config-section-name, must appear in the UpdateConfigSys item in an Install section of the .inf file.

Not all item types shown in the preceding syntax are needed or required. An Update Config.sys section may contain as many DevRename, DevDelete, DevAddDev, DelKey, and RemKey items as needed, but the Buffers, Files, and Stacks items may be used only once in a section. When processing an Update Config.sys section, the Installer processes all DevRenames items first, all DevDelete items second, and all DevAddDev items last. The syntax and meaning of each of the types of items that can be used in an Update Config.sys section are provided later in this topic.

Buffers item

Buffers=legal-dos-buffer-value
Sets the number of file buffers. As it does with the Stacks item, the Installer compares the existing value with the proposed value and always sets the file buffers to the larger of the two values.

legal-dos-buffers-value
A legal MS-DOS buffers value.

DelKey item

DelKey=key
Causes the Config.sys command with the specified key to be remarked out in the Config.sys file. For example, the following .inf file item:

DelKey=Break

would cause a Break=on command to be remarked out in the Config.sys file.

The DelKey item has the same effect as the RemKey item. There can be multiple DelKey and/or RemKey items in a section of the .inf file.

key
The key of the Config.sys command to be remarked out.

DevAddDev Item

DevAddDev=driver-name,configkeyword[,flag][,param-string]
Adds a device or install command to the CONFIG.SYS file.

driver-name
Name of the driver or executable file to add. The installer validates the file name extension, ensuring that it is .sys or .exe.

configkeyword
Command name. Can be device or install.

flag
Optional placement flag. If 0, the command is placed at the bottom of the file. If 1, it is placed at the top. If flag is not given, 0 is used by default.

param-string
Optional command parameters. Must be valid for the given device driver or executable file.

DevDelete Item

DevDelete=device-driver-name
Deletes any line containing the specified file name from the Config.sys file.

device-driver-name
Name of a file or device driver. The Installer searches the Config.sys file for the name and deletes any line containing it. Because MS-DOS does not permit implicit file name extensions in Config.sys, each device-driver-name must explicitly specify the file name extension.

The following example DevDelete item in an Update Config.sys section deletes lines 1 and 3 but not line 2 of the example Config.sys file:

DevDelete=Filename.sys

;; lines in Config.sys
Device=Filename.sys ;; line #1
Install=Filename.exe ;; line #2
Device=Filename.sys /d:b800 /I:3 ;; line #3

DevRename item

DevRename=current-dev-name,new-dev-name
Renames a device driver in the Config.sys file.

current-dev-name
Name of the device driver or executable file to rename. The installer looks for the name on the right side of a device or install command in the Config.sys file.

new-dev-name
New name for driver or executable file.

Files item

Files=legal-dos-files-value
Sets the maximum number of open files in the Config.sys file. As it does with the Stacks item, the Installer compares the existing value with the proposed value and always sets the maximum number of open files to the larger of the two values.

legal-dos-files-value
A legal MS-DOS files value.

PrefixPath item

PrefixPath=ldid[,ldid]...
Appends the path associated with the given LDID to the path command.

ldid
Can be any of the predefined LDID values or a new value defined in the .inf file. For a definition of all the predefined LDID values, see the "Reference" topic about the DestinationDirs section.

RemKey item

RemKey=key
Causes the Config.sys command with the specified key to be remarked out in the Config.sys file. For example, the following .inf file item:

RemKey=Break

would cause a Break=on command to be remarked out in the Config.sys file.

The RemKey item has the same effect as the DelKey item. There can be multiple RemKey and/or DelKey items in a section of the .inf file.

key
The key of the Config.sys command to be remarked out.

Stacks item

Stacks=dos-stacks-values
Sets the number and size of stacks in the Config.sys file. The Installer compares the existing value with the proposed value and always sets the stacks to the larger of the two values. For example, if Config.sys contains stacks=9,218 and an .inf file contains stacks=5,256, the installer sets the new value to stacks=9,256.

legal-dos-stacks-value
A legal MS-DOS stacks value.

Return to top of file

Update Autoexec.bat sections (UpdateAutoBat)

[ update-autoexec-section]
CmdAdd=command-name[,command-parameters]
CmdDelete=command-name
PrefixPath=ldid[,ldid]
RemOldPath=ldid[,ldid]
TmpDir=ldid[,subdir]
UnSet=env-var-name

Provides commands to manipulate lines in the Autoexec.bat file. The section name, update-autoexec-section-name, must appear in the UpdateAutoBat item in an Install section of the .inf file.

Not all item types shown in the syntax above are needed or required in an Update Autoexec.bat section. The section can contain as many CmdAdd, CmdDelete and UnSet items as needed, but only one PrefixPath, RemOldPath and TmpDir item can be used in an .inf file. The syntax and meaning of each of the item types is described later in this topic.

The installer processes all CmdDelete items before any CmdAdd items.

CmdAdd Item

CmdAdd =command-name[,"command-parameters"]
Adds the given command and optional command parameters to the Autoexec.bat file, at the end of the file.

command-name
Name of an executable file, with or without an extension. If the file name is also defined in the SourceDisksFiles and DestinationDirs sections of the .inf file, the installer adds the appropriate path to the file name before writing it to the Autoexec.bat file.

command-parameters
A string enclosed in double quotation marks or a replaceable string like %String1% or %Myparam%, where the strings that replace %String1% and %Myparam% are defined in the Strings section of the .inf file. The installer appends the string to the command-name before appending the line to the end of the Autoexec.bat file. The format of this line is dependent on the command line requirements of the given executable file.

CmdDelete item

CmdDelete=command-name
Deletes any lines from Autoexec.bat that include the given command name. The installer searches for and deletes any occurrence of the given name that has a file name extension of .exe, .com, and .bat.

command-name
Name of an executable file without an extension.

PrefixPath item

PrefixPath=ldid[,ldid]...
Appends the path associated with the given LDID to the path command.

ldid
Can be any of the predefined LDID values or a new value defined in the .inf file. For a definition of all the predefined LDID values, see the "Reference" topic about the DestinationDirs section.

RemOldPath item

RemOldPath=ldid[,ldid]
Removes the path associated with the given LDID from the path command. For example, if the user installs the new version of Windows into C:\Newwin and has an old copy of Windows in C:\Windows, the following .inf file item removes C:\Windows from the path environmental variable:

RemOldPath=10

ldid
Can be any of the predefined LDID values or a new value defined in the .inf file. For a definition of all the predefined LDID values, see the "Reference" topic about the DestinationDirs section.

TmpDir item

TmpDir=ldid[,subdir]
Creates a temporary folder within the folder given by the LDID, if it does not already exist.

ldid
Can be any of the predefined LDID values or a new value defined in the .inf file. For a definition of all the predefined LDID values, see the "Reference" topic about the DestinationDirs section.

subdir
A path name. If ldid\subdir does not already exist, it is created.

UnSet item

UnSet=env-var-name
Removes any set command from the Autoexec.bat file that includes the given environment variable name.

env-var-name
Name of an environment variable.

Return to top of file

DestinationDirs section

[DestinationDirs]
file-list-section =ldid[, subdir ]
.
.
[DefaultDestDir=ldid[, subdir ]]

The DestinationDirs section defines the destination directories for the operations specified in file-list sections, which are either CopyFiles, RenFiles, or DelFiles sections. Optionally, a default destination folder may be specified for any CopyFiles, RenFiles, or DelFiles sections in the .inf file that are not explicitly named in the DestinationDirs section.

file-list-section
Name of a CopyFiles, RenFiles, or DelFiles section. This name must be referred to in a Copyfiles, RenFiles, or DelFiles item in an Install section.

ldid
A logical disk identifier (LDID). Can be one of the following values:

00 | Null LDID - can be used to create a new LDID
01 | Source Drive:\pathname
10 | Machine folder (maps to the Windows folder on a server-based setup.)
11 | System folder
12 | IOSubsys folder
13 | Command folder
17 | Inffolder
18 | Help folder
20 | Fonts
21 | Viewers
22 | VMM32
23 | Color folder
24 | Root of drive containing the Windows folder
25 | Windows folder
26 | Guaranteed boot device for Windows (Winboot)
28 | Host Winboot
30 | Root folder of the boot drive
31 | Root folder for host drive of a virtual boot drive
subdir
Name of the folder within the folder named by LDID to be the destination folder.

The optional DefaultDestDir item provides a default destination for any CopyFiles items that use the direct copy (@file name) notation or any CopyFiles, RenFiles, or DelFiles sections not specified in the DestinationDirs section. If a DefaultDestDir is not used in a DestinationDirs section, then the default folder is set to LDID_WIN.

Th following example sets the destination folder for the MoveMiniPort section to Windows\Iosybsys and sets the default folder for other sections to be the Bin folder on the boot drive:

[DestinationDirs]
MoveMiniPort=12 ; Destination for MoveMiniPort section is
; windows\iosubsys
DefaultDestDirs=30,bin ; Direct copies go to boot:\bin

Return to top of file

SourceDisksNames section

[SourceDisksNames]
disk-ordinal="disk-description",disk-label,disk-serial-number
.
.
Identifies and names the disk(s) that contain the source files for file copying and renaming operations.

disk-ordinal
A unique number that identifies a source disk. If there is more than one source disk, each must have a unique ordinal.

disk-description
A string or a strings key describing the contents or purpose of the disk. The installer displays this string to the user to identify the disk. The description is enclosed in double quotation marks.

disk-label
Volume label of the source disk that is set when the source disk is formatted.

disk-serial-number
Unused. Value must be 0.

This example identifies one source disk. The disk description is given as a strings key:

[SourceDisksNames]
55 = %ID1%, Instd1, 0

[Strings]
ID1="My Application Installation Disk 1"

Return to top of file
SourceDisksFiles section

[SourceDisksFiles]
file name=disk-number[,subdir] [,file-size]
.
.
color=#000000Names the source files used during installation and identifies the source disks that contain the files.

color=#000000file name
color=#000000Name of the file on the source disk.

disk-number
color=#000000Ordinal of the source disk that contains the file. This ordinal must be defined in the SourceDisksNames section, and must have a value greater than or equal to 1 (zero is not a valid disk-number parameter value).

subdir
Optional parameter that specifies the subfolder on the source disk where the file resides. If this parameter is not used, the source disk root folder is the default.

file-size Optional parameter that specifies the size of the file, in bytes.

color=#000000The following SourceDisksFiles example section identifies a single source file, SRS01.386, on the disk having ordinal 1:

[SourceDisksFiles]
SRS01.386 = 1

Return to top of file

Strings section

[Strings]
strings-key=value
.
.
Defines one or more strings keys. A strings key is a name that represents a string of printable characters. Although the Strings section is generally the last section in the .inf file, a strings key defined in this section may be used anywhere in the .inf file that the corresponding string would be used. The Installer expands the strings key to the given string and uses it for further processing. You must enclose a strings key in percent signs (%).

strings-key
A unique name consisting of letters and digits.

value
A string consisting of letters, digits, or other printable characters. It should be enclosed in double quotation marks if the corresponding strings key is used in a type of item that requires double quotation marks.

The Strings section makes translation of strings for international markets easier by placing all strings that can be displayed at the user interface when the .inf file is used in a single section of the .inf file. Strings keys should be used whenever possible.

The following example shows the strings section for a sample .inf file.

[Strings]
String0="My Application"
String1="My Application Readme File"
String2="CX2590 SCSI Adapter"

Return to top of file

Optional Components section

[Optional Components]
install-section-name
[install-section-name]
.
.
Lists Install sections that are displayed when the user clicks the Add/Remove Programs icon in Control Panel, clicks the Windows Setup tab, and then clicks the Have Disk button. The Install sections show up as check boxes in the list.

Note that the Optional Components section is ignored when executing an .inf file by right-clicking on the .inf file and selecting the "install" verb. When executing an .inf file in this way, the [DefaultInstall] section is executed. The Optional Components section is also ignored if the .inf file is being executed via the Setupx.dll InstallHinfSection entry point. When executing an .inf file via the SETUPX entry point, the Install section specified in parameter to the entry point is executed.

The Install sections follow the same format as described previously, and the following additional keys can be added to the Install section to drive the interface in the "Have Disk" dialog box:

OptionDesc=option-description
Tip=tip-description
InstallDefault=0 | 1 ;
Whether to install this component by default. 1=Yes, 0=No.
IconIndex=icon-index
Parent= install-section-name
Needs=install-section-name, [install-section-name]
Include=inf-file, [inf-file]

option-description
String value that is used as the component name in the list box. The option-description parameter may be %String1%, where the string that replaces %String1% is defined in the Strings section of the .inf file.

tip-description
String value that is displayed in the "description" box when the component is selected in the list box. The tip-description parameter has a 255 character limit, and may be %String1%, where the string that replaces %String1% is defined in the Strings section of the .inf file.

icon-index
Numeric value that determines the mini-icon that is displayed next to the component name. Valid values are:
0 Machine (base and display)
1 Integrated circuit chip
2 Display
3 Network wires
4 Windows flag
5 Mouse
6 Keyboard (3 keys)
7 Phone
8 Speaker
9 Hard disks
10 Comm connector
11 Diamond (default value)
12 Checked box
13 Un-checked box
14 Printer
15 Net card
16 Same as 0
17 Same as 0 w/ a sharing hand underneath
18 Unknown (question mark)
19 Atwork
20 Greyed check box
21 Dial-up networking
22 Direct cable connection
23 Briefcase
24 Exchange
25 Partial check
26 Accessories group
27 Multimedia group
28 Quick View
29 MSN
30 Calculator
31 Defrag
32 Generic document
33 DriveSpace
34 Solitaire
35 HyperTerminal
36 Object Packager
37 Paint
38 Screen saver
39 WordPad
40 Clipboard Viewer
41 Accessibility
42 Backup
43 Bitmap document
44 Character map
45 Mouse pointers
46 Net Watcher
47 Phone Dialer
48 System Monitor
49 Help book
50 Globe (international settings)
51 Audio compression
52 CD player
53 Media Player
54 Sound scheme
55 Video clip
56 Video compression
57 Volume control
58 Musica sound scheme
59 Jungle sound scheme
60 Robotz sound scheme
61 Utopia sound scheme

Parent
The list box displayed in the optional components interface can contain sub-levels. If the optional component is a child, the Parent= keyword defines the Install section that is the parent.

Needs
If this component has dependencies on other components, this defines Install sections that are required by this component. If the component is selected, the user will be warned that the component requires the component(s) desribed in the Install section(s) listed on the Needs= line.

Note that the Install sections listed on the Needs= line must be in the same .inf file. However, if dependent components from other .inf files are listed in the Needs= line, the .inf files must be specified on the Include= line.

Include
The Include item enables you to specify .inf files that Setup must also load into memory when it loads your .inf file, because these .inf files contain sections that must be run in addition to the install sections in your .inf file. The Needs item specifies the names of the sections you intend to run in the included .inf file(s).

The following example defines two optional component install sections; each install section uses the additional entries to specify interface elements and dependencies:

[Optional Components]
InstallMyToys
InstallGames

[InstallMyToys]
OptionDesc=%Toys_DESC%
Tip=%Toys_TIP%
IconIndex=35 ;Phone mini-icon for dialogs
Parent=MailApps
Needs=MSMAIL, MAPI, MicrosoftNetwork
Include=mos.inf, msmail.inf
CopyFiles=MyToysFiles
UpdateInis=MyToysLinks
AddReg=MyToysRegItems

[InstallOtherApps]
OptionDesc=%Other_DESC%
Tip=%Other_TIP%
IconIndex=4 ;windows mini icon for dialogs
CopyFiles=OtherFiles
UpdateInis=OtherLinks
AddReg=OtherRegItems

[Strings]
Toys_DESC="Mail Utilities"
Toys_TIP="Additional utilities for sending and organizing
mail"
Other_DESC="Other Helpful Utilities"
Other_TIP="Calculator, disk checker and performance monitor"

Return to top of file


Using RunOnce Technology

You can run any program(s) after an .inf file is executed by adding entries to the Runonce registry key. If the .inf file specifies that the computer must be restarted, the Runonce entries are executed after the computer is restarted.

The Runonce registry key enables you to launch programs one time in Windows and to specify whether they should run "silently" (without prompts to the user) or as part of a list of programs or actions that the user sees. The reference to the program is then deleted so that the program will not be run again.

To run programs silently, add descriptionstring=commandline entries under the following registry key:

HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\RunOnce

To run programs that synchronously run under the Windows Runonce manager, add description-string=command-line entries under the following registry key:

HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\RunOnce\Setup

The following example shows an AddReg section that causes the following to happen:

  • Launch Myapp.exe (located in the Windows folder) with no user interface.

    HKLM,Software\Microsoft\Windows\CurrentVersion\RunOnce,"SilentApp",,"%25%\myapp.exe"

  • Launch Test.exe (located in the System folder) and display the message "Windows Setup is now setting up the following items":
    HKLM,Software\Microsoft\Windows\CurrentVersion\RunOnce\Setup,"Test Utility",,"%11%\test.exe"

Note

  • The description string under the Setup registry key appears in the user interface.


Manipulating Folders and Files by Using Setup Information (.inf) Files

You can use .inf files to manipulate files and folders in several ways. Some key ways are:

  • Creating folders and links in folders
  • Creating and deleting long file names
  • Setting attributes for files and folders
  • Copying files to the Program Files folder

Creating folders and links in folders

Creating a folder in the Program Files folder or creating links in a folder is done by the shell after a component is installed. Setup looks in the Setup.ini file for a [progman.groups] section and then parses it to create folders and links in those folders.

If you are installing a component that will require a folder or links in the Program Files folder, create an UpdateInis section that will create the proper entries in the Setup.ini file. The Setup.ini file uses the following syntax to create folders and links. Note that folders are relative to the Start menu.

[progman.groups]
folder_1=Folder_1_Name
folder_2=Folder_2_Name
:
folder_n=Folder_n_Name

[folder_1]
Link-Name, .exe-name, Icon-file-name, Icon-index, profile

If the profile field is left NULL, the link will always be added to the folder.

Notes

  • If .exe-name is a NULL item, it will be deleted from the group if it exists there.
  • If a folder or link has a space in its description, you must use double quotation marks to get this to show up in the Setup.ini file. See the examples below.

Example: Games

[Optional Components]
games

[games]
OptionDesc= %GAMES_DESC%
CopyFiles= wingames.files
UpdateInis= wingames.links
[wingames.files]
cards.dll
freecell.exe
freecell.hlp
mshearts.exe
mshearts.hlp
sol.exe
sol.hlp
winmine.exe
winmine.hlp

[wingames.links]
setup.ini, progman.groups,, "gamesfolder=%GAMES_DESC%" ;creates folder
setup.ini, gamesfolder,, """Solitaire Game"",SOL.EXE,,," ;creates link
setup.ini, gamesfolder,, "Minesweeper,WINMINE.EXE,,," ;creates link
setup.ini, gamesfolder,, ""Hearts Card Game"",MSHEARTS.EXE,,,";creates link
setup.ini, gamesfolder,, "FreeCell,FREECELL.EXE,,," ;creates link

Result: The entry for "Games" will appear in the Optional Components dialog box in Setup, and if selected, a Games folder will be created in the Program Files folder with links to Solitaire, Minesweeper, Hearts, and FreeCell.

Creating and deleting long file names

The setup engine in Windows 32-bit versions of the browser is a 16-bit .dll file for backwards compatibility. Because of this, the Windows setup engine can only copy files with 8.3 file names. In order to create and delete files with long file names, the setup engine runs a 32-bit application when it exits that renames any 8.3 file names to long file names and deletes files with long file names. The 32-bit application gets its instructions from predefined keys in the registry.

The root branch of the registry for rename operations is the following:

HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\RenameFiles

The root branch of the registry for delete operations is the following:

HKEY_LOCAL_MACHINE\Software\Microsoft\Windows\CurrentVersion\DeleteFiles

Each group of rename and delete operations is added to a subkey under each branch. Each group of operations is limited to renaming or deleting files in a single folder. You must include a minimum of two entries in each subkey to effect a rename or delete: the folder path for the files to be renamed or deleted, and the actual rename or delete operation.

The first key in each group of operations is the folder entry. Each entry for a rename operation in the related folder is an entry of the form "old_short_name"="new_long_name,[attrib_flag]".

The optional attrib_flag is used to set file attributes during the rename operation. The flag is composed of the following values.

1 | READONLY
2 | HIDDEN
3 | SYSTEM

To set multiple attributes on a file or folder, the flags are added together; for example, to set the READONLY and HIDDEN attributes, attrib_flag would be 3.

The following example is an AddReg section that sets the SYSTEM and HIDDEN attributes for the \Windows\System\Sample folder:

HKLM,Software\Microsoft\Windows\CurrentVersion\RenameFiles\Sys,,,%11% HKLM,Software\Microsoft\Windows\CurrentVersion\RenameFiles\Sys,SAMPLE,,"SAMPLE,6"

Note

  • You should use all capital letters to ensure that the file name remains a short file name.

Each entry for a delete operation in the related folder is an entry of the form "arbitrary_key_name"="long_name_to_delete".

The following example is an AddReg section that:

  • Renames Oldname.txt file to New Long Name.txt in the C:\Samples folder.
  • Renames Myreadme.txt file to My Application Readme.txt in the Windows folder.

[MyAppShort2Long]
HKLM,Software\Microsoft\Windows\CurrentVersion\RenameFiles\Samples,,,C:\Samples
HKLM,Software\Microsoft\Windows\CurrentVersion\RenameFiles\Samples,oldname.txt,,"New Long Name.txt"
HKLM,Software\Microsoft\Windows\CurrentVersion\RenameFiles\Win,,,%25%
HKLM,Software\Microsoft\Windows\CurrentVersion\RenameFiles\Win,myreadme.txt,,"My App Readme.txt"

The following example is an AddReg section that:

  • Deletes New Long Name.txt from the C:\Samples folder.
  • Deletes My Application Readme.txt from the Windows folder.

[MyAppDelLong]
HKLM,Software\Microsoft\Windows\CurrentVersion\DeleteFiles\Samples,,,C:\Samples
HKLM,Software\Microsoft\Windows\CurrentVersion\DeleteFiles\Samples,oldname.txt,,"New Long Name.txt"

HKLM,Software\Microsoft\Windows\CurrentVersion\DeleteFiles\Win,,,%25%
HKLM,Software\Microsoft\Windows\CurrentVersion\DeleteFiles\Win,myreadme.txt,,"My App Readme.txt"

After these renames and deletions have been processed, the entries are removed from the registry.

Note

  • During the rename operation, the destination file is deleted beforeany files are renamed. If the same rename operation is queued twice, it could result in a loss of the file. For example, suppose there is a bitmap that needs to be renamed from Picture.bmp to "Really Cool 3D Picture.bmp." The second time such a rename operation is performed, "Really Cool 3D Picture.bmp" already exists, so it is deleted before the rename opreation is performed. The exception to this rule is when the existing destination file name is a folder.

Setting attributes for files and folders

To set the attributes for a file or folder, you use the same convention to create long file names using an optional flag.

For details, see the section on "Creating and deleting long file names."

Copying files to the Program Files folder

Because copying Windows files is a 16-bit operation, only short (8.3) file names can be used. To access the Program Files folder, you will need to use the 8.3 equivalent, "24,PROGRA`1", in the [DestinationDirs] section (LDID 24 is the root of the drive that contains the Windows folder). Similarly, the short file name equivalent must be used to access any folders with long file names that are within the Program Files folder.

The following example copies three files to the Program Files\Accessories folder and creates links to one of the files:

[WordPadInstall]
CopyFiles = WordPadCopyFiles
UpdateInis = WordPadInis

[DestinationDirs]
WordPadCopyFiles = 24,%PROGRAMF%\%ACCESSOR%

[WordPadCopyFiles]
mswd6_32.wpc
wordpad.exe
write32.wpc
[WordPadInis]
setup.ini, progman.groups,, "group4=%APPS_DESC%" ;creates Accessories folder (if not already there)
setup.ini, group4,, """%WORDPAD_LINK%"", ""%24%\%PROGRAMF%\%ACCESSOR%\WORDPAD.EXE""" ;creates link in Accessories folder

[Strings]
APPS_DESC = "Accessories"
WORDPAD_LINK = "WordPad"
; Folder names - note that the short versions must match the truncated
; 8-character names for the long versions, or else there will be problems.
PROGRAMF = "Progra~1" ; first 6 chars of Program_Files, + "~1"
ACCESSOR = "Access~1" ; first 6 chars of Accessories, + "~1"

Limitations of .inf files

  • Directories cannot be deleted.
  • Files cannot be moved to a different location when using RenFiles. (The RenFiles command only renames a file in place.)
  • Copies of a file cannot be made. (The CopyFiles command only copies files from the source disk to the destination directory.)


Providing Uninstall Functionality in an .inf Script

You can provide uninstall functionality in your .inf files by adding an Install section that removes the files, registry entries, and shortcuts, then adds your component to the list of programs that can be uninstalled from the Add/Remove Programs dialog box in Control Panel. An example is included in the Inf folder of the IEAK Toolkit.

To add your component to the Add/Remove Programs dialog box, add a new key and values under the following registry key:

HKLM,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\app-name,"DisplayName",,"description"

HKLM,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\app-name,"UninstallString",,"command-line"

description
This string is displayed in the list box in the Add/Remove Programs dialog box.

command-line
This is the command line that will be executed when the component is selected from the list box in the Add/Remove Programs dialog box. To execute a section in an .inf file, you can use the Setupx.dll InstallHinfSection entry point (described below).

The following sample AddReg entries add "My Test Application" to the list box in the Add/Remove Programs dialog box and executes the Remove_TestApp Install section in Test.inf:

HKLM,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Test,"DisplayName",,"My Test Application"

HKLM,SOFTWARE\Microsoft\Windows\CurrentVersion\Uninstall\Test,"UninstallString",,"RunDll setupx.dll,InstallHinfSection Remove_TestApp 4 test.inf"

Notes

  • Your installation script must copy the .inf file to the Windows\Inf folder when your component is installed. This is the default location that is searched when the Setupx.dll InstallHinfSection entry point is called.
  • Your uninstall script should remove the key you created under the Uninstall registry key so that your program will no longer show up in the Add/Remove Programs list box after it has been uninstalled.


Managing Automatic Install

When users install Internet Explorer, they can choose just the components they want, so they can control how much hard disk space is used and limit download and installation time. However, as users browse the Web, they may find they need additional components.

When users visit a Web page that requires a program or component that is not already installed, Automatic Install prompts them to install the necessary components.

As a corporate administrator or ISP, you can control this feature by using the IEAK.

Notes

  • If you expect your organization to use Automatic Install over the Internet, you must sign the .cab files and specify in the security settings that the server hosting the .cab files is a trusted server, or for an intranet site only, set the security level to Low. For more information, see Signing Your Programs.

    If your intranet security level is Medium or higher, and you are specifying your network servers as trusted servers, you need to do the following:

    1. On the Security Settings page in the wizard, click Customize Security Zones settings, and then click Modify Settings.
    2. Select the Local intranet zone, and then click Sites.
    3. Clear the Include all network paths (UNC) check box, and then click OK.
    4. Select the Trusted sites zone, click Sites, type the path for the download server, and then click Add.
    5. Repeat the previous step for every download server that you want to specify as trusted.
  • The Automatic Install feature is not available for multiple-floppy-disk installations.


Creating Multiple Versions of the Browser

Use this process to create different versions of the browser (for example, versions with different mail servers) that share many of the same settings.

The Internet Explorer Customization wizard displays the settings you specified for the original version of your custom browser. These settings are stored in the Install.ins file. By renaming the .ins files, you can quickly make changes to each version of your custom browser.

  1. Create one version of your custom browser using the wizard.
  2. Rename the Install.ins file, which is located in the CIE\Custom folder. For example, if you need a version for users located in Texas, you may want to name the file Texas.ins.
  3. Open the Signup.htm file in the CIE\Custom folder. Create a link in this file to the Texas.ins file.
  4. Run the wizard again and specify the same custom folder as the destination directory for the output files.

    5. Be careful to keep wizard settings the same across all builds, except for the following settings, which you can customize for each build:

    • Logo
    • Title bar text
    • Favorites
    • Links bar
    • Home page and Search bar
    • Mail servers and domain
  5. Repeat steps 2 through 4 until you have created each version of your custom browser.


Creating an .isp File

The .isp file contains information that makes it possible for users to connect to your sign-up server. Microsoft provides a tool, the ISP File wizard, that you can use to generate your .isp file automatically.

To install the ISP File wizard, double-click Filewiz.exe in the \Toolkit\ISP\Wizard folder of your IEAK program folder. This will launch Setup for the wizard.

To start the ISP File wizard
  • Click the Start menu, point to Programs, and then click ISP File Wizard.
  • Follow the instructions in the wizard to create an .isp file with your custom settings.


Redistributing Internet Explorer

The IEAK can help you redistribute Internet Explorer with your custom program. For example, if you're an independent software vendor (ISV), you may want to customize Internet Explorer installation so that your custom program, instead of Internet Explorer, provides Setup choices and feedback to the user.

To redistribute Internet Explorer, choose the Content Provider/Developer option in Stage 1 of the Internet Explorer Customization wizard.

Use the Customization wizard to customize the appearance and functionality of the browser and Setup, if you want.

Then, you can use the following to further customize the Setup process:

  • Customizing Setup
  • Using Batch Mode Setup
  • Internet Explorer Batch Mode Setup Switches
  • Assessing the Installed Size of Internet Explorer
  • Working with .inf Files


Switching from Other Versions or Products

Before your employees or customers install Internet Explorer 5, you'll want to identify and address any issues related to upgrading.

Upgrading from Internet Explorer 3.0

Internet Explorer 5 Setup installs over an installed version of Internet Explorer 3.0 and imports proxy settings, Favorites, and cookies from the previous version. However, you must reinstall any plug-ins that you want to keep.

Upgrading from Internet Explorer 4.0

Internet Explorer 5 Setup installs over an installed version of Internet Explorer 4.0 and imports proxy settings, Favorites, and cookies from the previous version. However, you must reinstall any plug-ins that you want to keep.

If you want your users to have the Active Deskop from Internet Explorer 4.0, you can include the desktop in your Internet Explorer 5 browser packages for your Windows 95 and Windows NT 4.0 users. For example, if some of your users are using the Active Desktop from Internet Explorer 4.0, and some users are upgrading from Internet Explorer 3, you may want all users to have the Active Desktop. The new desktop is a part of Windows 98.

Migrating from Netscape Navigator 3 and 4

When you install Internet Explorer 5, you can import proxy settings, Favorites, and cookies from Netscape. However, you must reinstall any plug-ins that you want to keep. When Internet Explorer 5 is installed, you can choose whether to make Internet Explorer your default browser.


Installing Internet Explorer with Microsoft Office

The Custom Installation wizard (CIW) enables you to customize how you install Office programs. To simplify the installation process, the IEAK is designed to work with the CIW.

If you plan to include Internet Explorer with your customized Office package, you have two choices:

  • If you do not plan to customize Internet Explorer, you can install Internet Explorer components with the CIW; you do not need to use the IEAK.
  • If you plan to customize Internet Explorer, and you are deploying Office, then specify in the CIW that you want to customize Internet Explorer. The Custom Installation wizard starts the IEAK.

The IEAK Customization wizard runs in corporate administrator mode with the following settings:

  • The distribution media is CD.
  • Three installation options are available. You cannot change the names of these options, but you can specify which components will be installed with each installation option.
  • All of the .cab files and custom components that are created by the IEAK are placed in the same folder.

To use the IEAK as part of the CIW, Internet Explorer 5 and IEAK 5 must be installed on the computer where you are customizing your installation package.

Note

  • When using the Office Custom Install wizard, user options from Windows Update Setup for Internet Explorer will not be displayed during Setup. The user interface for Setup is determined by the Office Custom Install wizard.


Customizing the Search Assistant

The Microsoft Windows Search Assistant provides users with a single, unified search experience across different types of searches. It is a task-based searching tool that allows users to specify the type of information they are looking for instead of the search engine they want to use. The Search Assistant opens in the Search bar in the left side of the browser when the user clicks the Search button.

You can customize the Search bar to suit the needs of your organization. To do so, you specify the URL for the Search bar on the Important URLs screen in Stage 4 of the Internet Explorer Customization wizard.

The Search bar can be customized using the same functionality that is possible in the Internet Explorer browser. This includes JScript (compatible with ECMA 262 language specification), Visual Basic Scripting Edition (VBScript), ActiveX controls, Dynamic HTML, framesets, cascading style sheets (CSS), and so on.

The search results typically appear in the Search bar. It's critical for users to be able to easily use the results of any search service. You can use the Search bar functionality to store detailed information such as text abstracts, URLs, or file size. This information is contained in the ToolTips that appear when the mouse pointer hovers over a result. This helps keep the results page simple and provides detailed information when needed.

For information about customizing the Search Assistant, see the rest of this topic. For information about dimensions, design, and functionality, see The Search Bar User Interface. For information about the automatic search feature, which enables users to type search phrases into the Address bar, see Configuring Automatic Search. For more information about scripting and Dynamic HTML, see the Microsoft Site Builder Network Workshop.

Techniques for customizing the Search Assistant

The Search Assistant can be customized to meet specific searching needs. For example, additional information about search results can be stored within ToolTips, and search results can be highlighted on a particular Web page.

Search hit highlighting

Building customized Search Guides to search Web pages for a word or phrase is easy in Internet Explorer 5. The new NavigateAndFind method loads a specified Web page and scans the document for a match to the provided string. If a match is made, the string in the document is highlighted.

The following example opens the Microsoft Web site and searches for the words "Microsoft Corporation."

window.external.NavigateAndFind("http://www.microsoft.com","Microsoft Corporation");

ToolTips/abstracts

To help conserve space in the browser window and to improve the readability of search results, Internet Explorer enables you to define the specific information about a given link that should be included in a ToolTip. You do this by defining the TITLE= attribute of an HTML anchor tag.

The following example provides more information about the link:

<A HREF="http://www.acme-sports.com" TITLE="Latest sports news and scores, updated hourly. Interviews with winning players"> acme-sports - Latest sports news</A>

Point to this link to see how the results would appear: Latest sports news

New lines in ToolTips

The ToolTip automatically breaks lines at three inches and can contain at least a paragraph of text. However, no more than 1,024 characters are allowed within the ToolTip text. You can also force a new line or tab spaces in the abstract by using the reserved characters &#10; and &#13 for carriage return and line feed, and &#09 for tab spaces.

The following example includes a carriage return and a line feed after line 1 of the ToolTip:

<A HREF="http://www.microsoft.com"
TITLE="The text that will be displayed on line1&#10;&#13;
The text that will be displayed on line2&#10;
&#09;The text that will be displayed on line3&#10;
&#09;The text that will be displayed on line4">
Using multiple lines in ToolTips</A>

Point to this link to see how the results would appear: Using multiple lines in ToolTips


Configuring Automatic Search

You can customize automatic search, which enables users to type a conversational word into the Address bar to search for frequently used pages. Users will not need to remember the URLs for the pages that you specify, so key information can be easier to find.

For example, you could enable a Web page about invoices to appear when a user types the term "invoice" into the Address bar, even if the URL of the page doesn't contain this term. If you are a corporate administrator, the following topic shows you how you can customize automatic searching. If you are an Internet content provider or Internet Service provider, then send e-mail to autosrch@microsoft.com for more information.

This feature is already enabled for the Internet. For instance, typing in certain distinct, popular terms into the Address bar will cause a Web site associated with that term to appear. When a Web site cannot distinctly be associated with that term - for example, if there are several apparent matches - then a Web page showing top search results will be displayed.

The Web site that appears will not necessarily contain the exact search term in its URL. If a Web site whose domain is the same as the term is not the best match for the search term (for example, if the search term is the same as the URL without www. and .com), then the user will be redirected to the site that is the best match for that term. By default, the user will be prompted when a redirection occurs.

The Automatic Search URL is configurable using two parameters noted by using the percent (%) sign. These two values must be part of the URL itself. The value %1 represents what the user typed in the Address bar. The value %2 represents the type of search option chosen by the user. Possible values for %2 are 3, 2, 1, and 0, where 3 = display the results and go to the most likely site, 2 = just go to the most likely site, 1 = just display the results in the main window, and 0 = do not search from the Address bar.

To set up Automatic Search

  1. Create a script and post it to an intranet server.

    The search page can be a script file, such as an .asp file, that conditionally checks for search terms. The script needs to be hosted at this location: http://ieautosearch/response.asp?MT=%1&srch=%2
    If you are not using Internet Information Server (IIS), then you would need to remap this URL to the address where your script is located.

  2. If you are setting this option in the Internet Explorer Customization wizard, on the System Policies and Restrictions screen in Stage 5, click Internet Settings.

  3. If you are setting this option in the Profile Manager, click Policies and Restrictions, and then click Internet Settings.

  4. Click Advanced Settings, and then in the Searching area, type the term intranet into the Search Provider Keyword box.

Notes

  • If you're just redirecting users to another site rather than returning search results, then select Just go to the most likely site in the When searching from the address bar box.
  • If you are a corporate administrator, you are not customizing search, and your organization doesn't have Internet access, you may want to disable automatic searching. To do this, in the Searching area on the Advanced Settings screen, select Never search from the Address bar.

Sample .asp AutoSearch Script

<%@ Language=VBScript %>
<%
' search holds the words typed in the Address bar
' by the user, without the "go" or
' "find" or any delimiters like
' "+" for spaces.
' If the user typed
' "Apple pie," search = "Apple pie."
' If the user typed
' "find Apple pie," search = "Apple pie."
search = Request.QueryString("MT")
search = UCase(search)
searchOption = Request.QueryString("srch")

' This is a simple if/then/else
' to redirect the browser to the site
' of your choice based on what the
' user typed.
' Example: expense report is an intranet page
' about filling out an expense report
if (search = "NEW HIRE") then
Response.Redirect("http://admin/hr/newhireforms.htm")
elseif (search = "LIBRARY CATALOG") then
Response.Redirect("http://library/catalog")
elseif (search = "EXPENSE REPORT") then
Response.Redirect("http://expense")
elseif (search = "LUNCH MENU") then
Response.Redirect("http://cafe/menu/")
else
' If there is not a match, use the
' default IE autosearch server
Response.Redirect("http://auto.search.msn.com/response.asp?MT="
+ search + "&srch=" + searchOption +
"&prov=&utf8")
end if
%>


The Search Bar User Interface

The Search bar enables users to launch searches and view the results. When the user clicks the Search button, the search bar appears to the left of the browser in an area called the Explorer bar.

You can use the Search bar functionality to store detailed information such as text abstracts, URLs, or file size in the ToolTips that appear when the mouse pointer hovers over a result. This helps keep the results page simple and provides the user with detailed information when needed.

The Search bar is an integral part of Internet Explorer. Here are some guidelines you can follow when designing your own Search bar to ensure that it works well within the Explorer bar.

  • Result pages should always provide the ability to launch another search, with buttons for modifying and running the search in the top 20 percent of the content area.
  • Pages should fit within the 200-pixel width of the Search bar. If you use tables or other HTML layout elements, make sure they fit within the available width. Otherwise, you force the appearance of horizontal scroll bars, which take space away from your content and force the user to do more work. If you want to include more abstract or other information without consuming extra space, you can use ToolTips.
  • You can use Dynamic HTML, ActiveX technology, Java, and cascading style sheets to achieve dynamic effects and implement multimedia. Just remember that the space for the Search bar is limited.
  • The default size for the Search bar is 200 pixels wide and the full vertical size of the browser window, which is 430 pixels. This area may include advertisements or branding, as well as search information, depending on your requirements. The user is able to resize this area.
  • Because the Search bar is a tight space, you should prioritize your user interface. The basic rule of thumb is to provide the user with the best information without a lot of visual clutter or confusion. From the top of the page to the bottom, your interface should typically follow this order:
    • Your branding
    • Search query fields to refine
    • Search results
    • Ads or other services

    It is recommended that you place ads toward the bottom of the page, so users won't have to scroll beyond them to see their search results.

  • If your page requires the user to scroll, make sure that a significant number of actual results (not category results) are immediately visible.
  • The links for the Search results, or "hits," typically are displayed in the Search bar. When a user clicks of of these links, the Web page should appear in the main browser area. Avoid opening Web pages in the Search bar, because it does not contain Back and Forward buttons.


Managing ActiveX Controls

IEAK 5 introduces a new feature that enables the administrator to specify exactly which ActiveX controls are allowed to run in a particular zone. There are two major scenarios within which this feature offers a higher degree of usage control of ActiveX controls and thus a higher degree of security.

Scenario 1: Limited Internet usage of ActiveX controls

Many organizations make extensive use of ActiveX controls on the local intranet, yet want to limit use of ActiveX controls outside the firewall (i.e., in the Internet zone). While local intranet content can be trusted not to attempt malicious use of any controls it uses, these controls are not appropriate for use by Internet Web pages. By specifying the set of generic controls the administrator approves for use on the Internet, sites that use controls can still be supported while preventing any inappropriate use of other controls in that zone.

For example, suppose as administrator you want to limit use of ActiveX controls yet still allow an important Internet site (such as that of a business partner or service provider) to work with ActiveX controls. Visit the site and see what ActiveX controls it uses by noting new entries in the Downloaded Program Files folder of the Windows folder. Carry out the procedure at the end of this topic to specify that the controls are administrator approved.

After this has been configured, exactly those controls will be permitted to run on the site. Attempts by any Internet page to use other controls such as those intended for the intranet will be blocked.

Scenario 2: Restricted use of ActiveX controls

You can achieve a higher degree of control by listing all the approved ActiveX controls, and then allowing the browser to run only this approved set of controls. The cost of this additional degree of control is the extra effort to enumerate all the controls the administrator wants to allow to be used, so this approach is recommended where the total set of controls is relatively small.

Assess which controls are approved for use on any site. For zones that contain sites that are allowed to use these controls, carry out the procedure at the end of this topic to specify that the controls are administrator approved. For zones that contain sites that are not allowed to use these controls, select Disable in the Run ActiveX controls and plugins area. Now only the specified controls will ever run on Web pages and only in the allowed zones.

Choosing the ActiveX controls

Some common ActiveX controls are listed in the Active Control Administrator Approved file, Axaa.adm, which comes with the IEAK. This list is not a recommendation; it simply represents some of the commonly used ActiveX controls from the Web. As administrator, you should assess which, if any, of these controls are appropriate to use within your organization. You can edit this file and add any new controls you want. By default, no controls are listed as approved. If you want to add more controls after your users install Internet Explorer, you can use automatic configuration.

To specify that ActiveX controls must be approved by an administrator and to specify which controls you want to approve, carry out the following steps:

  1. Review the ActiveX control settings in the Axaa.adm file, which is located in the \Policies\<Language> subfolder of the IEAK folder. If you want to add more controls to this list, such as controls that your organization has created, use a text editor to edit the Axaa.adm file.

    It is recommended that you make a backup copy of this file in case you want to restore the original settings.

  2. On the Security Settings screen of the Internet Explorer Customization wizard, click Customize Security Zones settings, and then click Modify Settings.
  3. Select the content zone in which you want to manage ActiveX controls, and then click Custom Level.
  4. In the Run ActiveX controls and plugins area, click Administrator approved.
  5. Repeat the last two steps until you have set up all the zones you want.
  6. On the System Policies and Restrictions page in Stage 5 of the Customization wizard, click the Control Management category to expand its contents, and then select the check boxes for the controls you want to approve.


Internet Explorer Security Options

With Internet Explorer security zones, you can specify security options for different zones of Web content. A zone is a collection of Web sites that you trust at the same level. You assign a Web site to a specific zone, then you set the appropriate security options for that zone.

You can adjust the Internet Explorer default settings to best match the security features of your system. For a secure intranet, for example, you can usually adjust the security setting to Low or an appropriate custom setting (after the Local intranet zone is configured to match the firewall).

The following paragraphs describe the Internet Explorer security options in detail to help you make the right security decisions for each option in each zone. All security options apply to the Internet Explorer browser; they are not system-wide. Other Internet programs may or may not respect these options. This list contains the Internet Explorer security options for 32-bit versions of the browser, although some options also apply to 16-bit and UNIX versions of the browser.

The following settings or sections do not apply:

  • UNIX versions of the browser
    ActiveX controls and plugins
    Font download
    Software channel permissions
    Launching applications and files
    Installation of desktop items
  • 16-bit versions of the browser
    User authentication
    Font download
    Software channel permissions
    Installation of desktop items
    Active scripting
    Launching applications and files from an IFrame

To set corporate security options, you must modify the settings by using the IEAK. The user views security options in the browser by clicking the Tools menu, clicking Internet Options, and then clicking the Security tab. To see custom settings, the user selects a security zone, and then clicks Custom Level.

ActiveX controls and plugins

These options control how ActiveX controls and plugins are administrator approved, downloaded, run, and scripted. For more information about managing and approving ActiveX controls, see Managing ActiveX Controls.

When a user downloads an ActiveX control from a site different than the site the control is used on, Internet Explorer uses the more restrictive of the two sites' zone settings. For example, if a user is viewing a Web page within a zone that is set to allow (Enable) a download, but the code is downloaded from another zone that is set to prompt the user first, then the prompt setting is used.

Script ActiveX controls marked safe for scripting
This option determines whether an ActiveX control marked safe for scripting can interact with a script. Note that safe-for-initialization controls loaded with PARAM tags are not affected by this option. This option is ignored when Initialize and script ActiveX controls not marked as safe is set to Enable because the setting bypasses all object safety. You cannot script unsafe controls while blocking the scripting of the safe ones.

Initialize and script ActiveX controls not marked as safe
ActiveX controls are classified as being either safe or unsafe. This option controls whether or not a script is allowed to interact with unsafe controls. Unsafe controls are not meant for use on Internet Web pages, but in some cases may be used with pages that can absolutely be trusted not to use the controls in a malicious way. Object safety should be enforced unless all ActiveX controls and scripts that might interact with pages in this zone can be trusted. The settings are as follows:

Run ActiveX controls and plugins
This option determines whether ActiveX controls and plugins can be run on pages from the specified zone. Disabling this option prevents running any ActiveX controls or plug-ins; therefore, the other ActiveX settings are ignored. Downloading, running, and scripting ActiveX controls are three distinct steps with options that apply to each separate step. Downloading options distinguish between signed and unsigned controls. Scripting options can be set for safe and unsafe controls separately. Whether a control is safe for scripting (or initialization) is determined by the control author and should not be confused with signing; signing and safety are independent. For more information, see the Microsoft Site Builder Network Workshop.

Download signed ActiveX controls
This option allows users to download signed ActiveX controls from pages in this zone. The settings are as follows:

  • Enable lets users silently download any signed controls.
  • Prompt displays a warning before users download controls signed by publishers that aren't trusted. This setting still enables users to download trusted publisher-signed code silently.
  • Deny prevents users from downloading any signed controls.

Download unsigned ActiveX controls
This option allows users to download unsigned ActiveX controls from pages in this zone. This kind of code is potentially dangerous, especially when coming from an untrusted zone.

  • Enable overrides object safety. ActiveX controls are run, loaded with parameters, and scripted without setting object safety for untrusted data or scripts. This setting is not recommended except for secure and administered zones. This setting causes both unsafe and safe controls to be initialized and scripted, ignoring the Script ActiveX controls marked safe for scripting option.
  • Prompt attempts to enforce object safety. However, if the ActiveX control cannot be made safe for untrusted data or scripts, then the user is given the option of allowing the control to be loaded with parameters or scripted.
  • Disable enforces object safety for untrusted data or scripts. ActiveX controls that cannot be made safe are not loaded with parameters or scripted.

Java

Java permissions

You must have the Microsoft VM installed before the Java options are available.

These options control the downloading and running of Java within the zone. For Java downloads, if a control is downloaded from a different site than the page it is used on, the more restrictive setting of the two sites' zone settings is used. For example, if a user is accessing a Web page within a zone that is set to allow a download, but the code is downloaded from another zone that is set to prompt a user first, then the prompt setting is used.

The settings for most platforms are discussed below. For 16-bit versions of Windows operating systems, the available settings for Java permissions are Enable and Disable.

Each option setting determines the following:

  • The maximum permission level silently granted to signed applets downloaded from the zone.
  • The permissions granted to unsigned applets downloaded from the zone.
  • The permissions granted to scripts on pages in the zone that call into applets.

The five options are:

  • Custom controls permissions settings individually. In the Custom Permissions dialog box, the Unsigned tab specifies the permissions for both unsigned applets and for scripts calling Java. The Allowed Without Warning tab specifies the threshold up to which applets will silently be granted permissions.
  • Low Safety enables applets to perform all operations unhindered.
  • Medium Safety enables applets to run in their sandbox, an area in memory outside of which the program cannot make calls. It also enables capabilities like scratch space (a safe and secure storage area on the client computer) and user-controlled file Input/Output.
  • High Safety enables applets to run in their sandbox.
  • Disable Java does not allow any applets to run.

Scripting

Active scripting
This option determines whether script code on pages in this zone is run.

Scripting of Java applets
This option determines whether scripts within the zone are allowed to use objects that exist within Java applets, allowing the script on the page to interact with the Java applet.

Downloads

File Download
This option controls whether file downloads are permitted from within this zone. This option is determined by the zone of the page that contains the download link, not the zone from which the file is delivered.

Font download
This option determines whether users can download HTML fonts from pages within this zone.

User authentication

Logon

HTTP authentication honors the zone security policy for Logon credentials, which may have one of four values:

  • Automatic logon only in Intranet zone: Prompts for user ID and password in other zones. After the user is prompted, this value can be used silently for the remainder of the session.
  • Anonymous Logon: Disables HTTP authentication; uses guest account only for Common Internet File System (CIFS).
  • Prompt for username and password: Prompts for user ID and password. After the user is prompted, this value may be used silently for the remainder of the session.
  • Automatic logon with current username and password: The logon credential may be tried silently by Windows NT Challenge response (NTLM), an authentication protocol between an end-user client and application server, before prompting.

Miscellaneous

Access data sources across domains
This option specifies whether components that connect to data sources should be allowed to connect to a different server to obtain data. This applies only to data binding, such as active data objects. The settings are as follows:

  • Enable allows database access to any source, even other domains.
  • Prompt prompts users before allowing database access to any source in other domains.
  • Disable allows database access only to the same domain as the page.

Submit non-encrypted form data
This option specifies whether HTML pages in the zone can submit forms to or accept forms from servers in the zone. Forms sent with SSL (Secure Sockets Layer) encryption are always allowed; this setting affects only non-SSL form data submission.

Launching applications and files in an IFrame
This option controls whether users can launch applications and files from an IFRAME tag (containing a directory of a folder) in Web pages within this zone.

Installation of desktop items
This option controls whether users can install desktop items from Web pages within this zone.

Drag and drop or copy and paste files
This option controls whether users can drag or copy files from Web pages within this zone.

Software channel permissions
The settings are as follows:

  • Low safety allows:
    • E-mail notification
    • Auto download
    • Auto installation
  • Medium safety allows:
    • E-mail notification
    • Auto download
  • High safety allows:
    • None of the software channel distribution features

Cookies

Allow per-session cookies (not stored)
Determines the settings for cookies, text files that store the user's preferences, that are used by a Web site while the user is visiting the site. For example, this setting would determine whether a "virtual shopping cart" could be created while a user is shopping online. Per-session cookies do not remain on the hard disk.

The settings are as follows:

  • Enable means that cookies are automatically accepted.
  • Prompt means that users receive a prompt before a cookie is created.
  • Disable means that no cookies can be created. If you disable per-session cookies, some Web sites may not work properly.

Allow cookies that are stored on your computer
Determines the settings for cookies that are stored on the user's hard drive for future browsing sessions. For example, this setting would determine whether a list of preferences or a user's name was retained for the user's next visit.

The settings are as follows:

  • Enable means that persistent cookies are automatically accepted.
  • Prompt means that users receive a prompt before a persistent cookie is created.
  • Disable means that no persistent cookies can be created. If you disable persistent cookies, some Web sites will not retain their settings when the user returns to the site.

Security options that cannot be configured

The following options are fixed and cannot be set by the user. High, Medium, Medium-low, and Low zone settings do not change the behavior of these options.

Launch From Webview
This option controls whether users can start programs and files from a folder viewed as a Web page. This setting applies to Windows 98 users and to users who upgraded from Internet Explorer 4 and are using the Windows Desktop Update. The zone of the customizing Web content, not the zone of the folder itself, determines the setting:

My Computer | Local Intranet | Trusted Sites | Internet | Restricted Sites
Enable | Enable | Enable | Prompt | Prompt


Understanding Settings and Restrictions

Internet service providers, Internet content providers, and corporate administrators can specify default settings for their users before installing the browser. You can specify these settings in Stage 5 of the Internet Explorer Customization wizard. For example, you might want to:

  • Specify server lists for components such as Chat and NetMeeting.
  • Determine which programs are used for electronic mail and for placing Internet calls, and set up a page to update your users periodically.
  • Predetermine the user's connection settings. If you need to manage multiple connection settings, consider using the Connection Manager Administration Kit, and then importing your custom profile.

Corporate administrators

If you are a corporate administrator, you can also set policies and restrictions that help you manage bandwidth, control the behavior and appearance of Internet Explorer, and determine which features users can change.

For an illustration of this feature, see System Policies and Settings.

The ability to set policies and restrictions helps you extend the power of the Customization wizard. For example, they eliminate the need to specify settings individually on each user's computer. And if different sets of users have unique needs, you can create Profile Manager (.ins) files for different sets of users.

You can set policies and restrictions in two ways:

  • In Stage 5 of the Customization wizard.
  • In the Profile Manager, using automatic configuration.

    To use the Profile Manager, create a new user profile or open an existing profile. Then, expand the folders until you see the setting or restriction that you want to change. You can find more information about each Policies and Restrictions category by clicking the folder for the category.

With automatic configuration, browser settings and restrictions are maintained at the location that you specify in the Customization wizard or in the Internet Options dialog box. To check this location on your user's computers:

  1. Click the Tools menu in the browser.
  2. Click Internet Options.
  3. Click the Connections tab, and then click LAN Settings.

    4. Verify that the Use automatic configuration script option is selected, and check the path in the Address box.

You can set restrictions in the following categories:

  • Wizard Settings: Represents the pages of the Internet Explorer Customization wizard. These pages enable you to specify settings and make changes through automatic configuration.
  • Internet Settings: Contains settings from the Internet Options dialog box, such as security, ratings, and connections, as well as channels and browser menu settings.
  • Web Desktop: Enables you to determine how users can interact with the shell, or visible part, of their operating system. These settings control how users manage files, how their Start menu appears, how they use printers, and how they manage other everyday tasks.
  • Subscriptions: Enables you to control bandwidth and how users work with subscriptions and channels. The settings are helpful if you are concerned about server load.
  • NetMeeting, Chat, Outlook Express: Enable you to control bandwidth, server settings, and the appearance of these components.

Note

  • If you are familiar with .adm files, you can use the policies and restrictions you have set up in your own .adm files by clicking Policy, and then clicking Import. You can find .adm files that you can customize in the appropriate language for the IEAK Policies folder.


Setting Up a Sign-up Server for Full-Screen Kiosk Mode

An Internet sign-up server (ISS) is a Hypertext Transfer Protocol (HTTP) server that automates the task of adding new customers to an Internet service provider's (ISP) customer database. The ISS collects information from each new customer, adds the information to the ISP's customer database, and then passes a configuration packet back to the customer's desktop computer. The configuration packet contains information that is used to configure the customer's Internet browser for subsequent connection to the ISP's services.

For an illustration of the sign-up process, see ISP Sign-up Process.

This document provides information that an experienced Internet server administrator can use to implement an ISS. It assumes that you are already familiar with HTTP, Hypertext Markup Language (HTML), and Common Gateway Interface (CGI) processing.

The ISS adds a new customer to the ISP's database in three steps:

  1. Establishes an HTTP connection with a customer's desktop computer.
  2. Collects sign-up information from the customer.
  3. Handles the customer's acceptance or refusal of the ISP's services.


Software Distribution Channel

After the Internet Explorer browser is distributed and installed, you can provide future updates through a software distribution channel.

By default, Internet Explorer 5 automatically notifies users when when new releases of and updates to Internet Explorer are available. You can control how often Internet Explorer checks for this updated information. A Software Distribution Channel is not required for this notification method. For more information, see Updating Users Periodically.

For more information about software distribution, see the Microsoft Site Builder Network Workshop.


Error Log Information for Active Setup Log.txt

The Active Setup Log.txt file can help you troubleshoot Setup errors and the status of Setup when the error occurred. You can find the following entries in the log:

0 - Initializing (making a temporary folder, checking disk space).
1 - Dependency (checking for all dependencies).
2 - Downloading (server is downloading files).
3 - Copying (files are being copied from download folder to temporary install folder).
4 - Retrying (Setup is restarting download because of a timeout error or other download error).
5 - Checking trust (checking permissions).
6 - Extracting files.
7 - Running Setup program (an .inf or .exe file).
8 - Finished (installation is finished).
9 - Download finished (files have finished downloading).

Some common error codes:

80100003 - Files are missing from the download folder during installation.
800bxxxx - An error code starting with 800b is a trust failure.
800Cxxxx An error code starting with 800C is a urlmon failure.

Some common examples are:

800C005 - File or server not found.
800C00B - The connection timed out.
8004004 - The user canceled Setup.


Including a User Agent String

Some companies track site statistics, such as how many times their content is accessed and by which types of Web browsers. User agent strings help to identify the browser type.

If you gather browser statistics and your information includes the user agent string, you can track the usage of your customized browser. In the Internet Explorer Customization wizard, you can add characters to the end of the user agent string to customize it.

Your customized string will appear in any statistics that include the user agent string. Be aware that other companies that track statistics will see your customized string. Avoid using a string that you don't want others to see.

Here's an example of a user agent string:

Mozilla/4.0(compatible; MSIE 5.0; WindowsNT; YourCustomString)


Building Customized IEAK Packages for UNIX

You can now use the Internet Explorer Customization wizard and Profile Manager to build customized packages and administer Internet Explorer for the UNIX (Solaris 2.5.1 or 2.6) operating system.

You build the packages and run the IEAK from a computer running Internet Explorer 5 and any Windows 32-bit operating system (except Windows NT 3.51).

Some customization features, deployment methods, and maintenance practices differ from the Windows versions of the browser.

Here's some information you should know about building UNIX browser packages:

  • The Setup package will consist of one large file instead of a collection of files or a set of floppy disks.
  • The Customization wizard and Profile Manager support the corporate administrator role of the IEAK.

    • Unlike Internet Explorer 32-bit versions of the browser, 16-bit and UNIX versions of the browser do not perform digital signature verification. Programs or cabinet files for these operating systems do not need to be signed.

  • The UNIX functionality in the IEAK supports the more common UNIX method of installing the customized product on only a few servers. Users can then run Internet Explorer from this location rather than installing the product locally. This configuration is recommended for UNIX installations. The Windows Update Setup Wizard for Internet Explorer and Other Internet Tools, which downloads .cab files, is not available on the UNIX platform.
  • When creating customized browsers for Windows 3.1 and UNIX, you should make sure any channels you include will be displayed correctly on those platforms. The channels will appear in the Explorer bar, which appears in the left part of the browser when the user clicks the Channels button, but they do not appear in a separate channel bar on the desktop.


Microsoft Internet Explorer Administration Kit Help

The Internet Explorer Administration Kit

helps you customize, deploy, and maintain Internet Explorer.

You can deliver "the Web the way you want it." Browse online Help to find out how.

Explore the Index

Perform a Full-Text Search

Print Topics

© 1999 Microsoft Corporation. All rights reserved. Terms of Use.
Photography: PhotoDisc, Inc.


Examples of Wildcard Characters

  • Enter a wildcard at the beginning of an Internet address, IP address, or domain name to bypass servers with a common ending. For example, use "*.example.com" to bypass any entries ending in ".example.com" (such as "some.example.com" and "www.example.com").
  • Enter a wildcard in the middle of an Internet address, IP address, or domain name to bypass servers with a common beginning and ending. For example, the entry "www.*.com" matches any entry that starts with "www" and ends with "com" (such as "www.someplace.com," "www.almost.anywhere.com," and so on).
  • Enter a wildcard at the ending of an Internet address, IP address, or domain name to bypass servers with a common beginning. For example, use "www.someplace.*" to bypass any entries that begin with "www.someplace." (such as "www.someplace.com", "www.someplace.org", and "www.someplace.else.com").
  • Use multiple wildcards to bypass addresses with similar patterns. For example, use "123.1*.66.*" to bypass addresses such as "123.144.66.12", "123.133.66.15", and "123.187.66.13."

Note

  • Although wildcards are powerful, they must be used carefully. For example the entry, "www.*.com," will cause Internet Explorer to bypass the proxy for most Web sites.


Building Customized 16-bit IEAK Packages

You can now use the Internet Explorer Customization wizard and Profile Manager to build customized packages and administer 16-bit versions of Internet Explorer.

You build the packages and run the IEAK from a computer running Internet Explorer 5 and any Windows 32-bit operating system (except Windows NT 3.51).

Some customization features, deployment methods, and maintenance practices differ from the Windows 32-bit platform.

Here's some information you should know about building packages for Windows 16-bit platform:

  • Unlike Internet Explorer 32-bit versions of the browser, 16-bit and UNIX versions of the browser do not perform digital signature verification. Programs or cabinet files for these operating systems do not need to be signed.
  • If you build a Windows 32-bit platform package, and then rebuild a Windows 16-bit platform package in the same folder, the file names are automatically converted to eight-character names with three-character extensions (8.3 format). If you rebuild a Windows 32-bit platform package in the same location, the file names will continue to be converted into 8.3 format.If you need to build a Windows 32-bit platform package after you build a Windows 16-bit platform package, it's recommended that you build it in a new location.
  • The Setup graphic must be a 16-color, 162-by-312 pixel .bmp file.
  • You must include the Stack and Dialer for Windows 16-bit platforms if your users need dial-up access. If some users are running Windows NT 3.51 and some are running Windows 3.x, you should include at least two installation options: one with the dialer (for Windows 3.x and Windows for Workgroups 3.x) and one without it (for Windows NT 3.51). For dial-up access, Windows NT 3.51 computers must first be configured for Remote Access Service.
  • You can create multiple-floppy-disk builds for Windows 3.1 and Windows for Workgroups 3.11, but not for Windows NT 3.51.
  • The following security options for 32-bit versions of the browser do not apply to 16-bit versions of the browser:
    • User authentication
    • Font download
    • Software channel permissions
    • Installation of desktop items
    • Active scripting
    • Launching applications and files from an IFrame


Company Name and Customization Code

On this screen, you enter your company or organization's name and your 10-digit customization code. You must also choose your role.

  • Company name
    Type the name of your company or organization. This is not the name that will appear in the title bar of the browser. You will set this option later in the Internet Explorer Customization wizard.
  • Customization code
    This customization code is required; you cannot run the wizard without it. Keep this code safe and do not distribute it. You should have received your customization code via mail or e-mail after you registered. You must register to be licensed to redistribute Internet Explorer and related products. If you have lost your customization code, see the IEAK Web site for further instructions.

    • Options for your role are:

    • Content provider/developer if you provide custom content, links, and functionality to users. Available for 32-bit and 16-bit versions of the browser.
    • Service provider if you provide Internet service to users. Available for 32-bit and 16-bit versions of the browser.
    • Corporate administrator if you manage Internet software and services for a company or organization. Available for 32-bit, 16-bit, and UNIX versions of the browser.

    You must choose the role that matches your license agreement.


Platform Options

You can build customized Internet Explorer packages for the following operating systems:

32-bit versions of the browser run on these operating systems:

  • Windows 95
  • Windows 98
  • Windows NT 4.0

16-bit versions of the browser run on these operating systems:

  • Windows 3.1
  • Windows for Workgroups 3.11
  • Windows NT 3.51*

    *Note: Although Windows NT 3.51 is a 32-bit operating system, it runs the 16-bit version of the browser.

UNIX versions of the browser run on these operating systems:

  • Solaris 2.5.1
  • Solaris 2.6

To build an IEAK package for a different operating system, you must run the Internet Explorer Customization wizard again.

Windows 16-bit versions of the browser
Some customization features, deployment methods, and maintenance practices are different for these Windows operating systems. For more information, see Building Customized 16-bit IEAK Packages.

UNIX versions of the browser
Some customization features, deployment methods, and maintenance practices are different for the UNIX operating systems. For more information, see Building Customized IEAK Packages for UNIX.


Language Selection

Choose the language you want from the Target language list. If the language you want to use is not listed, quit the wizard, insert the CD that contains the language you want to use, and then restart the wizard.

The language you choose determines how the following folders are structured:

  • A subfolder for each localized version (for example, EN for English and DE for German) is created in the destination folder for your browser package. The destination folder is where the customized packages will be placed when the wizard is finished. The subfolder for your localized version is created in a platform subfolder, which is created in your destination, or build, folder

    For example, if you specify that your destination folder is C:\Cie\Build1\, your customized package that contains a downloadable English-language 32-bit version of Internet Explorer 5 would be created in this folder:
    C:\Cie\Build1\Download\Win32\En

If your users install the Windows Desktop Update, the language must match the language of their operating system. This limitation does not apply to the browser. If users attempt to install the browser and shell in a different language, only the browser will be installed.

You must run this wizard once for each localized version you want to create. To retain settings across multiple versions, specify the same destination folder for each version. The localized versions will then be saved in different subfolders.


Media Selection

On this screen, you determine which type of media you will use to distribute your package.

Download
Select this option to build a package for downloading over an intranet or the Internet. You can build your customized packages on your hard disk, and then move them to an Internet server or, if you're a corporate administrator, an intranet server. You can also build your packages directly on the server by specifying the server path as the target folder. For more information, see File Locations.

CD-ROM
When you create a version on CD-ROM, you can also specify Autorun information. This option groups your custom package into a set of folders and provides support for Autorun, which is a screen users see when they insert the CD-ROM into their computers.

Flat (all files in one folder)
If you build your packages on a local area network, or if you plan to move your packages to one, select this option to place all of the necessary files in one folder under the target destination (for example, C:\Cie\Lan).

Multiple floppy disks
You can also create multiple 1.44 MB floppy disks. In the destination directory you specified, you will find a folder named \Mfloppy that contains subfolders named Disk1, Disk2, and so on. Copy the contents of these folders to your floppy disks. You can create multiple-floppy-disk builds for Windows 3.1 and Windows for Workgroups 3.11, but not for Windows NT 3.51.

The Automatic Install feature is not available for multiple-floppy-disk installations.

When you select this option, all of the necessary files are grouped together instead of being separated for disk distribution; files associated with CD-ROM distribution, such as Autorun, are not included. This option is most useful for corporate administrators who have a file server network and application deployment system already in place.

Single floppy disk (ISPs only)
Select this option to distribute a small set of files via one floppy disk; these files initiate the rest of the download process. This eliminates the need to create and duplicate multiple floppy disks. Note: Even if you specified earlier in this wizard that you want to build on a single floppy disk, this option is not available when you use the no-sign-up method. The single-floppy build will not be created.

Single-disk branding
Select this option to customize an existing installation of Internet Explorer (versions 4.01 Service Pack 1, which came with Windows 98, and higher). This option creates a Setup.exe file in the BrndOnly folder of your build location. You can distribute this file on any media or server. When this file is run, it will customize Internet Explorer features, including Internet sign-up for ISPs, without installing Internet Explorer. This option does not enable you to package and install custom components, however.

Internet sign-up by using the Internet Connection wizard (ICW) is not available through single-disk branding on Internet Explorer 4.01 SP1 unless the user is running version 5 of the ICW. The ICW version that was released with Windows 98 was not enabled for use with the new ICW sign-up method with the IEAK. You can also create an Internet sign-up program through single-disk branding by using the kiosk sign-up method.


File Locations

You can change the destination folder, where your IEAK package is created, and the folder where your components are downloaded.

Destination folder
The destination folder is where the customized packages will be placed when the wizard is finished. You can create the package on your hard disk and move it to an Internet or intranet server, or you can create it on a Web server.

Subfolders for each localized version are created in the destination folder you specify for each platform and media type.

If you are creating the package on your hard disk or network drive, the recommended destination is C:\Cie\Dist. If you are creating the package on a Web server that is running from your hard disk, the destination should be the path to the Web server.

For example, if you specify your destination folder as
C:\Inetpub\Wwwroot\Cie\Dist,
then the English language version for Windows/NT 4.0 would be created in the
C:\Inetpub\Wwwroot\Cie\Dist\Download\Win32\En
folder.

Advanced Options
To customize the location and process for downloading files, or to import settings from an existing .ins file, click Advanced Options.

  • Check for latest components via (AVS) Automatic Version Synchronization
    The IEAK can check on the Internet for the latest versions of components when you create your Internet Explorer package. This feature can help you detect whether new versions have become available since the last time you ran the Internet Explorer Customization wizard.

    • If you downloaded the IEAK from the Internet, you must run the Customization wizard with AVS at least once, so that the wizard can check for updated versions of components.

  • Path of .ins file to import settings from

    To import settings from an existing .ins file as a starting point for a new IEAK package, enter the full path. Importing settings can save time if your new package will have similar settings. You can, however, change any settings you want.

  • Component download folder
    The components and setup files that you download will be placed in the folder you specify. The Automatic Version Synchronization (AVS) feature automatically checks this folder to determine whether you have the latest components available. With AVS, you download only the components that have changed since the last time you downloaded them. It is recommended that you do not change this folder, so that you can keep the components synchronized.

    • You should change this folder only if you plan to retain the files you downloaded the last time you ran the wizard, and you want to download a new set of components.


Feature Selection

You can determine which remaining screens of the wizard are displayed by selecting or clearing the check boxes on this screen. For example, if you plan to customize only links and URLs, you could clear the other check boxes, so that other screens aren't displayed. This will help you complete the Customization wizard quickly and easily by displaying only the screens you need.


Stage 1 Overview: Gathering Information

In this stage of the Internet Explorer Customization wizard, you will be prompted for basic information, such as the language and platforms of the package you are creating.

The options that are available will depend on whether you are a:

  • Corporate administrator
  • Internet service provider
  • Internet content provider

Note

  • The Customization wizard will not work correctly if Internet Explorer 5 is not installed. For more information, see Hardware and Software Requirements.


Download Site and Automatic Version Synchronization (AVS)

In this step, you will download the latest Microsoft programs and tools. If you already have the latest version of a component, you will be prompted to keep it. You may need to temporarily disable virus-checking programs to download components; a message will be displayed if this is necessary.

Microsoft Download Site
Choose the site that you will download the latest Internet Explorer and Internet Tools from, and click Next to see the Automatic Version Synchroni.

Download Internet Explorer components
Download the latest version of any Microsoft components shown in the box. The status of each component is indicated as follows:

This symbol | Means this
Red X | This component is not currently downloaded.
Yellow exclamation point | An outdated version of this component has been downloaded.
Green check mark | The latest version of this component has already been downloaded.

You must download the Internet Explorer browser to continue beyond this step.

Notes

  • To download or update more than one component, select each component you want, and then click Synchronize. To download all components, click Synchronize All.
  • For an illustration of this feature, see Automatic Version Synchronization.
  • For information about components and ComponentID strings, see the IEAK Web site.
  • If you cleared the Automatic version synchronization (AVS) check box in the first stage of this wizard, the Internet Explorer Customization wizard will not be able to verify whether you have the latest version of the components. The icons will not be green, even if you have the latest version. For those components that you have already downloaded, the icons will be yellow. For components you have not downloaded, the icons will be red. Also, if you have disabled version synchronization, you will not be able to download specific components in this stage of the wizard.
  • In this stage of the wizard, the Setup files for Internet Explorer and other components are downloaded to your computer. It's recommended that you keep a copy of these files on your hard disk. This will make it easier to rebuild your package later and to enable the Customization wizard to check to see whether newer versions of these programs are available.


Add Custom Components

You can add up to 10 custom components that your users can install at the same time that they install the browser. These components can be compressed cabinet (.cab) files. For 32-bit versions of the browser, these components can also be self-extracting executable (.exe) files.

For 32-bit versions, it is recommended that you sign any custom code that will be downloaded over the Internet. Code-signing lets users know they can trust your code before downloading it to their computers. The default settings in Internet Explorer will reject unsigned code.

For the UNIX platform, you should create a cabinet file that contains your add-on components and installation scripts. Then, specify the name of the cabinet file, the script name, and size information on this page of the wizard. You can specify up to 10 components. For more information, see Preparing a UNIX Component for Installation.

Some of the following options are not available on all platforms.

Component
Type the name of your component in this box. This name appears on the setup screen when users install your software.

Location
Type the path to your program or click Browse to search for it.

Command
If you specify a .cab file, you must also specify a command to run to extract the cabinet file.

Parameter
You can specify any switches to run with your custom program. For example, you might want to install your program "silently," with few or no prompts, so that users don't see prompts for your program as well as prompts for Internet Explorer. To specifically exclude setup prompts, you would use the /q:a switch.

Uninstall Key
Registering your uninstall program enables users to remove your program by clicking the Add/Remove Programs icon in Control Panel. To register your uninstall program, your application needs to add the following entries for the Uninstall subkey during Setup. For a sample uninstall file, see the Uncheck.inf file in the Inf folder of the IEAK Toolkit.

HKEY_LOCAL_computer\Software\Microsoft\Windows\CurrentVersion\
Uninstall\ApplicationName,UninstallString

  • ApplicationName = the display name of your program
  • UninstallString = path [ switches ]
Both the DISPLAYNAME and UNINSTALLSTRING values must be supplied and be complete for your uninstall program to appear in Control Panel. The path you supply to UninstallString must be the complete command line used to carry out your uninstall program. The command line you supply should carry out the uninstall program directly rather than from a batch file or subprocess.

The Uninstall Key field on this page should match the ApplicationName value if you want this program to be uninstalled when Internet Explorer is uninstalled.

Verify
Programs installed over the Internet typically need "digital signatures" that identify their source and guarantee that the code hasn't changed since it was signed. Depending on browser safety settings, users can be warned before the program is downloaded. Certification authorities can supply public and private keys needed to sign code. To determine whether the program has been digitally signed, click Verify. If you sign the rest of your files when you run the Internet Explorer Customization wizard, then this component will also be signed with that certificate.

For general up-to-date information about code signing, see the Microsoft Web site.

GUID
If your program already has a globally unique identifier, or GUID, type it in this box. If your program doesn't have a GUID, one will be generated for you. A GUID establishes a unique identity for programs, objects, and other items.

Version
Setup uses the version number to compare what is being installed with what is currently installed on the computer. When reinstalling a component, Setup will not install an older version. The version number helps you track versions of your program and ensure that the latest version is installed. The correct format for entering this version number is: xxxx,xxxx,xxxx,xxxx.

Description
Type up to 511 characters to describe your component. This text will appear in Setup when the user points to the component.

Install this component before Internet Explorer is installed
If you need to install a custom component before Internet Explorer is installed (for example, to run a batch file to preconfigure user settings), select this check box.

Tip
Tools for creating Iexpress scripts are included in the IEAK. Additional tools are available from the Microsoft Site Builder Network Workshop. For more general information about Setup technology, see Setup for Internet Explorer and Other Internet Tools.


Stage 2 Overview: Specifying Setup Parameters

In this stage of the Internet Explorer Customization wizard, you will specify information and locations for Setup.

The options that are available will depend on whether you are a:

  • Corporate administrator
  • Internet service provider
  • Internet content provider


Customize Setup

You can customize how Setup appears to your users. You can change the title bar and the graphic that appears when users run the Windows Update Setup wizard. If you provide a group of customized components, you can assign a name to them.

Setup wizard title bar text
This text appears in the title bar of the Setup wizard your users run. This text does not appear in the title bar of the customized browser. You can customize the browser title later in the Internet Explorer Customization wizard.

Setup wizard bitmap paths
These graphics will customize the appearance of the Setup wizard. You should avoid using graphics with complex lines and patterns.

  • 32-bit versions of the browser: The Setup wizard contains two 256-color bitmaps. The left vertical bitmap (on the first Setup wizard page) is 162-by-312 pixels. The top horizontal bitmap (on the remaining Setup wizard pages) is 496-by-56 pixels. The horizontal graphic appears behind some Setup instructions, so use a bitmap that won't interfere with readability.
  • 16-bit versions of the browser: The Setup wizard contains one bitmap that is 162-by-312 pixels. A 16-color bitmap is recommended. For more information, see Creating Customized Graphics.

Custom components installation title
You can install custom components when you install the customized browser. If you have specified more than one custom component, you can name them as a group; for example, you might have a group of components named Volcano Coffee Company Inventory Programs. This name appears in the Setup wizard when your users install their custom packages. Enter the title you want to appear.


Connection Manager Customization

You can use the Connection Manager Administration Kit (CMAK) to customize and manage how customers connect to the Internet. With the CMAK, you can change the appearance and settings of the Connection Manager dialer.

To run the Connection Manager Administration Kit so that you can create a custom profile, click Start CMAK.

When you use the CMAK, it creates a self-extracting executable (*.exe) file that installs itself on your user's computer. You do not need to digitally sign the .exe file created by the CMAK before you include it in the IEAK. When you sign the IEAK files, the CMAK file is also signed.

Use Custom Profile
If you've already created a custom profile, type the path of the profile you want to use for this browser package. The profile specifies customized content and connection methods.


Silent Install

Depending on how you plan to install your customized packages, you may want to provide your users with an interactive installation, a hands-free installation with prompts if errors occur, or an installation with no prompts.

If you want to provide an interactive installation for your users, in which they make installation decisions, click Interactive install.

If you want to provide a "hands-free" installation, in which users aren't prompted to make decisions but are informed of the installation progress and errors, click Hands-free install.

If you want your users to install the customized browser without receiving prompts, click Completely silent install. You should select this option when you want to control all setup options and suppress feedback to the user.

Selecting this check box is the same as installing Internet Explorer with the /Q:A switch. This mode is not interactive, and users will not have control over its progress. If installation does not finish successfully, users will not see an error message. You might consider using this feature for installations deployed when the user is not present. To fine-tune the installation, you can use additional Internet Explorer batch setup switches.

A silent installation (Hands-free or Completely silent) does the following:

  • Answers prompts that enable Setup to continue.
  • Accepts the license agreement.
  • Specifies that Internet Explorer will be installed and not just downloaded.
  • Carries out the type of installation that you specify (such as Standard or Custom). You will set this option later in the Internet Explorer Customization wizard.
  • Installs Internet Explorer in the location you specify, unless Internet Explorer is already installed. In that case, the new version of the browser is installed in the same location as the previous version.
  • Connects to the first download site specified in the IEAK. You will provide a list of download sites later in the Customization wizard.

Note

  • In a silent install, you can specify only one installation option and one download site for your users.


Installation Options

You can specify up to 10 installation options, such as Standard and Custom, and determine which standard and custom components are installed with each. If you are a corporate administrator and you have specified a silent installation, you will have only one option.

For the UNIX version of Internet Explorer, you will determine which available components will be a part of your Setup package. To move items from the Components available area to the Components to install area, click the arrows.

Option
Select the default installation option you want, or click New to create a new setup option. Type the description for the option, and then add or remove the components you want by clicking the arrows.

If you're an ISP, you might want to create a setup option for a specific set of customers; if you're a corporate administrator, you might want to specify setup options for different branches of your company.

Description
Type a description of the installation option, such as a list of components and programs that are installed. This text appears in the Windows Update Setup wizard that users will see.

Components available
The list of available components includes the Internet Explorer components you have downloaded and any custom components you have defined. To add components to this list, return to Stage 2 of the wizard.

Components to install
This list shows the components that will be installed with the option that appears in the Option box. Click the single arrows to add or remove a single component or the double arrows to add or remove all available components.

Note

  • If you are installing Internet Explorer 5 on a computer that has never run Internet Explorer 4, and you want your users to have channels, add the Offline Browsing Pack to your installation.


Component Download Sites

You must specify at least one download site, using an HTTP or FTP server, for your users to download your package from. You can specify up to 10 sites. You must place all the Microsoft components and custom components at each URL you specify below.

Site name
Type the name of your site. You can specify a friendly name that helps to identify the site. Do not use commas in the name.

Site URL
Type the URL for your site. The file Ie5sites.dat will be added or updated and a subfolder for the language of the package, such as EN for English, will be appended to the URL.

Site region
Type the region where your site is located, such as the city, state, region of the country, or country.

Custom download sites
The sites you specify will be listed in this column.

If the first site is down (for example, as a result of server problems), Setup will not be able to locate the remaining sites by default. A workaround involves overwriting the first site with the following command:

<path>\ie5setup.exe /c:"ie5wzd.exe /s:""<path>\ie5setup.exe"" /L:""http://my Web server/my Web site/ie5sites.dat"""

<path> is the folder where IE5setup.exe is located.

Here's an example:

c:\ie5setup.exe /c:"ie5wzd.exe

/s:""D:\Build\1700\package\download\win95_nt\en\ie5setup.exe""

/L:""http://<NewServerAddress>/<YourDownloadDir>/ie5sites.dat """

Note

  • You can specify only one download site for a silent installation.


Component Download

When a new version of Internet Explorer is available, users can update Internet Explorer by clicking the Tools menu and then clicking Windows Update in 32-bit versions of the browser. Users may also see this page when they click Add/Remove Programs in Control Panel, click Internet Explorer 5 and Internet Tools, and then click Add/Remove.

The default location for obtaining product updates is on the site(s) where users downloaded their customized browsers, but you can specify your custom add-on page.

Download all components from Microsoft sites after installation
Selecting this check box specifies that all components will be downloaded from Microsoft sites after installation.

URL of Add-on Component page
If you want users to obtain software updates from another location, specify a different URL.

Note

  • The configuration ID and version number available in previous versions of the IEAK, which formerly appeared on this screen, are no longer necessary. These values are generated automatically. The customizations, or branding, that you generate with the IEAK will always get installed, regardless of version number or configuration ID.


Installation Directory

If you are a corporate administrator, you can specify where you want Internet Explorer and other components to be installed. You can also determine whether the user can change the folder that you specify.

To allow the user to change the location that you specify, select the Allow the user to choose the installation directory check box. If you select this check box, the selection you make below appears as the default location.

If you click Install in the specified folder within the Windows folder or Install in the specified folder within the Program Files folder, Internet Explorer will be installed in the subfolder shown in the box.

If you select the Specify the full path of a custom folder check box, you can enter the path you want. If this path doesn't exist on the user's hard disk, it is created.

Notes

  • If Internet Explorer is already installed on the user's computer, the new version is installed over the existing version. The customized browser is not installed in the custom location you specify.
  • The UNIX functionality in the IEAK supports the more common UNIX method of installing the customized product on only a few servers. Users can then run Internet Explorer from this location rather than installing the product locally. If you need to install Internet Explorer locally, specify the location on this screen of the wizard.


Corporate Install Options

You can determine to what extent, if at all, your users can customize setup.

Disable Custom Installation option
Users can add or remove components to further customize setup. To prevent users from adding or removing specific components, select this check box.

Disable saving uninstall information
Setup automatically saves uninstall information. To save disk space, you can disable this feature by selecting this check box. However, users will not then be able to remove Internet Explorer 5 by clicking the Add/Remove Programs icon in Control Panel.

Disable Internet Explorer Compatibility mode
With the Internet Explorer compatibility option, users can run Internet Explorer 4 on the same computer as Internet Explorer 5. To disable this feature, select this check box.

Default browser options
Choose one of the three options to determine whether or not Internet Explorer is the default browser, and whether or not users can make this choice. The default browser runs when users open .htm, .html, and other associated file types. This option also determines whether Windows Media Player is the default program for playing multimedia files.

Note

  • If you are using a silent installation or customizing Internet Explorer for Microsoft Office deployment by using the Office Custom Install wizard, user options for Internet Explorer will not be displayed during Setup.


Windows Desktop Update

The Windows Desktop Update makes the desktop and folders look and work more like the Web. Although the Windows Desktop Update is not a part of Internet Explorer 5, you can include it with your IEAK package. If your users are running Windows 98, they already have the desktop features.

If you choose to install the Windows Desktop Update, you can customize its settings later in the wizard, if your build computer is running one of the following configurations:

  • Internet Explorer 5 upgraded from Internet Explorer 4.0 with the Windows Desktop Update installed
  • Internet Explorer 5 and Windows 98, which includes the new desktop

This can be helpful in setting a corporate standard desktop.

Do you want to integrate the Windows Desktop Update in your custom package?
To install the Windows Desktop Update, click Yes. If you don't want to install it, click No.


Advanced Installation Options

You can further customize Setup by having Setup detect whether a component exists and by fine-tuning which components users can add if they customize Setup.

Optimize for Web download
Setup can detect whether the same version of a component is already installed on your user's computer. If a version of the same component is already installed, and it will work with Internet Explorer 5, then Setup will not download it. This can save download time.

Prevent users from customizing Setup for specific components
If your users can customize their installations, but you don't want them to customize specific components, clear the check boxes for the components that you do not want users to be able to customize. Force Install will appear in the right column beside the components that will automatically be installed with the browser.


Components on Media

The components in this list have been downloaded to your computer but have not been included in a Setup option. The components you select can be made available for installation if users attempt to use a feature that requires these components; this feature is called Automatic Install.


Digital Signatures

If you have a publisher certificate from a certification authority or from Microsoft Certificate Server, you can sign your custom package in this step of the wizard. For more information about certificates, see Signing Your Programs.

To prepare certificates for use by the IEAK, you can import them onto your computer by using the Certificate Manager Import wizard. If you have received a file with an .spc extension, you can start the Certificate Manager Import wizard by double-clicking the .spc file in Windows Explorer or My Computer.

You can also open the Certificate Manager from Internet Explorer. To do this, click the Tools menu, click Internet Options, click the Content tab, and then click Certificates. Click Import to start the Certificate Manager Import wizard, and then follow the steps in the wizard.

Company name on certificate
If a publisher certificate is on your computer, its company name appears in this list.

Software publishing certificates (.spc) file
Type the name of the .spc file associated with the certificate, or click Browse to locate it.

Private key (.pvk) file
Type the name of the .pvk file associated with the certificate, or click Browse to locate it

Description text
Type the text that will appear in the dialog box that is displayed when users download programs that are signed with this certificate.

More information URL
Type the URL that will appear in this dialog box that users can click to obtain more information about the certificate and your company.


Customize the CD Autorun Screen

If you are creating a CD-ROM version of your customized browser, you can create an Autorun screen that is displayed when the user inserts the compact disc into the drive.

If you include an Autorun screen, you can provide a background bitmap and labels for two buttons: one for installing Internet Explorer and one for displaying more information. You can also customize the title bar and the text color.

Title bar text
This text appears in the title bar of the Autorun screen.

Custom background bitmap location
You can provide a bitmap that appears behind the text. Make sure the background color doesn't conflict with the text color.

Standard text color
This setting determines the color of any text that isn't part of a link.

Highlight text color
This setting determines the color of the links on the page.

Button style
You can determine the appearance of the buttons that users click to install Internet Explorer and to get more information.

  • Standard beveled buttons are similar to the ones that appear in standard software programs.
  • 3-D bitmap buttons have a three-dimensional appearance.
  • A custom button bitmap is based on a bitmap that you supply. To locate the path for the image, click Browse.

    The image should be a 256-color bitmap that is 540 pixels by 357 pixels. For more information about creating this graphic, see Create a Bitmap for the Autorun Splash Screen. For more information about all the graphics, see Creating Customized Graphics.


More CD Options

You can further customize the CD installation by adding an informational file, sometimes known as a "readme" file, and having a special Web page appear after installation.

More information text file
Specify the path and file name of the file that you want users to see after installation. By default, the CD Autorun screen provides a link to this file. If you change the name of this file, you'll need to update the path in the Autorun screen.

Use kiosk mode start page
Specify the path and file name of the .htm file that you want to appear after the user has installed Internet Explorer. This page will appear in kiosk (full-screen) mode, in which the browser toolbar and menu bar aren't displayed. You should place any graphics associated with this page in the same location as the .htm file.


Stage 3 Overview: Customizing Setup

In this stage of the Internet Explorer Customization wizard, you will specify how you will customize Setup.

The options that are available will depend on whether you are a:

  • Corporate administrator
  • Internet service provider
  • Internet content provider


Browser Title

You can customize the text that appears in the title bar of the Internet Explorer Web browser and Outlook Express, if you include Outlook Express in your package. Type the text that you want to appear. It will be added after the text "Microsoft Internet Explorer Provided by" or "Outlook Express Provided by."

Customize title bars
To customize the title bars, select the Customize Title Bars check box, and then type the text you want in the Title bar text box.

Toolbar background bitmap
You can specify a custom toolbar bitmap. This bitmap is displayed as a backdrop behind the buttons and drop-down menus. The background should be the size of the toolbar and light enough to show black text.

For more information, see Creating Customized Graphics.


Browser Toolbar Buttons

You can customize the toolbar buttons in the user's browser. You can specify the script or program that the buttons launch, as well as their appearance. For more information about designing custom programs, see Microsoft Site Builder Network Workshop. For more information about designing toolbar icons, see Designing Toolbar Icons for Internet Explorer 5.

Delete existing toolbar buttons, if present
To delete the existing toolbar buttons in the user's browser, select this check box.

Add
You can add custom toolbars that run scripts or executable files. When you click Add, you will be prompted for more information, such as the icon, caption, and action for the button to perform.

Toolbar caption (required)
You must specify a caption, or label, that will appear underneath the button when the user displays both the text and the icon on toolbar buttons. The maximum recommended size is 10 characters.

Toolbar Action, as script file or executable (required)
You must specify the script or executable file that will run when the user clicks the toolbar button.

Toolbar color icon (required)
You must specify a color icon that will appear on the toolbar buttons. The icon consists of 20-pixel-by-20-pixel images for active and inactive states. For more information, see the Microsoft Site Builder Network Workshop.

Toolbar grayscale icon (required)
You can specify a grayscale icon for the toolbar that will display on black-and-white monitors.

This button should be shown on the toolbar by default
Select this check box to enable the toolbar button you've specified to be shown in the user's browser by default.


Internet Explorer Logo

The Internet Explorer logo in the upper right corner of the browser appears in two states: animated when the browser is in use, and static when no action is taking place. You can replace the logo bitmap with your own animated or static bitmap.

Customize the animated logos

If you use an animated bitmap, the first frame appears as static when no action is taking place in the browser; the remaining frames appear as animated when the browser is in use.

To use your own animated logo, you must provide two animated bitmaps; one should be 22-by-22 pixels and the other 38-by-38 pixels.

Type the paths of the small and large custom animated bitmaps in the boxes provided. Sample animated bitmaps are available in the IEAK Toolkit, which was installed in the \Ieak\Toolkit folder on your hard disk when you installed the IEAK.

Customize the static logos

If you use a static bitmap, it will appear as static whether or not any action is taking place in the browser. To use your own static logo, you must provide two bitmaps; one should be 22-by-22 pixels and the other 38-by-38 pixels.

Type the paths of the small and large custom static bitmaps in the boxes in this panel.

Notes

  • Two tools are included with the IEAK to help you create customized animated bitmaps for your browser. One tool is used to stack bitmaps in the format described above, while the other tool previews the animation. For information about how to use these tools, see Animated Bitmap Tools.
  • For more information about all the graphics you can customize in the IEAK, see Creating Customized Graphics.


Important URLs

You can specify the URLs for the home, search, and online support pages.

Home page URL
The home page, sometimes known as a start page, appears when the user clicks the Home button. Internet Explorer can show a default home page, or you can specify a URL for your own page.

Type the URL for the home page that you want to use in the Home page URL box. If you want to use the Internet Explorer default home page, click Use Default.

Search bar URL
The Search bar appears in the Explorer bar on the left side of the screen. This bar enables a user to see the search query and search results at the same time. The Search bar comes with a choice of search engines. You can change the URL for this page if you want; for more information, see Customizing the Search Assistant.

If you want to use the Internet Explorer default Search bar, click Use Default.

Online support page URL
In Internet Explorer, support information is available by clicking Help, and then clicking Online Support. It's recommended that you develop a support page and make it available to your users.

Type the URL of your custom support page in the Online support page URL box. If you want to use the Internet Explorer default support page, click Use Default.


Favorites and Links

You can customize the Favorites folder and Links bar by adding links to sites related to your company or services. For example, if you're an ICP specializing in entertainment, you can provide links for entertainment-related sites.

The Links bar appears by default at the top of the user's screen, and it comes with a set of default links. You can add links to the default folders or add new folders. When a user clicks Favorites, the Favorites list appears on the left side of the window.

Place Favorites at top of list
Select this check box to specify that the Favorites you choose are moved to the top of the users' Favorites list, so they are easier for the user to find.

Delete existing Favorites and Links, if present (corporate administrators only)
Select this check box to delete the items on the users' Favorites and Links lists. It is recommended that you use this setting with caution, because it removes the links and favorites that the users have set up.

To add a folder to the Favorites list or Links bar

  1. Click Favorites, Links, or a folder within Favorites or Links, and then click Add Folder.
  2. Type the name of your folder in the Name box. This can be a friendly name that helps the user recognize what types of links are in the folder.

Notes

  • You can import a folder containing links by clicking Import, or you can click an existing folder to create a new subfolder.
  • Semicolons and slashes are not allowed in the titles.

To add a Web page to the Favorites list or Links bar

  1. Click Favorites, Links, or a folder within Favorites or Links, and then click Add URL.
  2. Type a name for this Web page in the Name box. This can be a friendly name that helps the user recognize what the link refers to.
  3. Type the path of your link in the URL box.
  4. To specify a 16-pixel-by-16-pixel custom icon, type the name of the file in the Icon box.
  5. To make this page available to users when they aren't connected to the Internet, select the Make available offline check box. This option is often helpful for users with laptop computers.

Notes

  • To test a link, click the URL in the list, and then click Test URL.
  • You can add up to 200 links to the Favorites folder.
  • To remove an item from the Favorites list or Links bar, right-click the item, and then click Delete.


Welcome Page

Internet Explorer displays a welcome page when the browser is first started. You can display the default Internet Explorer welcome page, or you can specify your own custom welcome page. The welcome page can be different than the home page, which is the page that opens when the user starts the browser after the first time or clicks the Home button.

Display default Microsoft Internet Explorer 5 welcome page
Select this option to display the default Internet Explorer welcome page.

Do not display a welcome page
Select this option if you don't want to display a welcome page. The first page that is displayed is the user's home page.

Use a custom welcome page
Select this option if you want to use a custom welcome page, and then type the URL in the box below.


Channels

You can add a custom channel or channel category (folder), or import the channel settings from your computer. When you import channels, you can further customize them; for example, you could import your channel settings but delete one of the channels you import.

To add channels, you should already have information about your channel or channel category, such as the path to the images and the titles you want to use. You should also have a Channel Definition Format (.cdf) file for each channel.

If your custom Internet Explorer 5 package might be installed on a computer on which Internet Explorer 4 has never been installed, and you want your users to be able to use channels, you should add the Offline Browsing Pack to your installation. This feature is part of Internet Explorer 4, but it is a separate component of Internet Explorer 5.

To guarantee that channels will work, you must make sure that the Offline Browsing Pack is included in your installation. If you let users customize their setup choices, you need to specify that this option won't appear as a custom installation choice. To do this, on the Advanced Installation Options wizard page, clear the Offline Browsing check box; Force Install will appear in the right-hand column.

When you create channels that will be viewed by Windows 3.1 and UNIX users, you should make sure that the channels will be displayed correctly on those platforms.

Delete existing channels, if present
If you are a corporate administrator, you can delete existing channels on the user's computer by selecting this check box.

Turn on Desktop Channel bar by default
If you are a corporate administrator, and you are setting up the Windows Desktop Update or installing Internet Explorer 5 on Windows 98 computers, you can set up the Channel bar on the user's desktop by default.

Add a channel

To add a channel, click Add channel, and then specify the following information:

Channel Title (required
Specify the title of your channel. This will appear in the user's Favorites list.

Channel Definition File on Web Server URL (required)
Type the URL of the .cdf file for this channel. The .cdf file provides information about when and how to update your content.

Channel Definition File Path
Type the path (on your hard drive or network) where the .cdf file is now located, or click Browse to locate it.

Narrow Channel Image Path
Type the path for the narrow channel image, or click Browse to locate it.

Channel Icon Path
Type the path for the channel icon, or click Browse to locate it.

Make available offline Select this check box to make the channel available offline. When content is made available offline, users can read it when their computer is not connected to the Internet. For example, they can view content on their laptop computer when they don't have a network or Internet connection.

Notes

  • When you specify a .cdf file for a custom channel, make sure that the .cdf file does not contain the LOGO tag with the IMAGE or ICON parameter.
  • If you are adding a channel within a channel category, use the following syntax: <category name>\<channel name> -
    for example, My Category\My Channel.

Add a channel category (a folder of channels)

To add a channel category, click Add Category, and then specify the following information:

Category Title
Type the title of the channel category.

Category HTML Page
Type the URL for the HTML page of your category.

Narrow Category Image Path
Type the path to your narrow category image. For more information, see Creating Customized Graphics.

Category Icon Path
Type the path to the icon that will be displayed for your category.

Edit a channel

To edit a channel or channel category that you've added or imported, click Edit. The dialog box with the image and path settings will be displayed.

Remove a channel

To remove a channel or category that you've added or imported, select the item, and then click Remove.

Import channels

To import the channel settings from your computer, click Import. If you want to change your channel settings before importing them, you do not need to close the wizard. Just switch to your browser, change your channel settings, and then switch back to the wizard.


Active Desktop

The Active Desktop enables users to put Web content, such as weather maps that update on a regular schedule, on their desktops. You can import the settings on your desktop as the corporate standard, so that all users have the same desktop. In the next stage of the wizard, you can determine whether users can change these settings.

You must include the Windows Desktop Update in your browser package, and be running the desktop on your build computer, to import your Active Desktop settings.

To use your current settings as the standard desktop for your company, click Import the current Active Desktop components. To modify your current settings so you can import them, click Modify Settings. If you don't want to customize users' desktops, click Do not customize the Active Desktop.


Desktop Toolbars

With the new desktop, users can add toolbars to your Windows taskbar, making it easier to get to programs, files, folders, subscriptions, and favorite Web pages. You can also position toolbars on any part of your desktop and resize them.

You must include the Windows Desktop Update in your browser package, and be running the desktop on your build computer, to specify desktop toolbars.

You can import your current settings by clicking Import the current Desktop Toolbar settings. If you want users to have the default toolbar settings, click Do not customize Desktop Toolbars.

These four toolbars can be added where you want them:

  • The Quick Launch toolbar provides shortcuts to several often-used features of Internet Explorer 5: the desktop, the Web browser, Outlook Express, and channels.
  • The Address toolbar enables you to type an Internet address (URL) without first opening the Internet Explorer browser.
  • The Links toolbar provides shortcuts to important Web sites (for example, www.microsoft.com) so that you can open them without first opening the browser.
  • The Desktop toolbar contains all of the shortcuts on your desktop and organizes them in one convenient location.

In addition to the ready-made toolbars, you can create a toolbar from the contents of any folder. For example, you could create a Control Panel toolbar or a toolbar that displays icons for each of your monthly sales reports.

To create a new toolbar

  1. Right-click the taskbar, point to Toolbars, and then click New Toolbar.
  2. Type the path to the folder or the address of the Internet site that you want to appear as a toolbar, or select it from the list.

Tips

  • To move a toolbar to the desktop, drag it into the position you want, and then size it to your needs.
  • For a handy toolbar containing your favorite shortcuts, create a folder on your hard disk and put the shortcuts you want in it. Then make the folder into a toolbar.


Folder Webviews

You can customize how My Computer and Control Panel appear on your company's computers by customizing the files that serve as templates for them. Then if the user installs the Windows Desktop Update, My Computer and Control Panel can appear as Web pages. One reason to customize these folders is to provide instructions, a company logo, or links to support or corporate sites.

You must include the Windows Desktop Update in your browser package, and be running the desktop on your build computer, to specify Folder Webviews.

To do this, you would use the following template files:

  • Mycomp.htt for My Computer
  • Controlp.htt for Control Panel

If you have installed the Windows Desktop Update on your computer, these files are located in the C:\Windows\Web or C:\Windows\NT folder. You can open them using a text editor, such as Notepad or an HTML editor. It's recommended that you make a back-up copy of these files before working with them, so you can restore them to their original state if needed.

There are several ways you can modify these files to suit your company's needs. You can add your own links or graphics, change colors, and even determine which contents (icons and file names) are displayed. For example, you could choose not to display the icons in Control Panel, but provide graphical buttons the user could click for only those settings you choose to make available.

These files use active scripting, such as JavaScript, JScript, or Visual Basic Scripting Edition (VB Script). The existing Mycomp.htt and Controlp.htt files, and other files related to the desktop (Folder.htt and Printers.htt), use JavaScript. You can modify some aspects of these files without scripting, or if you're familiar with scripting, you can add to or change the scripting to meet your needs.

These template files are very similar to .htm files, except for three variables: %THISDIRNAME%, %THISDIRPATH%, and %TEMPLATEDIR%, which are processed through a MIME filter and replaced with the correct file or path information. These variables are useful when you specify links to external files, such as graphics. Although these template files are located in the C:\Windows\Web or C:\Windows\NT folder, they are processed in the \Temp folder, so the path information is necessary to ensure that links to other items work.

An important issue is to ensure that the customized versions of My Computer and Control Panel resize the display in accordance with your users' screen resolutions, and that they appear correctly. In the Mycomp.htt and Controlp.htt files, the following syntax is used to ensure proper resizing:

<script language="JavaScript">
  window.onresize = fixSize;
</script>

These files use the FileList object to represent the contents (icons and file names) of My Computer and Control Panel. In My Computer, a pie chart showing the amount of free space available is represented by the PieChart object. These objects are optional.

For more information about scripting, see the Microsoft Site Builder Network Workshop.

In My Computer and Control Panel, Infotips from the registry are displayed when the user points to the item. The Infotips provide a brief description of the item.

You can also modify the Printers.htt (Printers) and Folder.htt (default Web view for folders) template files in the C:\Windows\Web or C:\Windows\NT folder on your computer or on your users' computers. These file cannot be included in your customized IEAK package.

If you want, you can provide an HTML file instead of modifying the *.htt files. To do this, you need to change the associated PersistMoniker references in the registry to PersistFile, and point the references to your customized file.

Note

  • Editing the registry can cause harm to an operating system, and should be performed at your own risk.


Custom Desktop Component

You can add one custom Active Desktop component to users' desktops. This component can be a channel (.cdf file), a Web page (HTML file), or a picture in .gif or .bmp format.

You must include the Windows Desktop Update in your browser package, and be running the desktop on your build computer, to specify a custom desktop component.

Desktop component URL or file path
Specify the file and the path to the file. Click Browse to locate the file. If you refer to other files from this component, such as .gif files or another Web page, make sure they are located in the same folder as the component.


User Agent String

Some companies track site statistics, such as how many times their content is accessed and by which types of Web browsers. User agent strings help identify the browser type.

Custom string to be appended to user agent string
The string you type in this box is appended to the user agent string for the customized browser. You do not need to customize the user agent string unless you want to track the usage of your custom browser and you gather browser statistics from other Internet sites. Be aware that other companies that track site statistics will see the customized string.


Automatic Configuration

You can assign URLs to files that will automatically configure the customized browsers. This feature is helpful if you want to control the settings of several users from one central location.

You can configure options by using .ins files, also known as IEAK profiles. Using .ins files, you can include standard proxy settings. For 32-bit and 16-bit versions of the browser, you can also specify script files in .js, .jvs, or .pac format that enable you to configure and maintain advanced proxy settings.

Network servers using Domain Name System (DNS) and Dynamic Host Configuration Protocol (DHCP) can automatically detect and configure a browser's settings when the user first starts the browser on a network. For more information, see Automatic Detection and Configuration of Browser Settings.

If you specify URLs for both automatic configuration and automatic proxy (auto-proxy), the auto-proxy URL will be incorporated into the .ins file. The correct form for the URL is http://share/test.ins.

To enable automatic configuration, select the Enable Automatic Configuration check box. Type the URL for the .ins file you want in the Auto-config URL (.ins file) box. Type the URL for the autoproxy script in the Auto-proxy URL (.js, .jvs, or .pac file) box.

For more information about auto-proxy files, see JavaScript or JScript Auto-Proxy Example Files. For more information about proxy selection and bypass, see Using Proxy Selection and Proxy Bypass Lists.

To automatically detect browser settings, select the Automatically detect settings check box.

Automatically configure every xx minutes
You can specify the interval in minutes for the automatic configuration feature. If you enter zero, or don't enter a value, automatic configuration happens only when the user's computer is restarted.


Connection Settings

You can preset connection settings for your users by importing the connection settings from your computer.

To see which settings you'll import, click the Tools menu in the browser, click Internet Options, and then click the Connections tab. Click Settings to view dial-up settings, and LAN Settings to view network settings. The address for automatic configuration is not imported, however.

If you do not want to preset your users' settings, click Do not customize connection settings.

To import the settings on your computer, click Import the current connection settings. If the settings displayed are not the settings you want to use, you can change them here.

If you are a corporate administrator, you can clear the existing settings on your users' computers by clicking Delete existing connection settings, if present.


Proxy Settings

You can specify which proxy servers your users connect to. A proxy server acts as a security barrier between your internal network (intranet) and the Internet, keeping other people on the Internet from gaining access to confidential information on your internal network.

If you want to use proxy servers for any of the listed services, select Enable proxy settings.

Type the address of the proxy server to the right of any of the listed services. Type the port number, which in many cases is 80, in the appropriate boxes under Port number.

To use the same settings for all services, select Use the same proxy server for all addresses.

In certain cases, you may not want to use a proxy server, such as for addresses on your corporate intranet. You can enter specific addresses in the box under Do not use proxy server for addresses beginning with. Use a semicolon to separate entries. To bypass proxy servers for all addresses on your intranet, select the Do not use proxy server for local (intranet) addresses check box.


Add a Root Certificate

You can add a root certificate to your customized IEAK package by typing the URL into the New root certificate path box. This provides a level of trust that certificates lower in the hierarchy can inherit. Each certificate is inspected for a parent certificate until it reaches the root certificate.


Sign-up Method

If you are an ISP, you can specify how users sign up with your service and connect to the Internet.

Server-based sign-up using the Internet Connection wizard (recommended)
The Internet sign-up server method provides full flexibility and dynamically adapts to various sign-up options. You create server solutions that exchange information with the screens of the Internet Connection wizard. For more information, see Internet Sign-up for the Internet Connection Wizard.

Server-based sign-up using full-screen kiosk mode
The Internet sign-up server method provides full flexibility and dynamically adapts to various sign-up options. You create server solutions that exchange information with the browser in kiosk mode, without toolbar buttons showing. For more information, see Setting Up a Sign-up Server for Full-Screen Kiosk Mode.

Serverless sign-up
The serverless sign-up method doesn't require a sign-up server. If you select the serverless method, the Internet Explorer Customization wizard prompts you to provide the necessary information to control the sign-up process. If you choose this option, you'll be prompted for dialing, gateway, and password information. You can also test your sign-up page from the Customization wizard. You cannot use the serverless sign-up method to customize the Internet Connection wizard.

No sign-up

Specify this method if you don't want users to go through a sign-up procedure when they install their custom browser. This option may be helpful when cable modems are used.

Note

  • Even if you specified earlier in this wizard that you want to build on a single floppy disk, this option is not available when you use the no-sign-up method. The single floppy-disk build will not be created.


Sign-up Files

To enable users to configure their computers to connect to your servers, you must create custom sign-up files. For more information, see Setting Up a Sign-up Server for Full-Screen Kiosk Mode and Internet Sign-up with the Internet Connection Wizard.

Specify custom sign-up files

The first of the files must be an HTML page that contains information about your service. For Internet sign-up in kiosk-mode, it must be named Signup.htm, and it must include a link to an appropriate HTML page on your sign-up server. For Internet sign-up with the ICW, it must be named Icwsign.htm

The Sign-up Files screen shows the working directory for the sign-up files. If you have already modified your sign-up files, then click Copy Files to copy them to this working directory. If you want to verify or specify settings in .isp files and .ins files by using wizard screens that will appear later in Stage 4 of the wizard, select the Verify/Modify the .isp file entries or the Verify/Modify the .ins file entries check boxes.

All sign-up files, including graphic files, must be saved in the same folder. You must have full read-write access to this folder, because the wizard needs to change the attributes of all files to read-write.

Type the path of the folder that contains your sign-up files, or click Browse to locate the folder.


Sign-up Server Information and Internet Settings Files

The Sign-up Server Information screen is for configuring your users' dial-up connections so they can make a connection to your Internet server.

The Internet Settings Files screen is for providing settings that the Customization wizard will use to generate an .ins file. The .ins file can be posted on your server or incorporated into the custom package you are creating for serverless sign-up.

Connection name
Type the name of your sign-up server. This can be a friendly name.

File name
Enter the file name for your file. For Sign-up parameters, the file should have an .isp extension; for Internet Settings, the file should have an .ins extension.

Connection Properties
Enter your area code, phone number, country code, and country ID.

Advanced Options
To set the following dialing and gateway settings, click Options.

Use static DNS address
The Domain Name System (DNS) is a set of protocols and services for Transmission Control Protocol/Internet Protocol (TCP/IP) networks. DNS enables you to use "friendly names," such as www.microsoft.com, instead of numeric addresses. To ensure that all DNS servers will be searched in an attempt to map name and IP addresses, select this check box and manually enter a primary and alternate address.

Dial number as shown
Prevents a default area code from being set. You might want to set this flag if, for example, some users might be calling from an area code different from the default. If users aren't aware that the default area code differs from their current area code, they could unexpectedly incur long-distance charges.

Encrypt passwords
Specifies that only encrypted passwords can be sent to, or accepted by, your computer. This is useful if you need additional security for this connection. The computer you are connecting to must support encrypted passwords for this option to take effect.

Use software compression
Specifies whether incoming or outgoing information is compressed before it is sent. This is useful to speed up the transfer of information. Compression occurs only if both computers are using compatible compression.

Use IP header compression
TCP/IP header compression is designed to improve the efficiency of bandwidth use over low-speed serial links. It typically optimizes data transfer between computers.

By reconstructing a smaller header that identifies the connection and indicates the fields that changed, fewer bytes can be transmitted. For compression to work, packets must arrive in order. Compression may not always be desirable. For example, if you are using older equipment, you may not be able to use compression. For the sake of interoperability, serial line IP drivers that allow header compression should include some sort of user-configurable flag to disable compression.

Use default remote gateway
Specifies whether Internet Protocol (IP) traffic is routed to the wide area network (WAN) connection by default. A gateway is a connection or interchange point that connects two networks that otherwise would be incompatible.

Apply all branding information to this file
Select this check box if you want to apply all the customized branding information that you've specified in the Customization wizard to this sign-up file.

Branding cabinet (.cab) file name
Enter a name for your branding cabinet file. Be careful when specifying a file name so that you don't overwrite any existing files.

URL to the branding cabinet (.cab) file
Enter the URL where your branding cabinet (.cab) file will be, or is, posted.

Note

  • You can also prevent a default area code from being set by setting a flag in the .isp file. The syntax for this flag is:
    Dial_As_Is=Yes


Internet Connection Wizard

You can specify the Internet Connection wizard (ICW) as the tool that customers use to sign up for Internet services. You can create server solutions that exchange information with the screens of the ICW. This feature is not available for the serverless sign-up method.

Title bar text
Select this check box to specify that customers use the Internet Connection wizard to sign up for your services.

Left image
Type the path to the 164-pixel by 458-pixel .bmp file that appears on the left side of the Internet Connection wizard screen.

Top image
Type the path to the 49-pixel by 49-pixel .bmp file that appears at the upper-right corner of the Internet Connection wizard screen.

Note

  • You will need to include the Dynamic HTML Data Binding component with your browser package to ensure that the Internet Connection wizard can interact with your server. Data binding allows the wizard page to display the list of ISP files in Signup.txt. You can specify that this option won't appear as a custom installation choice, which users can choose not to install. To do this, on the Advanced Installation Options wizard page, clear the Dynamic HTML Data Binding check box; Force Install will appear in the right-hand column.


Security

You can use certification authorities and Authenticode™ to help manage security.

You can use certification authorities to control the sites where users can download certain content, such as ActiveX controls and Java applets. Site authorities are a form of digital certificate for an Internet site. Using Authenticode technology, they show where programs come from and verify that they haven't been altered.

For Windows 3.x, you can import and install up to 20 certification authorities. If you have more than 20 certification authorities on your computer, you'll need to identify the 20 certificates you plan to install, and then delete the rest while you prepare the IEAK build.

You can import these settings from your computer. If you want to modify the settings that you will apply to your users' computers, click Import current certification authorities, and then click Modify Settings.

You can then use Certificate Manager to view and manage your certification authorities information. Certificates can apply to network server authentication, network client authentication, secure e-mail authentication, and software publishing.

You can use Authenticode to designate software publishers and credentials agencies as trustworthy. You can also import these settings from your computer. If you want to modify the settings that you will apply to your users' computers, click Import current Authenticode security information, and then click Modify Settings.


Security Settings

You can manage security zones and content ratings for your company. You can customize the settings for each security zone. Through content ratings, you can prevent users from viewing content that may be considered offensive.

Security zones

If you want to modify the settings that will be installed on your users' computers, click Import the current security zone settings, and then click Modify Settings. In Stage 5, you can also specify whether users will be able to change their security settings.

Note that the following settings or sections do not apply to UNIX and 16-bit versions of the browser:

  • UNIX versions of the browser
    ActiveX controls and plugins
    Font download
    Software channel permissions
    Launching applications and files
    Installation of desktop items
  • 16-bit versions of the browser
    User authentication
    Font download
    Software channel permissions
    Installation of desktop items
    Active scripting
    Launching applications and files from an IFrame

Content ratings

Microsoft Internet Explorer provides a way to help you control the types of content that your computer can access on the Internet. You can adjust the settings to reflect what you think is appropriate content in four areas: language, nudity, sex, and violence.

If you want to modify the ratings that you will apply to your users' computers, click Import the current content ratings settings, and then click Modify Settings. You can then modify your settings by using Content Advisor.

You should know that:

  • Content Advisor uses very cautious rating standards when you first enable it. You can adjust these settings to match your own preferences.
  • Not all Internet content is rated. If you choose to allow others to view unrated sites, some of those sites could contain inappropriate material.


Stage 4 Overview: Customizing the Browser

In this stage of the Internet Explorer Customization wizard, you can customize the appearance and behavior of Internet Explorer.

The options that are available will depend on whether you are a:

  • Corporate administrator
  • Internet service provider
  • Internet content provider

Note

  • The availability of some options, such as logo customization, also depends on your license agreement. For more information, consult your contract.


Programs

You can import your default program settings, such as which programs are the default for electronic mail and for editing HTML. These settings are located on the Programs tab of the Internet Options dialog box.

If you do not want to preset your user's settings, click Do not customize Program Settings. To import your settings without changing them, click Import the current Program Settings. To change your settings and then import them, click Import the current Program Settings, and then click Modify Settings.


Servers and Accounts

These settings are available because you downloaded Outlook Express. You can specify the mail and news servers here and specify whether you will require users to log on using Secure Password Authentication (SPA) to access a server.

Choose mail server type
Select the protocol that your mail servers are running. You can choose POP3, used by most Internet subscribers for e-mail, or IMAP, used mainly by corporate users who want to read their e-mail from a remote location. POP3 servers allow access to a single inbox, while IMAP servers provide access to multiple server-side folders.

Incoming mail server
Type the fully qualified server address in the text box (for example, pop01.microsoft.com). Then, click Log on using SPA (Secure Password Authentication) if your POP3 or IMAP server requires authentication via an SSPI provider such as NTLM.

Outgoing mail (SMTP) server
An SMTP server is the outgoing mail server. In some cases, the SMTP server may have the same name as your POP3 server (for example, smtp.microsoft.com). Type the fully qualified SMTP server address in the text box. Then, click Log on using SPA (Secure Password Authentication) if your SMTP server requires authentication via an SSPI provider such as NTLM.

Internet news server
The Network News Transfer Protocol (NNTP) is the protocol used to distribute network news messages to NNTP servers and to NNTP clients (news readers) on the Internet. Type the NNTP address in the text box (for example, nntp.microsoft.com). Then, click Log on using SPA (Secure Password Authentication) if your NNTP server requires authentication via an SSPI provider such as NTLM.

Accounts

You can use these options to lock down account settings for your users. When users set up their accounts, such as mail and news, those accounts will be configured using the restrictions you specify here.

Make all preconfigured accounts read-only
Select this option to create account settings that can be viewed, but not modified, by users.

Prevent deletion of all preconfigured accounts
Select this option to prevent users from deleting accounts that you have preconfigured for them.

Prevent configuration of additional accounts for users with preconfigured accounts
Select this option to prevent users from creating additional accounts in addition to the preconfigured accounts created for them. This option is recommended for corporate administrators only.


Outlook Express IMAP Settings

Use this screen to create default IMAP settings for your users. These settings are preconfigured for users when they create their IMAP accounts.

Root folder path
The root folder path is the mailbox that contains all of the users' folders on the IMAP server. For Cyrus servers, all users' folders must be contained in the Inbox folder. For UNIX-based IMAP servers, mail is usually stored in its own folder in the user's home folder (for example, ~username/Mail). Do not end the root folder path with a hierarchy character. For example, ~username/Mail is a valid root folder path, but ~username/Mail/ is not. Some IMAP servers, such as Microsoft Exchange Server, do not require a root folder path.

Store special folders on IMAP server
To specify that folders for the users' sent messages and in-progress messages should be created on the IMAP server, select Store special folders on IMAP server.

Sent items path
Type the path name for the Sent Items folder. This path will be used by all users who create IMAP accounts.

Drafts folder path
Type the path name for the Drafts folder. This path will be used by all users for whom you configure IMAP accounts.

Check for new messages in subscribed folders
To automatically poll all of an IMAP user's subscribed folders for changes in the number of messages when the user starts Outlook Express and at the user's regular mail polling interval, select Check for new messages. If this option is not selected, Outlook Express checks for new messages only in the Inbox.


UNIX Mappings

Use these settings to specify the options for associating extensions and MIME types with a program so that the appropriate program starts when a user clicks a link. To create a new association, click New. To remove an association, click Delete.

Associations
After you create an association, it appears on this list.

Description
Type the description that you want for this association.

Extensions
Type the extension you want to associate. You should include the period before the extension and a semicolon after the extension. You can include multiple extensions, providing you end each extension with a semicolon (for example, .asf;.asx;).

MIME Type
Type the MIME (Multipurpose Internet Mail Extensions) type to associate with this extension. A MIME type enables a browser to differentiate between different file types using a type designation rather than a file extension.

Command Line
Type the command line or program that you want to execute when a file is opened or a link of this type is clicked. If a script is placed into the <install_dir>/bin folder, you do not need to include path information. You should include the program name, followed by a space, and %1 (for example, netmeeting %1).


Outlook Express Custom Content

You can give Outlook Express a custom look and welcome new users with an e-mail message.

InfoPane

The Outlook Express InfoPane is an area for content providers to place helpful information and links. You can customize this pane with support numbers, frequently asked questions (FAQs), and information about your company.

The InfoPane appears as a 50-pixel high panel at the bottom of the Outlook Express main window. You can customize the InfoPane with an HTML file that is either a local file or an Internet address (URL). If you specify a local file, that file will be copied into your IEAK distribution package and subsequently copied onto the user's computer during installation.

Note

  • The InfoPane does not appear as part of the Outlook Express user interface unless a URL or file is specified in the IEAK.

URL
Type the URL of the HTML file you want to use for the InfoPane.

Local file
If you did not type a URL in the previous text box, you can type the path to the local HTML file you want to use for the InfoPane, or click Browse to locate the file. If you specify a local file, you can also specify an image to be copied.

Welcome message
You can also provide a welcome message as the first item in each user's Inbox. The welcome message is an HTML file. You must also provide the sender's friendly name (for example, your company or organization name) and the recipient's e-mail address.

Note

  • The IEAK does not provide a way to add an image to the Welcome message. However, if you edit the Welcome message outside of the IEAK, you can add a link to an image from the Web.
HTML path
Type the path of the HTML file you want to send, or click Browse to locate the file.

Sender
Type the name of the company or person sending the message (for example, Volcano Administration). This will appear on the From line of the message.

Reply-to
Type the e-mail address by which the user can reply to the message. Note that users can see this address in their welcome message, and they can reply to the welcome message.


Outlook Express Custom Settings

Use this screen to create settings that will apply to all of your users. These defaults include setting a default mail and news client. Also, you can provide information that users need to obtain additional e-mail accounts. Finally, you can provide a default message rules file for your users.

Default messaging programs
If you want Outlook Express to start whenever a user clicks an e-mail link in Internet Explorer, select the Make Outlook Express the default mail program check box. If you want Outlook Express to start whenever a user clicks a news link in Internet Explorer, select the Make Outlook Express the default news program check box. The default mail client setting is also used by many programs when a user sends documents by e-mail. Note that this replaces any current default mail client that the user has specified.

Newsgroups
Use this box to type the names of one or more newsgroups that you want your users to be subscribed to automatically. For example, your ISP or organization may have several newsgroups that provide assistance and information to users. You could use this feature to subscribe new users to these newsgroups.

New account source
You can add a menu item that users can use to get an additional mail account from your ISP. This entry is added to the New Account From menu in Outlook Express. Type the name of your ISP in the Service Name box (for example, Acme ISP). Then, type a URL in the Service URL box. When the user chooses this Service Name from the menu, the Web page is opened. An account number, which can be specified in the .ins file, and a unique identifier for the user will be sent to the ISP when the Web page is opened.

Junk mail filtering
Use this option to prevent junk mail messages or messages with adult content from filling up a user's Inbox. The messages that are detected are moved to the Junk Mail folder.


Outlook Express View Settings

You can customize certain views that determine whether specific elements of Outlook Express are displayed and how they are displayed.

Basic
You can use these settings to determine which elements of the Outlook Express interface are included in the default view for new users.

  • To include the Folder bar as a default for users, select the Folder bar check box.
  • To include a list of e-mail and news folders in the left column, select the Folder list check box.
  • To list the users' MSN Messenger Service contacts (if MSN Messenger Service is installed and configured) as well as addresses of e-mail correspondents, select the Contacts check box.
  • To display a tip every time Outlook Express is started, select the Tip of the Day check box.
  • To display the status bar, which appears at the bottom of the Outlook Express window, select Status Bar.
  • To display the Outlook Bar, a horizontal bar that displays certain folders, such as the Inbox, select Outlook Bar.

Toolbar
You can choose whether you want users to see the toolbar and whether you want to include text on it. The toolbar appears at the top of the Outlook Express window. It contains buttons that correspond to common commands and can be configured by the user.

Preview pane
You have the option of including a message preview pane for your users' default view of mail and news messages. The preview pane can either be a horizontal pane located below the list of messages or a vertical pane located beside and to the right of the list of messages. The preview pane includes a preview pane header area that can be used to display message header information, including the From, To, Cc, and Subject lines of the message.


UNIX Programs

These settings specify which programs will run when the user performs tasks related to electronic mail, newsgroups, or printing, or when the user views the HTML source of a page.

Mail
Type the name of the program to use as a default e-mail client, or select the Use Outlook Express as default e-mail client check box.

News
Type the name of the program to use for reading and posting (sending) newsgroup messages.

View Source
Type the name of the program to use when the user views the HTML source of Web pages.

Font folder
Type the name of the folder that contains additional font caches you would like to install with this browser package. For more details about the font cache, see the following two sections: "What are font caches?" and "Adding prebuilt font caches."

Printing
Type the name of the program to use for printing tasks.

What are font caches?

A font cache is a summary of the characteristics of the fonts that are available on a display. A font cache is used by Internet Explorer for UNIX to efficiently determine the best match for the fonts requested by each page of content. There is a different font cache for each combination of server release and font path. A number of prebuilt font caches are supplied with the product. They are installed into the <path>/Common/Fontcache folder and listed in the Readme file located there.

When Internet Explorer starts for the first time, the program checks the <path>/Common/Fontcache folder for the appropriate font cache file. If Internet Explorer is started with an X server or font path that is not represented in the pre-installed set, the program creates a new font cache for that configuration.

The first time the user runs Internet Explorer, the browser starts more slowly if a prebuilt font cache is not available. After Internet Explorer is started again with the same configuration, it uses the same font cache. To reduce initial startup time, you can create font caches in advance for your most common configurations, and add them to your custom package with the IEAK.

Adding prebuilt font caches

If you would like to add additional font caches to your browser package, carry out the following procedure:

  1. Install and run the browser using the configurations you want to create font caches for.
  2. For each configuration, identify the newest files in the <path>/Common/Fontcache folder. This is the font cache that was built automatically for your current configuration.
  3. Once you've created caches for your common configurations, move the caches to a place accessible from the Windows computer where you will be running the Internet Explorer Customization wizard.
  4. On the UNIX Programs screen in the Customization wizard, type the location of these font caches in the Font Directory box. These font caches will then be built into your custom package and installed in the <path>/Common/Fontcache folder at setup.

Note

  • To add font caches to your existing installations, you can copy them into the <path>/Common/Fontcache folders.


Outlook Express Compose Settings

Signatures
You can include a default signature, such as a corporate disclaimer, that will appear in Outlook Express newsgroup or e-mail messages. A disclaimer is often used to show that messages submitted by employees over the Internet do not represent official company policies. The maximum size of the signature is 1 KB.

You can append signatures only to newsgroup messages, only to e-mail messages, or to both types of messages.

HTML vs. plain text for mail and news messages
By default, e-mail messages are composed in HTML and news postings are composed in plain text. You can choose to override these settings. For example, in an environment where bandwidth is limited or many users have simple mail programs that cannot understand HTML, changing the default to plain text may make sense.

Likewise, in a corporate environment where all users use an HTML-aware newsreader, changing the news post default to HTML may be desirable.


Windows Address Book Directory Service

Directory services are powerful search tools that help your users find people and businesses around the world. The Windows Address Book supports LDAP (Lightweight Directory Access Protocol) for accessing directory services, and it comes with built-in access to several popular directory services. You can specify an additional service for your users.

Service Name
Type the friendly name of your LDAP service. This is the name that will be displayed to your users.

Server Name
Type the name of the directory service you want to add, such as ldap.AcmeISP.com or ldap.switchboard.com. If you require authentication via an SSPI package such as NTLM for users who access these services, click the Logon using SPA check box. Basic authentication using a user name and password combination can be configured via .ins files.

Service Web Site
This is the directory service's home page that appears if the user clicks the Start button, points to Find, clicks People, and then clicks Web Site.

Search base
Sometimes known as the root or scope, the Search Base is the hierarchical level at which to search a given LDAP server. The search base can be a country, organization, or other type of grouping. The Outlook Express default for search base when none is specified is "c=us." To specify no search base, type NULL.

Service bitmap
You can specify a custom 134-by-38 pixel, 16-color .bmp file. To ensure consistent color mapping, it is highly recommended that you use only the Windows 16-bit color palette when composing the bitmap. To locate the .bmp file on your computer, click Browse.

Search timeout
You can specify how long your users will wait before you time out a search request. Use the slider to set a time value between 30 seconds and 5 minutes.

Maximum number of matches to return
You can control the maximum number of results that can be returned to your users. Type the number in this box.

Name Resolution
To have Outlook Express resolve names against the server when a user sends a message, select Check names against this server when sending mail. This setting instructs Outlook Express to look up e-mail addresses for names typed on the To, Cc, and Bcc lines of a mail message.


System Policies and Restrictions

You can specify desktop, shell, and security settings across your organization.

Internet content providers, Internet service providers, and corporate administrators can specify default settings for their users.

Corporate administrators can customize and restrict numerous settings, ranging from whether users can delete printers to whether or not they can add items to their desktops.

For more information, see Understanding Settings and Restrictions.

You should understand the impact of the security settings on your users, especially if you have roaming users who share computers with other users. For more information, see the note below.

To set system policies and restrictions

  1. Double-click each category to display the options.
  2. Select or clear the check boxes you want.

Notes

  • The settings displayed in the wizard are contained in administration (.adm) files that come with the IEAK. If you are familiar with .adm files, you can use the wizard to set the policies and restrictions you have set up in your own .adm files by clicking Import.
  • If you remove the Run command from the Start menu setting for the Web Desktop, the initial start page (Start.htm) on a CD installation will not work properly.
  • To ensure that the Trusted Publishers setting for the Security section of Internet Restrictions is effective, you should verify that security zones and policies are correctly set up.

User settings can be stored in a central location and then follow users from computer to computer as they log on. This could be useful, for example, for a user who needs low security settings but who uses a computer that is typically operated by someone whose security settings are very restrictive.

Customizing security settings

You can allow three typical levels of customization for security settings:

  • Control, or "lock down," all settings.

    To lock down all settings

    1. Click Internet Restrictions, and then click Security.
    2. Select the Use only machine settings for security zones check box.
  • Control user settings while allowing profiles for roaming users to be downloaded.

    You can specify that settings can't be changed, without locking out roaming users who have different profiles. The Windows roaming user feature allows users to download their settings from a server.

    To restrict a user from changing policies for a zone

    1. Click Internet Restrictions, and then click Security.
    2. Select the Do not allow users to change policies for any security zone check box.

    To restrict a user from adding or deleting sites

    1. Click Internet Restrictions, and then click Security.
    2. Select the Do not allow users to add/delete sites from a security zone check box.
  • Customize initial settings, but allow user to modify them.

    In this stage of the wizard, you can customize many user settings, including security levels and ratings. Customizing the settings in this stage doesn't determine whether the user can control the settings.


Stage 5 Overview: Customize Components

In this stage of the Internet Explorer Customization wizard, you can customize components and specify Internet settings.

The options that are available will depend on whether you are a:

  • Corporate administrator
  • Internet service provider
  • Internet content provider